#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <string.h>

//smer: 0 >,1 <
//znak: 0 karo, 1 pik, 2 tref, 3 herc

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid,memid,memid2,memid3;
int *talon,*talonZn,*smer;

void sigh(int signal){
	printf("Brisem semafore i memoriju.\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
	shmdt(talon);
	shmdt(talonZn);
	shmdt(smer);
	shmctl(memid, IPC_RMID, NULL);
	shmctl(memid2, IPC_RMID, NULL);
	shmctl(memid3, IPC_RMID, NULL);
	exit(0);
}

int main(){
	srand(time(NULL));
	int skey,mkey,mkey2,mkey3;
	skey=ftok("igrac2.c",65);
	mkey=ftok("igrac2.c",66);
	mkey2=ftok("igrac2.c",67);
	mkey3=ftok("igrac2.c",68);
	union semun arg;
	//sigh(1);
	semid=semget(skey,4,0666|IPC_CREAT|IPC_EXCL);
	signal(SIGINT,sigh);
	if(semid!=-1){
		arg.val=1;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);
		semctl(semid,2,SETVAL,arg);
		semctl(semid,3,SETVAL,arg);
		memid = shmget(mkey,1,0666|IPC_CREAT|IPC_EXCL);
		memid2 = shmget(mkey2,1,0666|IPC_CREAT|IPC_EXCL);
		memid3 = shmget(mkey3,1,0666|IPC_CREAT|IPC_EXCL);
		talon=shmat(memid,NULL,0);
		talonZn=shmat(memid2,NULL,0);
		smer=shmat(memid3,NULL,0);

		*talon=rand()%14+1;
		*talonZn=rand()%4+1;
		*smer=0;
		printf("Igra zapoceta: talon:%d znak:%d\n",*talon,*talonZn);
	}else if(errno==EEXIST){
		//Vec postoji
		semid=semget(skey,4,0);
		memid=shmget(mkey,1,0);
		memid2=shmget(mkey2,1,0);
		memid3=shmget(mkey3,1,0);
		talon=shmat(memid,NULL,0);
		talonZn=shmat(memid2,NULL,0);
		smer=shmat(memid3,NULL,0);
		printf("Igra postoji: talon:%d znak:%d\n",*talon,*talonZn);
	}else{
		printf("Greska pri kreiranju semafora.\n");
	}

	struct sembuf P,V1,V2;

	P.sem_num=2;
	P.sem_op=-1;
	P.sem_flg=0;

	//smer 0
	V1.sem_num=3;
	V1.sem_op=1;
	V1.sem_flg=0;
	//smer 1
	V2.sem_num=1;
	V2.sem_op=1;
	V2.sem_flg=0;

	int karta,znak;
	while(1){
		semop(semid,&P,1);
		karta=rand()%14+1;
		znak=rand()%4+1;
		//Kretanje u jednom pravcu
		if(karta==*talon || znak==*talonZn){
			*talon=karta;
			*talonZn=znak;
			if(*talon==8) {
				if(*smer==0) *smer=1;
				else *smer=0;
			}
			printf("Igrac3: Odigrao kartu:%d znak:%d\n",*talon,*talonZn);
		}else printf("Nemam adekvatnu kartu (%d, %d).\n",karta,znak);

		if(*smer==0)
			semop(semid,&V1,1);//sledeci
		else 
			semop(semid,&V2,1);//prethodni

		sleep(1);
	}
}
