#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


int main(int argc ,char *argv[])
{
	
	key_t key;
	int semid,shmidk,shmidz,shmids;
	//shmidk za koriscenje id-ja za broj karte
	//shmidz za koriscenje id-ja za znak karte
	//shmids za koriscenje id-ja za smera igre
	int *dk,*dz,*ds;
	// dk za deljenu memoriju za broj karte
	// dz za deljenu memoriju za znak karte
	// ds za deljenu memoriju za smer igre
	
	struct sembuf P,V;
	
	
	//kreiranje semafora 
	key=ftok("./init.c",'A');
	printf("Kljuc za semafore je %d\n",key);
	semid=semget(key,4,0);
	printf("Id za semafore je %d\n",semid);
	
	
	
	//kreiranje deljene memorije
	//Za broj karte
	key=ftok("./init.c",'K');
	printf("Kljuc za memoriju za broj karte %d\n",key);
	shmidk=shmget(key,1*sizeof(int),IPC_CREAT | 0644);
	printf("Id za broj karte %d\n",shmidk);
	
	//Za znak karte
	key=ftok("./init.c",'Z');
	printf("Kljuc za memoriju za znak karte %d\n",key);
	shmidz=shmget(key,1*sizeof(int),IPC_CREAT | 0644);
	printf("Id za znak karte %d\n",shmidz);
	
	//Za smer kretanja igre
	key=ftok("./init.c",'S');
	printf("Kljuc za memoriju za smer igre %d\n",key);
	shmids=shmget(key,1*sizeof(int),IPC_CREAT | 0644);
	printf("Id za smer igre %d\n\n\n",shmids);
	
	//kacimo se na memoriju
	
	dk=shmat(shmidk,NULL,0); // za broj
	dz=shmat(shmidz,NULL,0); // za znak	
	ds=shmat(shmids,NULL,0); // za smer
	
	//normalna smer 1-2-3-4-1... oznacavamo sa 0
	//suprotan smer 1-4-3-2-1... oznacavamo sa 1
	// 0 je herc
	// 1 je tref
	// 2 je karo
	// 3 je pik
	int bk,zk;
	//broj i smer izvucene karte
	
	//treba mi opreacija smanjvanja mog semafora i uvecanja sledeceg semafora
	
	P.sem_num = 1;
	P.sem_op = -1;
	P.sem_flg = 0;
	int tb,tz;
	int br=0;
	while(1)
	{
		semop(semid,&P,1);
		br++;
		
		srand(time(NULL));
		
		//izvlacimo kartu
		bk=rand()%14;
		bk+=1;
		zk=rand()%4;
		
		//trenutno se nalazi
		tb=(*dk);
		tz=(*dz);

		if(tb == bk || tz == zk)
		{
					
			*dk=bk;
			*dz=zk;
			if(bk == 8 && (*ds) == 0)
			*ds=1;
			else if(bk == 8 && (*ds) == 1)
			*ds=0;
			
			
			
			printf("Prolaz %d : Imam adekvatnu kartu i to:\n",br);
			printf("Broj karte - %d\tZnak karte - %d\tSmer kretanja je - %d\n\n",*dk,*dz,*ds);
		}
		else
		{
			printf("Prolaz %d : Nemam adekvatnu kartu!!\n\n",br);
			//printf("Izvukao sam : Broj karte - %d\tZnak karte - %d\t\n\n",bk,zk);
		}
		sleep(3);
		
		//da odredimo koji je smer
		if((*ds) == 0)
		{
			//normalan smer
			V.sem_num = 2;
			V.sem_op = 1;
			V.sem_flg = 0;
		}
		else
		{
			//suprotan smer
			V.sem_num = 0;
			V.sem_op = 1;
			V.sem_flg = 0;
		}
		
		semop(semid,&V,1);
		
	}
	
	shmdt(dk);
	shmdt(ds);
	shmdt(dz);

}
