#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef union unija{
	int val;
	struct semid_ds *buf;
	ushort *array;
}semun;

int main(){
	
	srand(time(NULL));
	
	key_t kljuc;
	int semid, shmid, k, z;
	int *karta, *znak, *indikator;
	semun arg;
	struct sembuf smanji, povecaj1, povecaj2;
	
	kljuc = ftok("./igrac1.c", 'R');
	shmid = shmget(kljuc, 3*sizeof(int), 0644 | IPC_CREAT);
	
	kljuc = ftok("./igrac1.c", 'A');
	semid = semget(kljuc, 4, 0666 | IPC_CREAT | IPC_EXCL);
	
	karta = (int*)shmat(shmid,NULL,0);
	znak = ((int*)shmat(shmid,NULL,0)) + 1;
	indikator = ((int*)shmat(shmid,NULL,0)) + 2;
		
	if(semid != -1){
		arg.val = 0;
		semctl(semid, 0, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 1, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 2, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 3, SETVAL, arg);
	}
	else if(errno == EEXIST){
		semid = semget(kljuc,4,0);
	}
	else{
		printf("Greska!\n");
		exit(0);
	}
	
	smanji.sem_num = 2;
	smanji.sem_op = -1;
	smanji.sem_flg = 0;
	
	povecaj1.sem_num = 3;
	povecaj1.sem_op = 1;
	povecaj1.sem_flg = 0;
	
	povecaj2.sem_num = 1;
	povecaj2.sem_op = 1;
	povecaj2.sem_flg = 0;
	
	for(; ; ){		
		/*karta = rand()%14;
		if(karta==10){
			printf("Izvukao sam kartu broj 11, a to je 1\n");
		}
		else{
			printf("Izvukao sam kartu broj %d\n", karta+1);
		}
		semop(semid,&povecaj,1);
		sleep(3);
		semop(semid,&smanji,1);*/
		
		k = rand()%14;
		z = rand()%4;
		
		semop(semid,&smanji,1);
		
				printf("Izvukao sam kartu broj %d\n", k+1);
				if(z == 0){
				printf("Izvukao sam kartu znaka karo\n");
				}
				else if(z == 1){
					printf("Izvukao sam kartu znaka pik\n");
				}
				else if(z == 2){
					printf("Izvukao sam kartu znaka tref\n");
				}
				else{
					printf("Izvukao sam kartu znaka herc\n");
				}
				
				if(*indikator == 0)
				{
				if(k==*karta || z==*znak){
					*karta = k;
					*znak = z;
					printf("Poklopio sam\n");
					if(k==8){
						semop(semid,&povecaj2,1);
						*indikator = 1;
						sleep(3);
					}
					else{
						semop(semid,&povecaj1,1);
						//*indikator = 0;
						sleep(3);
					}
				}
				else{
					printf("Nisam poklopio\n");
					semop(semid,&povecaj1,1);
					//*indikator = 0;
					sleep(3);
				}
				}
				else{
					if(k==*karta || z==*znak){
					*karta = k;
					*znak = z;
					printf("Poklopio sam\n");
					if(k==8){
						semop(semid,&povecaj1,1);
						*indikator = 0;
						sleep(3);
					}
					else{
						semop(semid,&povecaj2,1);
						//*indikator = 0;
						sleep(3);
					}
				}
				else{
					printf("Nisam poklopio\n");
					semop(semid,&povecaj2,1);
					//*indikator = 0;
					sleep(3);
				}
				}	
		
		
	}
	
	
	
	return 0;

}
