#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

struct karta {
	int br; // 1-14
	int znak;
	int smer;
};

int main() {
	srand(time(NULL));
	
	key_t key;
	union semun arg;
	int shmid, semid;
	struct sembuf P, /*D, T, C, */talon;
	struct karta *pocetna;
	
	key = ftok("./Zadatak2_init.c", 'A');
	printf("Kljuc je %d\n", key);
	
	shmid = shmget(key, SHM_SIZE * sizeof(int), 0644 | IPC_CREAT);
	printf("ID segmenta je %d\n", shmid);
	
	pocetna = shmat(shmid, NULL, 0);
	
	key = ftok("./Zadatak2_init.c", 'B');
	printf("Kljuc semafora je %d\n", key);
	
	semid = semget(key, 5, 0644 | IPC_CREAT);
	printf("ID semafora je %d\n", semid);
	
	arg.val = 0;
	semctl(semid, 0, SETVAL, arg);
	semctl(semid, 1, SETVAL, arg);
	semctl(semid, 2, SETVAL, arg);
	semctl(semid, 3, SETVAL, arg);
	semctl(semid, 4, SETVAL, arg);
	
	// prvi igrac
	P.sem_num = 0;
	P.sem_op = 1;
	P.sem_flg = 0;
	/*
	// drugi igrac
	D.sem_num = 1;
	D.sem_op = 1;
	D.sem_flg = 0;
	
	// treci igrac
	T.sem_num = 2;
	T.sem_op = 1;
	T.sem_flg = 0;
	
	// cetvrti igrac
	C.sem_num = 3;
	C.sem_op = 1;
	C.sem_flg = 0;*/
	
	// init semafor
	talon.sem_num = 4;
	talon.sem_op = -1;
	talon.sem_flg = 0;
	
	pocetna->br = (rand() % 14) + 1;
	pocetna->znak = rand() % 4;
	pocetna->smer = 0;
	/*if(!id_znaka) pocetna->znak = "karo";
	else if(id_znaka == 1) pocetna->znak = "pik";
		 else if(id_znaka == 2) pocetna->znak = "tref";
			  else pocetna->znak = "herc";*/
	
	printf("Karta na pocetku igre je %d %d\n", pocetna->br, pocetna->znak);
	
	while(1) {
		semop(semid, &P, 1);
		semop(semid, &talon, 1);
		sleep(2);
	}
}
