#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef union Semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
}semun;

int main()
{
	key_t kljuc;
	int semid, shmid1, shmid2, shmid3, *data1, *data2, *ind, i;
	int broj, znak;// karta
	semun arg;
	struct sembuf povecaj1, povecaj2, smanji;
	
	srand(time(NULL));
	
	
	/*
	 * Pravim tri reda za deljenu memoriju jer kad napravim kao niz
	 * izbacuje mi neki segmentation i onda ne znam da resim drugacije.
	 * Nadam se da necete zbog ovoga da skidate poene ako radi ceo zadatak :).
	 * */
	kljuc=ftok("./igrac1.c", 'L');
	shmid1=shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	data1=shmat(shmid1, NULL, 0);
	
	kljuc=ftok("./igrac1.c", 'Z');
	shmid2=shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	data2=shmat(shmid2, NULL, 0);
	
	kljuc=ftok("./igrac1.c", 'R');
	shmid3=shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	ind=shmat(shmid3, NULL, 0);
	*ind=1;
	
	broj=rand()%14;
	znak=rand()%4;
	broj++;
	
	*data1=broj;
	*data2=znak;
	printf("Na pocetku karta je %d\t%d\n", broj, znak);
	if(*data1==8)
	{
		i=2;
		(*ind)=i;
	}
	
	kljuc=ftok("./igrac1.c", 'A');
	semid=semget(kljuc, 4, 0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{
		arg.val=1;
		semctl(semid, 0, SETVAL, arg);
		
		arg.val=0;
		semctl(semid, 1, SETVAL, arg);
		
		arg.val=0;
		semctl(semid, 2, SETVAL, arg);
		
		arg.val=0;
		semctl(semid, 3, SETVAL, arg);
		
	}
	else if (errno==EEXIST)
	{
		semid=semget(kljuc, 4, 0);
	}
	else
	{
		printf("Doslo je do greske\n");
		exit(0);
	}
	
	smanji.sem_num=0;
	smanji.sem_op=-1;
	smanji.sem_flg=0;
	
	povecaj1.sem_num=1;
	povecaj1.sem_op=1;
	povecaj1.sem_flg=0;
	
	povecaj2.sem_num=3;
	povecaj2.sem_op=1;
	povecaj2.sem_flg=0;
	
	while(1)
	{
		semop(semid, &smanji, 1);
		broj=rand()%14;
		broj++;
		znak=rand()%4;
		
		
		if(broj==(*data1) || znak==(*data2))
		{
			*data1=broj;
			*data2=znak;
			printf("Izbacio sam kartu %d-%d na talon\n", broj, znak);
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
		}
		
		
		
		if((*data1==8) && (znak==(*data2)) && ((*ind)==1))
		{
			i=2;
			(*ind)=i;
		}
			
		else if((broj==8) && (znak==(*data2)) && ((*ind)==2))
		{
			i=1;
			(*ind)=i;
		}
		
		
		
		sleep(rand()%10);
				
		
		
		if((*ind)==1)
			semop(semid, &povecaj1, 1);
			
		if((*ind)==2)
			semop(semid, &povecaj2, 1);
	}
	
	shmdt(data1);
	shmdt(data2);
	shmdt(ind);
	
	return 0;
}
