#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun 
{
	int val;
	struct semid_ds *buf; 
	ushort *array;
};

int main()
{
	srand(time(NULL));
	int i;
	int semid;
	union semun arg;
	key_t key;
	struct sembuf P,D,T,C;
	
	key=ftok("./Prvi.c",1);
	
	semid = semget(key, 4, 0666 | IPC_CREAT);
	
	arg.val = 0;
	semctl(semid, 0, SETVAL, arg);
	arg.val = 0;
	semctl(semid, 1, SETVAL, arg);
	arg.val = 0;
	semctl(semid, 2, SETVAL, arg);
	arg.val = 0;
	semctl(semid, 3, SETVAL, arg);
	
	P.sem_num = 0;
	P.sem_op = -18;
	P.sem_flg = 0;
	
	D.sem_num = 1;
	D.sem_op = 18;
	D.sem_flg = 0;
	
	T.sem_num = 2;
	T.sem_op = 1;
	T.sem_flg = 0;
	
	C.sem_num = 3;
	C.sem_op = 1;
	C.sem_flg = 0;
	

	for(i=0;i<6;i++)
		{
			sleep(2);
			semop(semid, &D, 1);
			semop(semid, &T, 1);
			semop(semid, &C, 1);
			printf("Dobio sam kartu %d\n",(rand()%14)+1);
			semop(semid, &P, 1);		
		}

	
}
