#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union unija{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{
	key_t kljuc;
	kljuc = ftok("./prvi.c",'A');
	
	int semid;
	semid = semget(kljuc, 4, 0666 | IPC_CREAT | IPC_EXCL);
	
	if(semid != -1)
	{
		union unija operacijeNadSem;
		
		operacijeNadSem.val = 1; //prvi igrac
		semctl(semid, 0, SETVAL, operacijeNadSem);
		
		operacijeNadSem.val = 0; //drugi igrac
		semctl(semid, 1, SETVAL, operacijeNadSem);
		
		operacijeNadSem.val = 0; //treci igrac
		semctl(semid, 2, SETVAL, operacijeNadSem);
		
		operacijeNadSem.val = 0; //cetvrti igrac
		semctl(semid, 3, SETVAL, operacijeNadSem);
		
	}
	else if(errno == EEXIST)
	{
		semid = semget(kljuc, 4, 0);
	}
	else
	{
		printf("Greska!\n");
		exit(0);
	}
	
	struct sembuf P,V;
	
	P.sem_num = 3;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	int ind;
	int i, j=15;
	int brojKarata = 0;
	
	srand(time(NULL));
	
	while(1)
	{
		ind = semop(semid, &P, 1);
		
		int karta = rand() % j;
		if(karta == 0)
			karta = 1;
		else
			karta = karta;
		printf("Igrac4: %d\n", karta);
		brojKarata++;
		//printf("Broj karata je %d\n", brojKarata);

		ind = semop(semid, &V, 1);
		sleep(10);
		
		if(brojKarata == 6)
			break;
	}
	
	return 0;
}
