#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024

union semun {
int val;
/* used for SETVAL only */
struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */
ushort *array;
/* used for GETALL and SETALL */
};

int semid, shmid;
int *karta, *igrac;

void izbrisi(int sig)
{
	printf("\nUHVATIO SIGNAL!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	
	shmdt(karta);
	shmctl(shmid, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	key_t kljuc;
	struct sembuf sem1, semDeljenaP, semDeljenaS;
	union semun operacija;
	int ind;
	srand(time(NULL));
	
	signal(SIGINT, izbrisi);
	
	kljuc = ftok("sever.c", 34);
	shmid = shmget(kljuc, SHM_SIZE*sizeof(int), IPC_CREAT|0666);
	karta = shmat(shmid, NULL, 0);
	
	kljuc=ftok("sever.c", 33);
	shmid = shmget(kljuc,1024*sizeof(int),0666|IPC_CREAT);
	igrac = shmat(shmid, NULL, 0);
	
	kljuc = ftok("server.c", 3);
	semid = semget(kljuc, 2, 0666|IPC_CREAT|IPC_EXCL);
	
	
	if(semid != -1)
	{
		printf("Kreiram \n");
		operacija.val = 1;
		semctl(semid,0,SETVAL, operacija);
		operacija.val = 0;
		semctl(semid,1,SETVAL, operacija);
		
	}
	else if(errno == EEXIST)
	{
		printf("Kacim se \n");
		semid = semget(kljuc, 2, 0);
	}
	else 
	{
		printf("Greska\n");
		exit(0);
	}
	
	semDeljenaP.sem_num = 0;
	semDeljenaP.sem_op = 1;
	semDeljenaP.sem_flg = 0;
	
	semDeljenaS.sem_num = 0;
	semDeljenaS.sem_op = -1;
	semDeljenaS.sem_flg = 0;
	
	sem1.sem_num = 1;
	sem1.sem_op = -1;
	sem1.sem_flg = 0;
	
	
	while(1)
	{
		ind = semop(semid, &sem1, 1);
		if(ind == -1)
			break;
		
		// PRISTUP MEMORIJI
		ind = semop(semid, &semDeljenaS, 1);
		if(ind == -1)
			break;
		
		karta[2] = rand() % 14 + 1;
		karta[3] = rand() % 4 + 1;
		
		printf("Karta je %d, %d\n", karta[2], karta[3]);
		
		ind = semop(semid, &semDeljenaP, 1);
		if(ind == -1)
			break;
		sleep(3);
		
	}
}








































