#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
int val;
/* used for SETVAL only */
struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */
ushort *array;
/* used for GETALL and SETALL */
};

int semid, shmid1, shmid2;
int *karta, *igrac;

void izbrisi(int sig)
{
	printf("\nUHVATIO SIGNAL!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	
	shmdt(karta);
	shmctl(shmid1, IPC_RMID, NULL);
	shmdt(igrac);
	shmctl(shmid2, IPC_RMID, NULL);
	
	exit(0);
}

int main()
{
	key_t kljuc;
	struct sembuf sem1, semDeljenaP, semDeljenaS;
	union semun operacija;
	int ind, i, bri=0, br=1;
	srand(time(NULL));
	
	signal(SIGINT, izbrisi);
	
	kljuc=ftok("sever.c", 34);
	shmid1 = shmget(kljuc,1024*sizeof(int),0666|IPC_CREAT);
	karta = shmat(shmid1, NULL, 0);
	
	kljuc=ftok("sever.c", 33);
	shmid2 = shmget(kljuc,1024*sizeof(int),0666|IPC_CREAT);
	igrac = shmat(shmid2, NULL, 0);
	
	kljuc = ftok("server.c", 3);
	semid = semget(kljuc, 2, 0666|IPC_CREAT|IPC_EXCL);
	
	karta[0] = rand() % 14 + 1;
	karta[1] = rand() % 4 + 1;
	
	if(semid != -1)
	{
		printf("Kreiram \n\n");
		operacija.val = 1;
		semctl(semid,0,SETVAL, operacija);
		operacija.val = 0;
		semctl(semid,1,SETVAL, operacija);
		
	}
	else if(errno == EEXIST)
	{
		printf("Kacim se \n\n");
		semid = semget(kljuc, 2, 0);
	}
	else 
	{
		printf("Greska\n");
		exit(0);
	}
	
	semDeljenaP.sem_num = 0;
	semDeljenaP.sem_op = 1;
	semDeljenaP.sem_flg = 0;
	
	semDeljenaS.sem_num = 0;
	semDeljenaS.sem_op = -1;
	semDeljenaS.sem_flg = 0;
	
	sem1.sem_num = 1;
	sem1.sem_op = 1;
	sem1.sem_flg = 0;

	printf("Karte server %d %d \n\n", karta[0], karta[1]);
	
	while(1)
	{
		for(i=0; i<4; i++)
		{
			ind = semop(semid, &sem1, 1);
			if(ind == -1)
				break;
			sleep(4);
			//rintf("Karte igraca  %d %d \n", karta[2], karta[3]);
			
			// PRISTUP MEMORIJI
			ind = semop(semid, &semDeljenaS, 1);
			if(ind == -1)
				break;
			
			igrac[bri*2] = karta[2];
			igrac[bri*2+1] = karta[3];
			
			if(karta[2] == 8)
			{
				br=br*(-1);
			}
			
			if(karta[2] == karta[0] || karta[3]==karta[1])
			{
				karta[0] = karta[2];
				karta[1] = karta[3];
			}
			
			else printf("Nemam adekvatnu kartu\n");
			
			ind = semop(semid, &semDeljenaP, 1);
			
			printf("br=%d\n", br);
			printf("Igrac %d ima karte %d %d\n", bri+1, igrac[bri*2], igrac[bri*2+1]);
			printf("---Talon %d %d--- \n\n", karta[0], karta[1]);
			if(ind == -1)
				break;
				
			if(br<0 && bri==0)
				bri=3;
			else
			{
				if(br>0 && bri==3)
					bri=0;
				else
				{
				bri+=br;
				}	
			}
			
			
			sleep(4);

		}
	}
}


