#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
	
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};

int main(){
	
	key_t kljuc = ftok("prvi.c",'A');
	int semid = semget(kljuc,4,0666|IPC_CREAT|IPC_EXCL);
	int br;
	int redni_broj=1;
	
	srand(time(NULL));
	
	if (semid != -1){
		
		union semun init_operacija;
		
		init_operacija.val=1;
		semctl(semid,0,SETVAL,init_operacija);
		
		init_operacija.val=0;
		semctl(semid,1,SETVAL,init_operacija);
		
		init_operacija.val=0;
		semctl(semid,2,SETVAL,init_operacija);
		
		init_operacija.val=0;
		semctl(semid,3,SETVAL,init_operacija);
		
	}
	else if (errno == EEXIST){
		
		semid = semget(kljuc,4,0);
	}
	else{
		
		printf("Doslo je do neke druge greske izlazim\n");
		exit(0);
	}
	
	struct sembuf povecaj, smanji;
	
	smanji.sem_num=0;
	smanji.sem_op=-1;
	smanji.sem_flg=0;
	
	povecaj.sem_num=1;
	povecaj.sem_op=1;
	povecaj.sem_flg=0;
	
	while (1){
		
		if (redni_broj<7){
			semop(semid,&smanji,1);
			br=rand() % 14 +1;
			sleep(2);
			printf("Moj slucajna broj je %d\n",br);
			br=0;
			redni_broj++;
			semop(semid,&povecaj,1);
		}
		else{
			
			printf("Zavrsio sam deljenje\n");
			break;
		}
	}
	
	return 0;
}
