#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <signal.h>
union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;	
};
int semid;
struct deljena
{
	int niz[3];
};
void izbrisiSemafore(int sig)
{
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
}

int main()
{
	signal(SIGINT,izbrisiSemafore);
	key_t key;
	int ind,*data_talon,*data_talon_znak,*data_smer,shmid,broj,talon,talon_znak,znak,shmid1,shmid2,shmid3;
	struct deljena *data;
	union semun operacija_nad_sem;
	struct sembuf opr_p,opr_v,opr1_v;
	
	key = ftok("./Igrac1.c",'A');
	
	semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	shmid1=shmget(key,sizeof(int),0666|IPC_CREAT);
	shmid2=shmget(key,sizeof(int),0666|IPC_CREAT);
	shmid3=shmget(key,sizeof(int),0666|IPC_CREAT);
	
	
	if(semid!=-1)
	{
		printf("Ja kreiram semafor\n");
		operacija_nad_sem.val=1;
		semctl(semid,0,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,1,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,2,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,3,SETVAL,operacija_nad_sem);
	}else if(errno==EEXIST)
	{
		printf("Vec postoji semafor\n");
		semctl(semid,3,0);
	}else
	{
		printf("Neka druga GREKA!\n");
		exit(0);
	}
	//printf("DB1\n");
	opr_p.sem_num=1;
	opr_p.sem_op=-1;
	opr_p.sem_flg=0;
	
	opr_v.sem_num=2;
	opr_v.sem_op=1;
	opr_v.sem_flg=0;
	
	opr1_v.sem_num=0;
	opr1_v.sem_op=1;
	opr1_v.sem_flg=0;
	//printf("DB2\n");
	data_talon=(int*)shmat(shmid1,(void *)0,0);
	data_talon_znak=(int*)shmat(shmid1,(void *)0,0);
	data_smer=(int*)shmat(shmid1,(void *)0,0);
	
	//printf("DB3\n");
	talon = rand()%15;
	talon_znak = rand()%4;
	*data_talon=talon;
	//printf("DB5\n");
	*data_talon_znak=talon_znak;
	*data_smer=1;
	//0 - karo, 1 - pik, 2 - tref, 3 - herc
	while(!talon)
	{
		talon=rand()%15;
	}
	//printf("DB4\n");
	while (1)
	{
	//printf("DB1\n");
		ind=semop(semid,&opr_p,1);
		if(ind==-1) break;
		broj=0;
		broj=rand()%15;
		znak = rand()%4;
		while(broj==0)
		{
			broj=rand()%15;
		}
		//printf("DB5\n");
		if(broj==talon || znak==talon_znak)
		{
			talon=broj;
			talon_znak=znak;
			*data_talon=talon;
			*data_talon_znak=znak;
			if(talon==8) data_smer=0;
			//printf("Izbacujem kartu: %d %d\n",broj,znak);
			if(znak==0) printf("Igrac 2 - Izbacujem kartu: %d %s\n",broj,"Karo");
			if(znak==1) printf("Igrac 2 - Izbacujem kartu: %d %s\n",broj,"Pik");
			if(znak==2) printf("Igrac 2 - Izbacujem kartu: %d %s\n",broj,"Tref");
			if(znak==3) printf("Igrac 2 - Izbacujem kartu: %d %s\n",broj,"Herc");
			sleep(1);
		} else printf("Nemam adekvatnu kartu\n");
		if(*data_smer!=0)
		{
			ind=semop(semid,&opr_v,1);
			if(ind==-1) break;
		}else if(*data_smer==0)
		{
			ind=semop(semid,&opr1_v,1);
			if(ind==-1) break;
		}
	}
	
	return 0;
}
