#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;/* used for SETVAL only */
	struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */
	ushort *array; /* used for GETALL and SETALL */
};

/*
struct sembuf {
	ushort sem_num; 
	short sem_op;
	short sem_flg;
};
*/

#define shm_size 1024

int main() {
	union semun arg;
	struct sembuf P[4], V[4];
	int shm_kljuc, sem_kljuc, shmid, semid;
	char *data;
	int i, j, karta;
	int ig1[6], ig2[6], ig3[6], ig4[6];
	
	srand(time(NULL));
	
	shm_kljuc = ftok("zadatak.c", 1);
	
	shmid = shmget(shm_kljuc, 1024, 0644 | IPC_CREAT);
	data = shmat(shmid, NULL, 0);
		
	//shmctl(shmid, IPC_RMID, NULL);
	
	sem_kljuc = ftok("zadatak.c", 1);
	semid = semget(sem_kljuc, 1, 0644 | IPC_CREAT);

	
	arg.val = 1;
	semctl(semid, 0, SETVAL, arg);
	
	//semctl(semid, 0, IPC_RMID);
	
	for(j=1; j<=6; j++) {
		for(i=1; i<=4; i++) {
			printf("Karta %d igraca %d: ", j, i);
			karta = rand()%14+1;
			if(i==1) ig1[j]=karta;
			if(i==2) ig2[j]=karta;
			if(i==3) ig3[j]=karta;
			if(i==4) ig4[j]=karta;				
			printf("%d \n", karta);
		}
		printf("\n");
	}
	
	for(i=1; i<=4; i++) {
		printf("Karte igraca %d: ", i);
		for(j=1; j<=6; j++) {
			if(i==1) printf("%d ", ig1[j]);
			if(i==2) printf("%d ", ig2[j]);
			if(i==3) printf("%d ", ig3[j]);
			if(i==4) printf("%d ", ig4[j]);
		}
		printf("\n");
	}
		
	P[0].sem_num = 0;
	P[0].sem_op = -1;
	P[0].sem_flg = 0;
	semop(semid, &P[0], 1);

	V[0].sem_num = 0;
	V[0].sem_op = 1;
	V[0].sem_flg = 0;
	semop(semid, &V[0], 1);
		
	shmdt(data);
	
	return 0;
}
