#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


typedef struct delmem_s {
	int broj;
	int znak;
} delmem;

#define SHMSIZE sizeof(delmem)

int main(void) {
	
	srand(time(NULL));
	
	//kaci se na semafor
	key_t key = ftok("init.c", 'S');
	int sid = semget(key, 4, IPC_CREAT | 0666);	

	//kaci se na deljenu
	key = ftok("init.c", 'M');
	int mid = shmget(key, SHMSIZE, 0666 | IPC_CREAT);	
	delmem *talon = (delmem*)shmat(mid, NULL, 0);
	
	
	//kreiraj sve potrebne semafore
	struct sembuf PS1 = {0, -1, 1};	
	struct sembuf VS2 = {1, +1, 1};

	
	//brojac da zna kad je 6ti krug obrnuo - da stane tada
	int br = 0;
	
	for(;;) {
		br++; 
		semop(sid, &PS1, 1);
		int broj = (rand() % 14) + 1;
		int znak = (rand() % 4);
		//0 - karo
		//1 - pik
		//2 - tref
		//3 -  herc 
		printf("IGRAC1 (KRUG BROJ %d): Dobio sam kartu: %d", br, broj);
		if (znak == 0) printf(" - karo\n");
		if (znak == 1) printf(" - pik\n");
		if (znak == 2) printf(" - tref\n");
		if (znak == 3) printf(" - herc\n");
		
		if (broj == talon->broj ||znak == talon->znak) {
			printf("Karta koju sam izvukao se poklapa sa kartom na talonu.\n");
			printf("Stara karta na talonu je zamenjena sa mojom kartom.\n\n");
			talon->broj = broj;
			talon->znak = znak;
			
		} else {
			printf("Karta koju sam izvukao se ne poklapa sa kartom na talonu.\n");
			printf("Talon ostaje nepromenjen.\n\n");
			
		}
		sleep(1);			
		semop(sid, &VS2, 1);
		
		
	
		
		if (br == 6) {
			printf("Odigrao sam 6 kruga. Zavrsavam.\n");
			shmdt(talon);
			return 0;
		}
		
	}
	
	
	


	
	
	
	
	return 0;
}

