#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>




union semun
{
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};


enum znak
{
	karo = 0,
	pik,
	tref,
	herc
};


typedef struct{
	int broj;
	enum znak z;
}karta;


int main()
{
	key_t kljuc = ftok("./igrac1.c",32);
	int semid = semget(kljuc,4,0666 | IPC_CREAT | IPC_EXCL);
	
	key_t kljuc2 = ftok("./igrac1.c",33);
	
	key_t kljuc3 = ftok("./igrac1.c",333);
	
	int shmid = shmget(kljuc,sizeof(int),0);
	int shmid2 = shmget(kljuc2,sizeof(int),0);
	int shmid3 = shmget(kljuc3,sizeof(int),0);
	
	karta* talon = (karta*)shmat(shmid, NULL, 0);
	int *smer = (int*)shmat(shmid2, NULL, 0);
	int *iskoriscena = (int*)shmat(shmid3, NULL, 0);
	
	//(*smer) = 1;
	
	if(semid == -1)
	{
		if(errno == EEXIST)
		{
			semid = semget(kljuc,4,0);
			
		}
		
	}
	else
	{
		union semun init_sem;
		init_sem.array =(unsigned short*)malloc(4*sizeof(unsigned short));
		
		init_sem.array[0] = 1;
		init_sem.array[1] = 0;
		init_sem.array[2] = 0;
		init_sem.array[3] = 0;
		
		semctl(semid,0, SETALL,init_sem);
	}
	
	struct sembuf P,V;
	
	//srand(getpid());
	srand(time(NULL));
	
	while(1)
	{
		srand(time(NULL));
		karta saTalona = (*talon);
		/*if(saTalona.broj == 8 && (*smer) == 1 && *iskoriscena == 0)
		{
			*smer = 0;
			*iskoriscena = 1;
		}
		else if(saTalona.broj == 8 && (*smer) == 0 && *iskoriscena == 0)
		{
			*smer = 1;
			*iskoriscena = 1;
		}*/
			P.sem_num = 1;
			P.sem_op = -1;
			P.sem_flg = 0;
			
			
			semop(semid, &P, 1);
			
			karta Karta;
			Karta.broj = rand() % 14 + 1;
			Karta.z = rand() % 4;
			
			printf("Izvukao sam kartu %d %d\n", Karta.broj, Karta.z);
			
			if((saTalona.broj == Karta.broj) || (saTalona.z == Karta.z))
			{
				printf("Izbacujem na talon\n");
				switch(Karta.z)
				{
					case 0:
					printf("%d karo\n", Karta.broj);
					break;
					case 1:
					printf("%d pik\n", Karta.broj);
					break;
					case 2:
					printf("%d tref\n", Karta.broj);
					break;
					case 3:
					printf("%d herc\n", Karta.broj);
					break;
					
				}
				
				
				*talon = Karta;
				if(Karta.broj == 8 && *smer==0)
				{
					*smer = 1;
				}
				else if(Karta.broj == 8 && *smer==1)
				{
					*smer = 0;
				}
			}
			else
			{
				printf("Nemam adekvatnu kartu.\n");
			}
			sleep(2);
			if((*smer) == 1)
			{
				
				printf("V sem2\n");
				V.sem_num = 2;
				V.sem_op = 1;
				V.sem_flg = 0;
			}
			else
			{
				printf("V sem0\n");	
				V.sem_num = 0;
				V.sem_op = 1;
				V.sem_flg = 0;
			}
			semop(semid, &V, 1);
	}
	return 0;
}
