#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
	
	int val;
	struct semid_ds *buf;
	ushort *array;	
};

int semid,shmid1,shmid2;
void handler(int sig)
{
		printf("Prekinut sa CTRL+C, brisem ipc objekte\n");
		semctl(semid,0,IPC_RMID);
		semctl(semid,1,IPC_RMID);
		semctl(semid,2,IPC_RMID);
		semctl(semid,3,IPC_RMID);
		shmctl(semid,IPC_RMID,NULL);
		exit(0);		
}
int main()
{
	key_t key;
	//int semid,shmid;
	int *broj,*znak;
	union semun arg;
	struct sembuf p;
	
	signal(SIGINT,handler);
	key=ftok("./init.c",10);
	printf("Kljuc:%d\n",key);
	
	semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	printf("Id semafora:%d\n",semid);
	
	key=ftok("./init.c",20);
	printf("Kljuc:%d\n",key);
	
	shmid1=shmget(key,1024,0666|IPC_CREAT);
	printf("Id deljene memorije1:%d\n\n",shmid1);
	
		key=ftok("./init.c",30);
	printf("Kljuc:%d\n",key);
	
	shmid2=shmget(key,1024,0666|IPC_CREAT);
	printf("Id deljene memorije:%d\n\n",shmid2);
	
	if(semid != -1)
	{
		printf("Uspesno napravljen semafor\n");
		arg.val=0;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);
		arg.val=0;
		semctl(semid,2,SETVAL,arg);
		arg.val=0;
		semctl(semid,3,SETVAL,arg);
	}
	else if(errno==EEXIST)
	{
		printf("Povezivanje na semafor\n");
		semid=semget(key,4,0);
		
	}
	else
	{
		printf("Neka druga greska,zavrsavam\n");
		exit(0);
	}
	
	srand(time(NULL));
	
	p.sem_num=0;
	p.sem_op=3;
	p.sem_flg=0;
	
	broj=shmat(shmid1,NULL,0);
	*broj=rand()%13;
	printf("Broj na karti: %d\n",*broj);
	
	
	znak=shmat(shmid2,NULL,0);
    *znak=rand()%3;
	printf("Znak na karti:%d\n",*znak);
	
	semop(semid,&p,1);
	
	return 0;
	
}

