#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

typedef struct{
	int broj;
	int znak;
	int ind;
}KARTA;

int main(){
	srand(time(NULL));
	key_t key_s, key_m;
	int shmid, semid;
	KARTA karta, *nasa_karta;
	struct sembuf p2, v3, v1;
	
	key_m = ftok("./igrac1.c", 'R');
	shmid = shmget(key_m, SHM_SIZE*sizeof(int), 0644 | IPC_CREAT);
	
	key_s = ftok("./igrac1.c", 'A');
	semid = semget(key_s, 4, 0644 | IPC_CREAT);
	
	nasa_karta = shmat(shmid, NULL, 0);

	p2.sem_num = 1;
	p2.sem_op = -1;
	p2.sem_flg = 0;
	
	v3.sem_num = 2;
	v3.sem_op = 1;
	v3.sem_flg = 0;
	
	v1.sem_num = 0;
	v1.sem_op = 1;
	v1.sem_flg = 0;

	nasa_karta->ind = 1;
	while(1){
		if(nasa_karta->ind==1 || nasa_karta->broj==-1){ //nije se na talonu pojavio broj 8
			semop(semid, &p2, 1);
				karta.broj = rand()%14;
				if(karta.broj == 8) {
					nasa_karta->ind = 0; //da promeni redosled igre
					continue;
				}
				karta.znak = rand()%4;
				if(nasa_karta->broj != -1){
					if(nasa_karta->broj == karta.broj || nasa_karta->znak == karta.znak){
						nasa_karta->broj = karta.broj;
						nasa_karta->znak = karta.znak;
						printf("Izbacujem kartu %d %d.\n", nasa_karta->broj, nasa_karta->znak);
					}
					else printf("Nemam adekvatnu kartu.\n");
				}
				else{ //kad igra otpocne, da stavi kartu 
					nasa_karta->broj = karta.broj;
					nasa_karta->znak = karta.znak;
					printf("Izbacujem kartu %d %d.\n", nasa_karta->broj, nasa_karta->znak);
				}
				
				sleep(2);
			semop(semid, &v3, 1);
		}
		else{ //na talonu se pojavio broj 8 -> promena smera
			semop(semid, &p2, 1);
				karta.broj = rand()%14;
				if(karta.broj == 8) {
					nasa_karta->ind = 0; //da promeni redosled igre
					continue;
				}
				karta.znak = rand()%4;
				if(nasa_karta->broj != -1){
					if(nasa_karta->broj == karta.broj || nasa_karta->znak == karta.znak){
						nasa_karta->broj = karta.broj;
						nasa_karta->znak = karta.znak;
						printf("Izbacujem kartu %d %d.\n", nasa_karta->broj, nasa_karta->znak);
					}
					else printf("Nemam adekvatnu kartu.\n");
				}
				else{ //kad igra otpocne, da stavi kartu 
					nasa_karta->broj = karta.broj;
					nasa_karta->znak = karta.znak;
					printf("Izbacujem kartu %d %d.\n", nasa_karta->broj, nasa_karta->znak);
				}
				
				sleep(2);
			semop(semid, &v1, 1);
		}
	}
	
	semctl(semid, 0, IPC_RMID);
	shmdt(nasa_karta);
}
