#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
int val;					/* used for SETVAL only */
struct semid_ds *buf;		/* used for IPC_STAT and IPC_SET */
ushort *array;				/* used for GETALL and SETALL */
};

#define SMR_SIZE = 2;

int main()
{
	key_t key;
	int semid3,semid4,semid5;
	int shmem1,shmem2;
	int *data1,*data2;
	struct sembuf V,P;
	char dznak[10];
	union semun;
	int ranBr,ranZn,br=0,n=6,i,niz[100][100],ind;
	srand(time(NULL));
	
	key=ftok("./init.c",0);
	shmem1=shmget(key,sizeof(int),0644|IPC_CREAT);
	printf("ID memorije:%d\n",shmem1);
	
	key=ftok("./init.c",7);
	shmem2=shmget(key,sizeof(int),0644|IPC_CREAT);
	printf("ID memorije:%d\n",shmem2);
	
	key=ftok("./init.c",3);
	semid3=semget(key,1,0);
	
	key=ftok("./init.c",4);
	semid4=semget(key,1,0);
	
	key=ftok("./init.c",5); 	//semafor za kontrolu kriticnog regiona
	semid5=semget(key,1,0);
	
	P.sem_num = 0;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	
	
	
	while(1)
	{
		semop(semid3,&P,1);
		while(1)
		{
			ranBr=(rand()%14)+1;
			ranZn=(rand()%4);
			ind=0;
			for(i=0;i<br;i++)
			{
				if(niz[i][0]==ranBr && niz[i][1]==ranZn)
				{
					ind=1;
					break;
				}
			}
			if(ind==0)
				break;
		}
		if(ranZn==0)
			strcpy(dznak,"karo");
		else if(ranZn==1)
			strcpy(dznak,"pik");
		else if(ranZn==2)
			strcpy(dznak,"tref");
		else if(ranZn==3)
			strcpy(dznak,"herc");
		printf("Moje karte su: %d %s\n",ranBr,dznak);
		
		semop(semid5,&P,1);
		data1=shmat(shmem1,NULL,0);
		data2=shmat(shmem2,NULL,0);
		if(*data2==0)
			strcpy(dznak,"karo");
		else if(*data2==1)
			strcpy(dznak,"pik");
		else if(*data2==2)
			strcpy(dznak,"tref");
		else if(*data2==3)
			strcpy(dznak,"herc");
		printf("Karta na talonu je: %d %s\n",*data1,dznak);
		if(*data1==ranBr || *data2==ranZn)
		{
			*data1=ranBr;
			*data2=ranZn;
			printf("Poklopio sam kartu\n");
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
			niz[br++][0]=ranBr;
			niz[br++][1]=ranZn;
		}
		sleep(1);
		shmdt(data1);
		shmdt(data2);
		semop(semid5,&V,1);
		semop(semid4,&V,1);
	}
}
