#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
int val;					/* used for SETVAL only */
struct semid_ds *buf;		/* used for IPC_STAT and IPC_SET */
ushort *array;				/* used for GETALL and SETALL */
};

int main()
{
	key_t key;
	int semid1,semid2,semid3,semid4,semid5;
	int shmem1,shmem2;
	int *data1,*data2;
	union semun arg1,arg2,arg3,arg4,arg5;
	
	srand(time(NULL));
	
	key=ftok("./init.c",0);
	shmem1=shmget(key,sizeof(int),0644|IPC_CREAT);
	printf("ID memorije:%d\n",shmem1);
	
	key=ftok("./init.c",7);
	shmem2=shmget(key,sizeof(int),0644|IPC_CREAT);
	printf("ID memorije:%d\n",shmem2);
		
	data1=shmat(shmem1,NULL,0);
	data2=shmat(shmem2,NULL,0);
	
	*data1=(rand()%14)+1;
	*data2=rand()%4;
	
	printf("Karte: %d %d\n",*data1,*data2);
	
	shmdt(data1);
	shmdt(data2);
	
	key=ftok("./init.c",1);		//prvi igrac
	semid1=semget(key,1,0644|IPC_CREAT);
	printf("ID semafora 1:%d\n",semid1);
	
	key=ftok("./init.c",2);		//drugi igrac
	semid2=semget(key,1,0644|IPC_CREAT);
	printf("ID semafora 2:%d\n",semid2);
	
	key=ftok("./init.c",3);		//treci igrac
	semid3=semget(key,1,0644|IPC_CREAT);
	printf("ID semafora 3:%d\n",semid3);
	
	key=ftok("./init.c",4);		//cetvrti igrac;
	semid4=semget(key,1,0644|IPC_CREAT);
	printf("ID semafora 4:%d\n",semid4);
	
	key=ftok("./init.c",5);		//semafor za kontrolu kriticnog regiona
	semid5=semget(key,1,0644|IPC_CREAT);
	printf("ID semafora 5:%d\n",semid5);
	
	arg1.val=1;
	semctl(semid1,0,SETVAL,arg1);
	arg2.val=0;
	semctl(semid2,0,SETVAL,arg2);
	arg3.val=0;
	semctl(semid3,0,SETVAL,arg3);
	arg4.val=0;
	semctl(semid4,0,SETVAL,arg4);
	arg5.val=1;
	semctl(semid5,0,SETVAL,arg5);
	
	
}

