#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
int val;
struct semid_ds *buf;
ushort *array;
};

int semid;

typedef struct Karta{
    int vrednost;
    int boja;
}karte;

int main(){
    key_t key,key2, key3;
    int shmid, id, shmid2, shmid3;
    int *data,*data2, *ind;
    union semun arg;
    struct sembuf smanji, povecaj, povecaj2;
    karte karta;
    srand(time(NULL));
    key = ftok("igrac1.c",'A');
    semid = semget(key, 4, 0666|IPC_CREAT|IPC_EXCL);
    shmid = shmget(key, sizeof(int),0666|IPC_CREAT);
    key2 = ftok("igrac1.c",'B');
    shmid2 = shmget(key2, sizeof(int),0666|IPC_CREAT);
    key3 = ftok("igrac1.c",'C');
    shmid3 = shmget(key3, sizeof(int),0666|IPC_CREAT);
    if(semid != -1){
        printf("Semafor nije bio inicijalizovan, ja sam ga inicijalizovao.\n");
        arg.val = 1;
        semctl(semid, 0, SETVAL, arg);
        arg.val = 0;
        semctl(semid, 1, SETVAL, arg);
        arg.val = 0;
        semctl(semid, 2, SETVAL, arg);
        arg.val = 0;
        semctl(semid, 3, SETVAL, arg);
        data = (int*)shmat(shmid,NULL,0);
        data2 = (int*)shmat(shmid2,NULL,0);
        ind = (int*)shmat(shmid3,NULL,0);

        *data = rand()%14 + 1;
        *data2 = rand()%4 + 1;
        *ind = 0;
        if(*data == 8)
        *ind = 1;
        
    }
    else if(errno == EEXIST){
        printf("Semafor je bio inicijalizovan, ja se samo povezujem. \n");
        semid = semget(key, 4, 0);
        data =(int*)shmat(shmid,NULL,0);
        data2 =(int*)shmat(shmid2,NULL,0);
        ind = (int*)shmat(shmid3,NULL,0);
    }
    else{
        printf("Neka druga greska, izlazim...\n");
        exit(0);
    }

    smanji.sem_num = 0;
    smanji.sem_op = -1;
    smanji.sem_flg = 0;

    povecaj.sem_num = 1;
    povecaj.sem_op = 1;
    povecaj.sem_flg = 0;

    povecaj2.sem_num = 3;
    povecaj2.sem_op = 1;
    povecaj2.sem_flg = 0;

    while(1){
        semop(semid, &smanji, 1);
        karta.vrednost = rand()%14+1;
        karta.boja = rand()%4+1;
        if(*data == karta.vrednost || *data2 == karta.boja){
            printf("Na talonu je %d %d\n", *data,*data2);
            *data = karta.vrednost;
            *data2 = karta.boja;
            printf("\tPromenio sam kartu u %d %d\n",*data,*data2);
            if(*data == 8){
                printf("\n------------\n------------\n------------\nMenjam krug.\n------------\n------------\n------------\n");
                *ind = *ind + 1;
            }
        }
        else{
            printf("Na talonu je %d %d, a ja imam %d %d\n    Nemam adekvatnu kartu.\n", *data,*data2,karta.vrednost,karta.boja);
        }
        printf("\n");
        sleep(1);
        if(*ind % 2 == 0)
            semop(semid, &povecaj, 1);
        else{
            semop(semid, &povecaj2, 1);
        }
    }
}