#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
 };

int semid;
int count=0;

void izbrisiSemafore(){
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	printf("kraj\n");
	exit(0);
}

int main(){
	key_t kljuc;
	int ind;
	struct sembuf igrac2, igrac3;
	union semun operacija;
	
	kljuc= ftok("igrac1.c",'a');
	semid= semget(kljuc, 4, 0666|IPC_CREAT|IPC_EXCL);
	
	if(semid != -1){
		operacija.val= 1;
		semctl(semid, 0, SETVAL, operacija);
		operacija.val= 0;
		semctl(semid, 1, SETVAL, operacija);
		semctl(semid, 2, SETVAL, operacija);
		semctl(semid, 3, SETVAL, operacija);
		}
	else if (errno == EEXIST)
		semid= semget(kljuc, 3, 0);
	else
		exit(0);
	
	srand(time(NULL));
	
	igrac2.sem_num= 1;
	igrac2.sem_op= -1;
	igrac2.sem_flg= 0;
	
	igrac3.sem_num= 2;
	igrac3.sem_op= 1;
	igrac3.sem_flg= 0;
	
	while(1){
			ind=semop(semid, &igrac2, 1);
			if (ind == -1)
				break;
			printf("Drugi igrac, njegova karta je: %d\n", rand()%14+1);
			sleep(1);
			
			ind= semop(semid, &igrac3,1);
			if (ind == -1)
				break;
			if(++count == 6){
				printf("Zavrsio!\n");
				exit(0);}
		}

	return 0;
}
