#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
 };

int semid, shmid;
int count=0;
int *data;

void izbrisiSemafore(int sig){
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	printf("kraj\n");
	shmctl(shmid, IPC_RMID, NULL);
	shmdt(data);
	exit(0);
}

int main(){
	key_t kljuc;
	int ind, karta, znak;
	struct sembuf igrac1, igrac2;
	union semun operacija;
	
	signal(SIGINT, izbrisiSemafore);
	kljuc= ftok("igrac1.c",'a');
	semid= semget(kljuc, 5, 0666|IPC_CREAT|IPC_EXCL);
	
	if(semid != -1){
		operacija.val= 1;
		semctl(semid, 0, SETVAL, operacija);
		operacija.val= 0;
		semctl(semid, 1, SETVAL, operacija);
		semctl(semid, 2, SETVAL, operacija);
		semctl(semid, 3, SETVAL, operacija);
		operacija.val= 1;
		semctl(semid, 4, SETVAL, operacija);
		}
	else if (errno == EEXIST)
		semid= semget(kljuc, 3, 0);
	else
		exit(0);
	
	kljuc= ftok("igrac1.c",'b');
	shmid= shmget(kljuc, SHM_SIZE*sizeof(int), 0644|IPC_CREAT);
	data= shmat(shmid, NULL, 0);
	
	data[0]=rand()%14+1;
	data[1]=rand()%4+1;
	
	srand(time(NULL));
	
	igrac1.sem_num= 0;
	igrac1.sem_op= -1;
	igrac1.sem_flg= 0;
	
	igrac2.sem_num= 1;
	igrac2.sem_op= 1;
	igrac2.sem_flg= 0;
	
	
	
	while(1){
			ind=semop(semid, &igrac1, 1);
			if (ind == -1)
				break;
			karta= rand()%14+1;
			znak= rand()%4+1;
			
			printf("Karta na talonu: %d %d\n", *data, *(data+1));
			if(*data == karta || *(data+1) == znak){
				printf("Prvi igrac poklapa sa: %d %d\n\n", karta, znak);
				*data= karta;
				*(data+1)= znak;
			}
			else
				printf("Prvi igrac nema adekvatnu kartu! (%d %d)\n\n", karta, znak);
			sleep(2);
			
			ind= semop(semid, &igrac2,1);
			if (ind == -1)
				break;
			
		}
	
	
	return 0;
}
