#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 4

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

void izbrisiSemafore(int sig){
	printf("\nPrimljen SIGINT!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	exit(0);
}

typedef struct kart{
	int broj;
	int znak;
}kart;

int main(){
	//n=4;
	int *karte;
	srand(time(NULL));
	key_t kljucsem = ftok("./deljenje", 'a');
	key_t kljucshm = ftok("./deljenje", 'r');
	key_t kljucshm2 = ftok("./deljenje", 'x');
	semid = semget(kljucsem, 5, 0666|IPC_CREAT|IPC_EXCL);
	int shmid = shmget(kljucshm, SHM_SIZE*sizeof(int), 0666|IPC_CREAT);
	kart *karte2;
	int shmid2 = shmget(kljucshm2, sizeof(kart), 0666|IPC_CREAT);
	//
	union semun arg;
	struct sembuf ig1P,ig1S, ig2P, ig2S, ig3P,ig3S, ig4P, ig4S, deljenjeP, deljenjeS;
	signal(SIGINT, izbrisiSemafore);
	if(semid != -1){
		//nije kreirao semafor
		arg.val=1;
		semctl(semid, 4, SETVAL, arg); //odblokiran deljenje.c
		arg.val=0;
		semctl(semid, 1, SETVAL, arg);
		semctl(semid, 2, SETVAL, arg);
		semctl(semid, 3, SETVAL, arg);
		semctl(semid, 0, SETVAL, arg);
	}
	else if(errno == EEXIST) semid = semget(kljucsem, 4, 0);
	else { printf("Neka druga greskas!\n"); exit(0); }
	karte = shmat(shmid, NULL, 0);
	
	ig3P.sem_num=2;
	ig3P.sem_op=1;
	ig3P.sem_flg=0;
	
	ig3S.sem_num=2;
	ig3S.sem_op=-1;
	ig3S.sem_flg=0;
	
	ig4P.sem_num=3;
	ig4P.sem_op=1;
	ig4P.sem_flg=0;
	
	ig4S.sem_num=3;
	ig4S.sem_op=-1;
	ig4S.sem_flg=0;
	
	deljenjeP.sem_num=4;
	deljenjeP.sem_op=1;
	deljenjeP.sem_flg=0;
	
	deljenjeS.sem_num=4;
	deljenjeS.sem_op=-1;
	deljenjeS.sem_flg=0;
	
	int ind;
	for(int i =0; i<6; i++){
		ind = semop(semid, &ig3S, 1); //blokiram igrac4.c
		if(ind == -1)
			break;
		printf("igrac 3: %d\n", karte[2]);
		sleep(3);
		ind = semop(semid, &deljenjeP, 1);
		if(ind == -1)
			break;
		//sleep(3);
		//semop(semid, &ig4P, 1);
		
	}
	karte2 = shmat(shmid2, NULL, 0);
	printf("karte na talonu: %d %d\n", karte2->broj, karte2->znak);
}





