#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};
enum znak_karte
{
	TREF=1,
	PIK, 
	HERC,
	KARO
};
typedef struct
{
	int broj;
	int znak;
}Karta;
int main()
{
	key_t kljuc = ftok("./igrac1.c", 'a');
	int semid = semget(kljuc, 4, 0666 | IPC_CREAT);
	
	kljuc = ftok("./igrac1.c", 'c');
	int shmid1 = shmget(kljuc, sizeof(int),0666 | IPC_CREAT  );
	Karta *t = shmat(shmid1, NULL, 0); //talon

	kljuc = ftok("./igrac1.c", 'b');
	int shmid2 = shmget(kljuc, sizeof(int),0666 | IPC_CREAT  );
	int *s = shmat(shmid2, NULL, 0); //smer
	
	srand(getpid());
	
	if(semid == -1)
	{
		if(errno == EEXIST)
		{
			semid = semget(kljuc, 4, 0);
		}
	}
	else
	{
		union semun init_sem;
		init_sem.array = (unsigned short*)malloc(4 * sizeof(unsigned short));
		
		init_sem.array[0] = 1;
		init_sem.array[1] = 0;
		init_sem.array[2] = 0;
		init_sem.array[3] = 0;
		
		semctl(semid, 0, SETALL, init_sem);
		
	}
	
	struct sembuf P, V;
	int i;
	
	Karta k, talonKarta;
	
	P.sem_num = 0;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	
	V.sem_num = 1;
	V.sem_op =  1;
	V.sem_flg = 0;
	
	//prvi igrac inicijalizuje koja je karta na talonu
	k.broj = (rand() % 14) + 1;
	k.znak = (rand() % 3) + 1;
//	k.broj = 8;
	
	switch(k.znak)
	{
		case 1:
		printf("Na talonu je: %d tref\n", k.broj);
		break;
		case 2:
		printf("Na talonu je: %d pik\n", k.broj);
		break;
		case 3:
		printf("Na talonu je: %d herc\n", k.broj);
		break;
		case 4:
		printf("Na talonu je: %d karo\n", k.broj);
		break;

	}
	
	//inicijalizuje i smer
	
	(*s)  = 1; //pravilan smer
	(*t) = k;
	

	for(i=0; i<6; i++)
	{
		
			
		semop(semid, &P, 1);
		
		talonKarta = (*t);
			
		if(talonKarta.broj == 8 && (*s)==1)
		{
			(*s)=0;
			printf("Smer je promenjen\n");
		}
		else if(talonKarta.broj == 8 && (*s)==0)
		{
			(*s)=1;
			printf("Smer je promenjen\n");
		}

		if((*s)==0)
		{
				
			
				P.sem_num = 0;
				P.sem_op = -1;
				P.sem_flg = 0;
				
				V.sem_num = 3;
				V.sem_op =  1;
				V.sem_flg = 0;
				
				
		}
		else
		{
				
				P.sem_num = 0;
				P.sem_op = -1;
				P.sem_flg = 0;
				
				V.sem_num = 1;
				V.sem_op =  1;
				V.sem_flg = 0;
				
			
		}
		
			
		
		
		
		
		//napravi Kartu	
		k.broj = (rand() % 14) + 1;
		k.znak = (rand() % 3) + 1;
	
		if(k.broj == talonKarta.broj || k.znak == talonKarta.znak)
		{
			switch(k.znak)
			{
				case 1:
				printf("Stavljam kartu: %d tref\n", k.broj);
				break;
				case 2:
				printf("Stavljam kartu: %d pik\n", k.broj);
				break;
				case 3:
				printf("Stavljam kartu: %d herc\n", k.broj);
				break;
				case 4:
				printf("Stavljam kartu: %d karo\n", k.broj);
				break;

			}
			
			(*t) = k;
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
		
		}
		
		sleep(3);
		
	
		
		semop(semid, &V, 1);
		
	}
	
	
	return 0;
}
