#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <time.h>
#include <unistd.h>

#define ORIGIN 1
#define OBRNUTI -1
typedef struct Karta
{
	int broj;
	int znak;
	int smer;
}Karta;


int main(int argc, char const *argv[])
{
	srand(time(0));
	Karta *talon;
	key_t kljuc;
	kljuc = ftok("./init.c", 1);
	int shmid;
	shmid = shmget(kljuc, sizeof(Karta), IPC_CREAT | 0666);
	
	talon = (Karta *)shmat(shmid, NULL, 0);

	int semid;
	semid = semget(kljuc, 4, 0);

	struct sembuf smanji_sem_3, povecaj_sem_0, povecaj_sem_2;

	smanji_sem_3.sem_num = 3;
	smanji_sem_3.sem_op = -1;
	smanji_sem_3.sem_flg = 0;

	povecaj_sem_0.sem_num = 0;
	povecaj_sem_0.sem_op = 1;
	povecaj_sem_0.sem_flg = 0;

	povecaj_sem_2.sem_num = 2;
	povecaj_sem_2.sem_op = 1;
	povecaj_sem_2.sem_flg = 0;

	Karta karta;
	
	while(1)
	{
		semop(semid, &smanji_sem_3, 1);
		// printf("Smer: %d\n",(*talon).smer);
		karta.broj = (rand() % 14) + 1;
		karta.znak = (rand() % 4) + 1;
		printf("Na talon je: broj - %d znak - %d\n",(*talon).broj, (*talon).znak);
		sleep(1);
		printf("Igrac 4 izvukao kartu: broj- %d znak- %d\n", karta.broj, karta.znak);
		sleep(1);

		karta.smer = (*talon).smer;

		if((*talon).broj == karta.broj || (*talon).znak == karta.znak)
		{
			if(karta.broj == 8)
			{
				karta.smer = karta.smer * -1;
			}
			(*talon) = karta;
		}
		else 
		{
			printf("Nema adekvatnu kartu\n");
		}
		printf("Smer: %d\n",(*talon).smer);
		printf("#########################################################################\n");
		sleep(2);
		if((*talon).smer == ORIGIN)
			semop(semid, &povecaj_sem_0, 1);
		else
			semop(semid, &povecaj_sem_2, 1);
	}

}