#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <time.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

#define ORIGIN 1
#define OBRNUTI (-1)

typedef struct Karta
{
	int broj;
	int znak;
	int smer;
}Karta;

int main(int argc, char const *argv[])
{
	srand(time(0));
	Karta *talon;
	key_t kljuc;
	kljuc = ftok("./init.c", 1);
	int shmid;
	shmid = shmget(kljuc, sizeof(Karta), IPC_CREAT | 0666);
	
	talon = (Karta *)shmat(shmid, NULL, 0);

	int semid;
	semid = semget(kljuc, 4, IPC_CREAT | 0666);

	Karta karta;

	karta.broj = (rand() % 14) + 1;
	karta.znak = (rand() % 4) + 1;
	karta.smer = ORIGIN;
	if(karta.broj == 8)
	{
		karta.smer = OBRNUTI;
	}

	union semun init_sem;
	init_sem.val = 1;
	semctl(semid, 0, SETVAL, init_sem);
	init_sem.val = 0;
	semctl(semid, 1, SETVAL, init_sem);
	semctl(semid, 2, SETVAL, init_sem);
	semctl(semid, 3, SETVAL, init_sem);

	if(karta.smer == OBRNUTI)
	{
		init_sem.val = 0;
		semctl(semid, 0, SETVAL, init_sem);
		init_sem.val = 1;
		semctl(semid, 3, SETVAL, init_sem);
	}

	(*talon) = karta;

	printf("Na talonu je: broj - %d znak - %d\n", (*talon).broj, (*talon).znak);
	printf("Smer: %d\n",(*talon).smer);

	return 0;
}