#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
int semid;
int invertuj(int n)
{
	if(n == 0) return 1;
	return 0;
}

void sigh(int sig)
{
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
}

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *arr;
};

typedef struct karta
{
	int br;
	int z;
	int osam;
}karta;

int main()
{
	int *data;
	int shmid;
	signal(SIGINT,sigh);
	int rbr;
	printf("unesi redni broj igraca: ");
	scanf("%d",&rbr);
	key_t key;
	key_t dm;
	union semun arg;
	int pom = 6;
	int broj;
	int znak;
	karta *pomocna;
	
	time_t t;
	srand((unsigned)time(&t));
	
	/* pravljenje kljuca za dm */
	dm = ftok("igrac.c", 'V');
	
	/* uzimanje id segmenta dm */
	shmid = shmget(dm, sizeof(int) * 3, 0644 | IPC_CREAT);
	
	/* kacenje na segment */
	pomocna = shmat(shmid, NULL, 0);
	
	/* pravljenje kljuca za semafore */
	key = ftok("igrac.c", 'B');
	
	/* pravljenje ili kacenje na semafore */
	semid = semget(key, 5, 0666 | IPC_CREAT);
	
	/* definisanje operacije */
	struct sembuf P;
	struct sembuf V;
	struct sembuf PI;
	struct sembuf VI;
	
	PI.sem_num = 4;
	PI.sem_op = -4;
	PI.sem_flg = 0;
	
	VI.sem_num = 4;
	VI.sem_op = 1;
	VI.sem_flg = 0;
	
	P.sem_num = rbr - 1; // svoj semafor smanjuje
	P.sem_op = -1;
	P.sem_flg = 0;
	
	if(rbr == 4)
	{
		V.sem_num = 0; // ako je poslednji igrac onda otvara prvi semafor
	}else
	{
		V.sem_num = rbr; // svi ostali otvaraju sledeci
	}
	V.sem_op = 1;
	V.sem_flg = 0;
	
	semop(semid, &VI, 1);
	if(rbr == 1)	semop(semid, &PI, 1); // prvi proces ceka da dodje jos 3 procesa da mogu da zapocnu igru, dok ostala tri procesa cekaju prvi da startuje
	while(1)
	{
		broj = rand()%15;
		if(!broj) broj++;
		znak = rand()%4;
		
		semop(semid, &P, 1); // blokiranje dok ga prethodni igrac ne otvori
		printf("izvucena karta: ");
		if(znak == 0) printf("pik ");
		if(znak == 1) printf("herc ");
		if(znak == 2) printf("karo ");
		if(znak == 3) printf("tref ");
		printf("%d\t",broj);
		printf("talon: ");
		if(pomocna->z == 0) printf("pik ");
		if(pomocna->z == 1) printf("herc ");
		if(pomocna->z == 2) printf("karo ");
		if(pomocna->z == 3) printf("tref ");
		printf("%d\n",pomocna->br);
		if(pomocna->br == broj || pomocna->z == znak)
		{
			if(znak == 0) printf("pik ");
			if(znak == 1) printf("herc ");
			if(znak == 2) printf("karo ");
			if(znak == 3) printf("tref ");
			printf("%d\n",broj);
			
			pomocna->br = broj; // promeni kartu na talonu
			pomocna->z = znak;
			
			if(broj == 8) pomocna->osam = invertuj(pomocna->osam); //promeni smer igre
		}else
		{
			printf("Nemam adekvatnu kartu\n");
		}
		
		if(pomocna->osam)
		{
			if(rbr == 1)
			{
				V.sem_num = 3; // prvi otvara poslednji
			}else
			{
				V.sem_num = rbr - 2; // svi ostali otvaraju prethodni
			}
		}else
		{
			if(rbr == 4)
			{
				V.sem_num = 0; // opet vracamo stari redosled
			}else
			{
				V.sem_num = rbr; // svi ostali otvaraju sledeci
			}
		}
		
		sleep(2);
		semop(semid, &V, 1);
	}
	
	return 0;
}
