#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

void brisiSem(int sig)
{
	semctl(semid,0,IPC_RMID);
	exit(0);
}

int main()
{
	key_t kljuc;
	int karta;
	
	struct sembuf p,v,p1,v1;
	union semun arg;
	
	signal(SIGINT,brisiSem);
	
	srand(time(NULL));
	
	kljuc = ftok("./igrac1.c",'A'); 
	
	semid = semget(kljuc,2,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid != -1)
	{
		arg.val = 0;
		semctl(semid,0,SETVAL,arg);
		arg.val = 0;
		semctl(semid,1,SETVAL,arg);
	}
	else if(errno == EEXIST)
	{
		semid = semget(kljuc,1,0);
	}
	else
	{
		exit(0);
	}
	
	p.sem_num = 0;
	p.sem_op = 1;
	p.sem_flg = 0;
	
	v.sem_num = 0;
	v.sem_op = -1;
	v.sem_flg = 0;
	
	p1.sem_num = 1;
	p1.sem_op = -1;
	p1.sem_flg = 0;
	
	v1.sem_num = 1;
	v1.sem_op = 1;
	v1.sem_flg = 0;

	
	int i = 0;
	
	while(i<6)
	{
		i++;
		semop(semid,&p,1);     
		semop(semid,&p1,1);
		karta = rand()%14 + 1;
		printf("%d.Karta:%d\n",i,karta);
		sleep(2);
		semop(semid,&v1,1);
		semop(semid,&v,1); 
	}
}
