#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SIZE 4*sizeof(int)

union unija{
	int val;
	struct semid_ds *buf;
	ushort *array;
};
int semid;
void handler(int sig)
{	
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	printf("Brisem sve semafora\n");
	exit(0);
}

int main()
{

	key_t kljuc;
	int shmid, br=0,karta,i;
	int *data;
	struct sembuf smanjiD, povecajT ;
	union unija sem;
	srand(time(NULL));
	signal(SIGINT,handler);
	
	kljuc=ftok("./igrac1.c", 15);
	printf("Kljuc je %d\n", kljuc);
	
	shmid=shmget(kljuc, 4*sizeof(int), 0666|IPC_CREAT);
	printf("ID memorije je %d\n", shmid);
	
	data=(int *)shmat(shmid,NULL,0);
	
	semid=semget(kljuc, 4, 0666|IPC_CREAT|IPC_EXCL);
	printf("ID skupa semafora je %d\n", semid);
	if(semid!=-1)
	{
		printf("Ja sam kreirao semafor\n");
		sem.val=1;
		semctl(semid,0,SETVAL,sem);
		
		sem.val=0;
		semctl(semid,1,SETVAL,sem);
		
		sem.val=0;
		semctl(semid,2,SETVAL,sem);
		
		sem.val=0;
		semctl(semid,3,SETVAL,sem);
	}
	else if(errno==EEXIST)
	{
		printf("Neko drugi je kreirao semafor, ja se samo povezujem\n");
		semid=semget(kljuc,4,0);
		printf("ID skupa semafora je %d\n", semid);
	}
	else
	{
		printf("Neka druga greska. Izlazim\n");
	}
	
	smanjiD.sem_num=1;
	smanjiD.sem_op=-1;
	smanjiD.sem_flg=0;
	
	povecajT.sem_num=2;
	povecajT.sem_op=1;
	povecajT.sem_flg=0;
	
	printf("Drugi igrac\n");
	
	
	while(1)
	{
		
		semop(semid,&smanjiD,1);
		karta=rand()%14;
		*data=karta;
		printf("Karta je %d\n",*data); //isto bi bilo i da smo stampali 'karta' umesto '*data'
		br++; 
		if(br==6)
			semop(semid,&povecajT,1);
		else
		{	
			sem.val=1;
			semctl(semid,1,SETVAL,sem);
		}
		//sleep(2);
		
	}
	sleep(2);
	shmdt(data);
	return 0;
	
}
