#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

void hendler(int sig){
	printf("Primljen signal\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	printf("Semafori obrisani\n");
	exit(1);
}

int main(){
	srand(time(NULL));
	key_t kljuc;
	int karta, broj_karata = 0;
	union semun operacija;
	struct sembuf povecaj, smanji;
	
	signal(SIGINT, hendler);
	
	kljuc = ftok("./igrac1.c", 'T');
	semid = semget(kljuc, 4, 0666|IPC_CREAT|IPC_EXCL);
	
	if (semid != -1){
		operacija.val = 1;
		semctl(semid, 0, SETVAL, operacija);
		operacija.val = 0;
		semctl(semid, 1, SETVAL, operacija);
		operacija.val = 0;
		semctl(semid, 2, SETVAL, operacija);
		operacija.val = 0;
		semctl(semid, 3, SETVAL, operacija);
	}
	
	else if (errno == EEXIST)
		semid = semget(kljuc, 4, 0);
		
	else{
		printf("Greska\n");
		exit(1);
	}
	
	smanji.sem_num = 0;
	smanji.sem_op = -1;
	smanji.sem_flg = 0;
	
	povecaj.sem_num = 1;
	povecaj.sem_op = 1;
	povecaj.sem_flg = 0;
	
	while (1){
		semop(semid, &smanji, 1);
		
		karta = random()%15;
		while (karta == 0)
			karta = random()%15;
			
		broj_karata++;
		printf("PRVI IGRAC: Moja karta je %d\n", karta);
		sleep(2);
		
		if (broj_karata == 6){
			printf("PRVI IGRAC: Zavrsio sam\n");
			sleep(2);
			semop(semid, &povecaj, 1);
			exit(1);
		}
		
		semop(semid, &povecaj, 1);
	}
	
	return 0;
}
