#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

int pid_pom;
void sig_handler_dete(int sig)
{
	if(pid_pom == 0)
	{
		signal(SIGINT, SIG_IGN);
		printf("Nije moguce prekinuti proces dete\n");
	}
	else
	{
		//printf("Ubijam dete\n");
		kill(pid_pom, SIGKILL);
		//printf("Umirem");
		exit(2);
	}
	
}



int main()
{
	int n, i;
	scanf("%d",&n);
	
	pid_t pid;
	signal(SIGINT, sig_handler_dete);

	pid = fork();
	pid_pom = pid;
	if(pid == -1)
	{
		printf("Neuspesan fork/n");
		exit(1);
	}
	else if (pid == 0)
	{
		for(i=1; i<n; i+=2)
		{
			printf("Dete: %d\n", i);
			sleep(rand() % 5);
			
		}
		
	}
	else
	{
		for(i=0; i<n; i+=2){
			printf("Roditelj: %d\n", i);
			sleep(rand() % 5);
			
		}
		
	}
	
	
	
	return 0;
}
