#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<sys/types.h>
#include<sys/msg.h>
#include<sys/ipc.h>
#include<unistd.h>

struct msg{
	long tip;
	long pid;
	long broj;
	char tekst[100];
};

int main()
{
	struct msg kaServeru,odServera,odMene,kaMeni;
	key_t kljuc1,kljuc2;
	int id_reda1, id_reda2;
	long mojpid;
	
	kljuc1=ftok("./server.c",1);
	if((id_reda1=msgget(kljuc1,0))==-1)
	{
		printf("Neuspesno prijavljivanje na red\n");
		exit(0);		
	}
	printf("Saljem poruku za prijavu serveru...\n");
	kaServeru.tip=1;
	kaServeru.pid=getpid();
	mojpid=getpid();
	printf("Moj pid:%ld\n",kaServeru.pid);
	msgsnd(id_reda1,&kaServeru,sizeof(kaServeru),0);
	sleep(rand()%10);
	
	msgrcv(id_reda1,&odServera,sizeof(odServera),mojpid,0);
	int mojRedniBr;
	mojRedniBr=odServera.broj;
	
	printf("Moj redni broj:%d\n",mojRedniBr);
	
	if(mojRedniBr %2 != 0)
	{
		kljuc2=ftok("./klijent",mojRedniBr);
		if((id_reda2=msgget(kljuc2,IPC_CREAT|0666))==-1)
		{
			printf("Neuspesno kreiranje reda\n");
			exit(0);
		
		}
		
		printf("Unesite poruku za slanje\n");
		fgets(odMene.tekst,sizeof(odMene.tekst),stdin);
		odMene.broj=mojRedniBr;
		odMene.tip=mojRedniBr;
		msgsnd(id_reda2,&odMene,sizeof(odMene),0);
		sleep(rand()%10);
		msgrcv(id_reda2,&kaMeni,sizeof(kaMeni),mojRedniBr+1,0);
		printf("Primljena poruka:%s\n",kaMeni.tekst);		
	}
	else if(mojRedniBr %2 ==0)
	{
		kljuc2=ftok("./klijent",mojRedniBr-1);
		if((id_reda2=msgget(kljuc2,0))==-1)
		{
			printf("Neuspesno povezivanje na red\n");
			exit(0);
		
		}
		msgrcv(id_reda2,&kaMeni,sizeof(kaMeni),mojRedniBr-1,0);
		printf("Primljena poruka:%s\n",kaMeni.tekst);	
		printf("Moj odgovor\n");
		fgets(odMene.tekst,sizeof(odMene.tekst),stdin);
		odMene.broj=mojRedniBr;
		odMene.tip=mojRedniBr;
		msgsnd(id_reda2,&odMene,sizeof(odMene),0);
		}


	return 0;
}
