#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

/*
 Napisati programe server.c i klijent.c. Server čeka da mu se prijavi N klijenata (N je paran
broj manji od 21). Svakom klijentu, u zavisnosti od redosleda prijavljivanja, prosleđuje se redni broj
(od 1 do N). Nakon završene prijave, klijenti razmenjuju po jednu poruku, i to tako da prvo klijent
sa neparnim rednim brojem šalje poruku klijentu sa rednim brojem za jedan većim, zatim klijent sa
parnim rednim brojem odgovara na tu poruku. Poruke učitati sa standardnog ulaza.
*/



/*


server:
ucitaj N
od 1..N uradi N prijava tj da im redne brojeve
signaliziraj prvom da moze da krene


*/

struct mojaPoruka {
	long tip;
	int pid;
	int redniBroj;
	char text[25];
};

int main(void) {
	
	printf("Unesi N (broj klijenata):");
	int N;
	scanf("%d", &N);
	
	
	key_t kljuc = ftok("server.c", 65);
	if (kljuc == -1) { perror("ftok"); exit(1); }
	
	int red =  msgget(kljuc, IPC_CREAT | 0666);
	if (red == -1) { perror("msgget"); exit(1); }
	
	int i;
	struct mojaPoruka poruka;
	
	for (i = 1; i <= N; i++) {
		msgrcv(red, &poruka, sizeof(poruka), 99, 0);
		poruka.tip = poruka.pid;
		poruka.redniBroj = i;
		msgsnd(red, &poruka, sizeof(poruka), 0);
		
	}
	
	printf("SERVER: Prijave zavrsene\n");
	printf("SERVER: Saljem signal prvom klijentu da moze da krene\n");
	poruka.tip = 1;
	msgsnd(red, &poruka, sizeof(poruka), 0);
	printf("SERVER: Zavrsavam jer nemam vise sta da radim\n");
	exit(0);
	
	

	
	
	
	return 0;
}
