#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct 
{
    long type;
    char data[100];
    int rbr;
}message;



int main() {
	key_t key, key2;
	message msg;
    int qid, pom, qid2;

    key = ftok("./server.c", 65);
    qid = msgget(key, IPC_CREAT|0666);

    msg.type = 1;
    msg.rbr = -1;
    strcpy(msg.data, "Zahtev poslat.\n");

    
    printf("%d\n", msgsnd(qid, &msg, sizeof(msg), 1));
    printf("Klijent je poslao prijavu serveru i ceka odgovor.\n");

    // TEST
    msg.rbr = 1;
    //msgrcv(qid, &msg, sizeof(msg), 2, 0);
    printf("Redni broj klijenta je [%d].\n", msg.rbr);

    // Red za poruke izmedju klijenata
    key2 = ftok("./klijent.c", msg.rbr);
    qid2 = msgget(key2, IPC_CREAT|0666);

    if(msg.rbr % 2 == 1){
        printf("Ucitati poruku koja [%2d] salje [%2d].\n", msg.rbr, msg.rbr + 1);
        fgets(msg.data, sizeof(msg.data), stdin);

        msg.type = 2;
        
        msgsnd(qid2, &msg, sizeof(msg), 2);
        printf("Poruka je poslata.\n");
    }
    else{
        printf("Klijent sa rednim brojem [%2d] ceka.\n", msg.rbr + 1);

        msgrcv(qid2, &msg, sizeof(msg), 2, 0);
        printf("Poruka je primljena:\n\t%s\n", msg.data);        
    }

    return 0;
}
	
	