#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

struct poruka {
	long tip;
	int redniBroj;
	int pid;
	int brojKlijenata;
	//char prijava[10];
	char tekst[20];
};

int main(){
	int idReda, kljuc;
	struct poruka novaPoruka;
	int i;
	
	kljuc = ftok("./server.c", 65);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	msgrcv(idReda, &novaPoruka, sizeof(novaPoruka), 2, 0);
	printf("Primljena poruka %s\n", novaPoruka.tekst);
	novaPoruka.tip = 1;
	
	for(i = 0; i < novaPoruka.brojKlijenata; i++) {
		fgets(novaPoruka.tekst, sizeof(novaPoruka.tekst), stdin);
		novaPoruka.pid = getpid();
		printf("Moj pid je %d\n", novaPoruka.pid);
		msgsnd(idReda, &novaPoruka, sizeof(novaPoruka), 0);
	}
	
	for(i = 0; i < novaPoruka.brojKlijenata; i++) {
		novaPoruka.tip = novaPoruka.pid;
		msgrcv(idReda, &novaPoruka, sizeof(novaPoruka), 2, 0);
		printf("Prijavu poslao klijent %d\n", novaPoruka.redniBroj);
		printf("Klijent redni broj: %d\n", novaPoruka.redniBroj);
	}
}
