#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

struct poruka {
	long tip;
	int pid;
	int redniBroj;
	int brojKlijenata;
	//char prijava[10];
	char tekst[20];
};

int main(){
	int idReda, kljuc;
	struct poruka novaPoruka;
	
	kljuc = ftok("./server.c", 65);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	int n;
	int i; 
	scanf("%d", &n); getchar();
	
	if(n%2 || n > 20){
		printf("Treba uneti paran broj manji od 21\n");
		exit(0);
	}
	
	novaPoruka.brojKlijenata = n;
	novaPoruka.tip = 2;
	
	fgets(novaPoruka, sizeof(novaPoruka), stdin);
	msgsnd(idReda, &novaPoruka, sizeof(novaPoruka), 0);
	// da bi klijent ucitao koliko klijenata ima tj koliko je n
	
	for(i = 0; i < n; i++) {
		msgrcv(idReda, &novaPoruka, sizeof(novaPoruka), 1, 0);
		novaPoruka.redniBroj = i + 1;
		printf("Primljena poruka %s rednog broja %d\n", novaPoruka.tekst, novaPoruka.redniBroj);
	}
	
	int p;
	p = 0;
	for(i = 0; i < novaPoruka.brojKlijenata; i++) {
		p++;
		novaPoruka.tip = p;
		msgsnd(idReda, &novaPoruka, sizeof(novaPoruka), 0);
		msgrcv(idReda, &novaPoruka, sizeof(novaPoruka), p, 0);
		novaPoruka.tip = p;
		msgsnd(idReda, &novaPoruka, sizeof(novaPoruka), 0);
		msgrcv(idReda, &novaPoruka, sizeof(novaPoruka), p+1, 0);
	}
}
