#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct{
	long tip_poruke;
	int redni_broj;
	int pid;
	char tekst_poruke[100];
} PORUKE;

int main(){
	key_t kljuc;
	int id_reda;
	PORUKE poruka;
	int i, n;
	
	kljuc = ftok("./server.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	printf("Unesite broj klijenata: ");
	scanf("%d", &n);
	
	for(i = 1; i <= n; i++){
		msgrcv(id_reda, &poruka, sizeof(poruka), 1, 0);
		printf("%s: Proces sa PID-om %d\n", poruka.tekst_poruke, poruka.pid);
		poruka.tip_poruke = poruka.pid;
		poruka.redni_broj = i;
		msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	}
	
	return 0;
}
