#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/msg.h>
#include <string.h>


typedef struct Poruka
{
	long tip_poruke;
	int redni_broj;
	char tekst_poruke[100];
}Poruka;

int main(int argc, char const *argv[])
{
	key_t kljuc;
	kljuc = ftok("./server.c", 1);
	int id_reda;
	id_reda = msgget(kljuc, IPC_CREAT | 0666);

	Poruka poruka;

	poruka.tip_poruke = getpid();
	msgsnd(id_reda, &poruka, sizeof(poruka), 0);

	msgrcv(id_reda, &poruka, sizeof(poruka), getpid(), 0);
	printf("Proces %d ima redni broj %d\n", getpid(), poruka.redni_broj);

	int moj_redni_broj = poruka.redni_broj;

	if(moj_redni_broj % 2 == 1)
	{
		poruka.tip_poruke = moj_redni_broj + 1;
		printf("Unesite poruku koju zelite da posaljete klijentu sa rednim brojem %d.\n", moj_redni_broj + 1 );
		fgets(poruka.tekst_poruke, sizeof(poruka.tekst_poruke), stdin);
		poruka.tekst_poruke[strlen(poruka.tekst_poruke) - 1] = '\0';
		msgsnd(id_reda, &poruka, sizeof(poruka), 0);

		printf("Cekam odgovor od klijenta sa rednim brojem %d...\n", moj_redni_broj + 1);
		msgrcv(id_reda, &poruka, sizeof(poruka), moj_redni_broj, 0);
		printf("ODGOVOR: %s\n", poruka.tekst_poruke);

	}
	else
	{
		printf("Cekam poruku od klijenta sa rednim brojem %d....\n", moj_redni_broj - 1);
		msgrcv(id_reda, &poruka, sizeof(poruka), moj_redni_broj, 0);
		printf("STIGLO: %s\n", poruka.tekst_poruke);
		printf("ODGOVORI:\n");

		poruka.tip_poruke = moj_redni_broj - 1;
		fgets(poruka.tekst_poruke, sizeof(poruka.tekst_poruke), stdin);
		poruka.tekst_poruke[strlen(poruka.tekst_poruke) - 1] = '\0';

		msgsnd(id_reda, &poruka, sizeof(poruka), 0);

	}

	return 0;
}