#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include <wait.h>


int pid_deteta;

void moj_handler1(int sig)
{
	kill(pid_deteta, SIGKILL);
	exit(0);
}

void moj_handler2(int sig)
{
	printf("Nije moguce prekinuti proces dete\n");
}

int main(int argc, char const *argv[])
{
	srand(time(NULL));
	int n,i,j; //jelica
	printf("Unesite zeljeni broj:\n");
	scanf("%d", &n);

	if(fork())
	{
		signal(SIGINT, moj_handler1);
		for (i = 1; i <= n; ++i)
		{
			if(i % 2 == 0)
			{
				printf("Roditelj: %d\n", i);
				sleep(rand() % 5 + 1);
			}
		}
		wait(0);
	}
	else
	{
		signal(SIGINT, moj_handler2);
		pid_deteta = getpid();
		// printf("Pid deteta = %d\n", pid_deteta);
		for (j = 1; j <= n; ++j)
		{
			if(j % 2 == 1)
			{
				printf("Dete: %d\n", j);
				sleep(rand() % 7 + 1);	
			}
		}
		exit(0);

	}


	return 0;
}
