#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

struct prijava
{
	long tip;
	int pid;
};

struct server
{
	long tip;
	int redni_broj;
};

struct pidovi
{
	long tip;
	int pid_suseda;
};

struct chat
{
	long tip;
	int pid;
	char text[50];
};

int main(void)
{
	key_t kljuc;
	int ID,pom;
	struct prijava prijava_za_server;
	struct server poruka_od_servera;
	struct pidovi poruka_koji_sused;
	// Kreiranje reda;
	
	kljuc = ftok("./Zadatak2Server.c",100);
	ID = msgget (kljuc, IPC_CREAT | 0666);
	
	// Upis prijave:
	
	pom = getpid();
	printf("Moj pid je %d\n",pom);
	prijava_za_server.pid = pom;
	prijava_za_server.tip = 1;
	
	//Slanje poruke serveru;
	
	msgsnd (ID,&prijava_za_server,sizeof(prijava_za_server),0);
	printf("Poslao sam prijavu!\n");
	printf("Cekam odgovor...\n");
	msgrcv (ID,&poruka_od_servera,sizeof(poruka_od_servera),pom,0);
	printf("Primio sam poruku od servera! Moj redni broj je %d\n",poruka_od_servera.redni_broj);
	
	msgrcv(ID,&poruka_koji_sused,sizeof(poruka_koji_sused),pom,0);
	//printf("Pid mog suseda je %d\n",poruka_koji_sused.pid_suseda);
	
	char S[50];
	struct chat poruka_za_suseda;
	struct chat poruka_od_suseda;
	if (poruka_od_servera.redni_broj % 2 != 0)
	{
		poruka_za_suseda.tip = poruka_koji_sused.pid_suseda;
		poruka_za_suseda.pid = pom;
		printf("Uneti poruku za suseda: ");
		fgets(S,50,stdin);
		strcpy (poruka_za_suseda.text,S);
		msgsnd(ID,&poruka_za_suseda,sizeof(poruka_za_suseda),0);
		printf("Poslao sam poruku susedu\n");
		printf("Cekam poruku od suseda...\n");
		msgrcv(ID,&poruka_od_suseda,sizeof(poruka_od_suseda),pom,0);
		printf("Primio sam poruku od suseda: %s\n",poruka_od_suseda.text);
	}
	else
	{
		printf("Cekam poruku od suseda...\n");
		msgrcv(ID,&poruka_od_suseda,sizeof(poruka_od_suseda),pom,0);
		printf("Dobio sam poruku od suseda: %s\n",poruka_od_suseda.text);
		printf("Uneti povratnu poruku: ");
		fgets(S,50,stdin);
		poruka_za_suseda.tip = poruka_od_suseda.pid;
		poruka_za_suseda.pid = pom;
		strcpy(poruka_za_suseda.text,S);
		msgsnd(ID,&poruka_za_suseda,sizeof(poruka_za_suseda),0);
		printf("Posalo sam poruku sussedu\n");
	}

}
