#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

struct prijava
{
	long tip;
	int pid;
};

struct server
{
	long tip;
	int redni_broj;
};

struct pidovi
{
	long tip;
	int pid_suseda;
};

int main (void)
{
	key_t kljuc;
	int ID,i;
	int N;
	int niz_pidova[21];
	struct prijava prijava_klijenta;
	struct server  odgovor_za_prijavu;
	struct pidovi poruka_o_pidu_suseda;
	//Pravljenje reda za poruke:
	
	kljuc = ftok("./Zadatak2Server.c",100);
	ID = msgget (kljuc, IPC_CREAT | 0666);
	
	//Unos broja klijenata:
	
	printf("Uneti broj N\n");
	scanf("%d",&N);
	
	//Ceka N prijava:
	
	for (i = 1;i <= N;i++)
	{
		printf("Cekam prijavu od klijenta...\n");
		msgrcv (ID,&prijava_klijenta,sizeof(prijava_klijenta),1,0);   //Server prima prijavu;
		odgovor_za_prijavu.tip = prijava_klijenta.pid;					//Server vraca tacno onom klijentu koji je poslao prijavu;
		odgovor_za_prijavu.redni_broj = i;
		niz_pidova[i-1] = prijava_klijenta.pid;
		printf("Dobio sam prijavu od klijenta sa pidom %d\n",prijava_klijenta.pid);								
		msgsnd (ID,&odgovor_za_prijavu,sizeof(odgovor_za_prijavu),0);					//Server salje poruku klijentu;
		printf("Poslao sam redni broj %d klijentu sa pidom %d\n",i,prijava_klijenta.pid);	
	}
	for (i = 0;i < N;i++)
	{
		poruka_o_pidu_suseda.pid_suseda = niz_pidova[i+1];
		poruka_o_pidu_suseda.tip = niz_pidova[i];
		msgsnd (ID,&poruka_o_pidu_suseda,sizeof(poruka_o_pidu_suseda),0);
		//printf("Poslao sam klijentu sa pidom %ld da je njegov sused sa pidom %d\n",poruka_o_pidu_suseda.tip,poruka_o_pidu_suseda.pid_suseda);
	}
	
}
