#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct Poruka{
	long tip_poruke;
	int redni_broj;
	int pid_poruke;
	char tekst_poruke[100];
}poruka;

int main(){

	key_t kljuc;
	int id_reda;
	poruka moja_poruka;
	
	kljuc = ftok("./server.c", 100);
	id_reda = msgget(kljuc, IPC_CREAT | 0666);
	
	moja_poruka.tip_poruke = 1;
	moja_poruka.pid_poruke = getpid();
	moja_poruka.redni_broj = 0;
	strcpy(moja_poruka.tekst_poruke," ");
	
	printf("Hocu da se prijavim sa pidom %d\n", moja_poruka.pid_poruke);
	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),moja_poruka.pid_poruke,0);
	printf("Stigao mi je redni broj %d i pid %d\n", moja_poruka.redni_broj, moja_poruka.pid_poruke);
	
	if(moja_poruka.redni_broj%2==1){
		fgets(moja_poruka.tekst_poruke,100,stdin);
		moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke)-1] = '\0';
		printf("Poslao sam %s\n", moja_poruka.tekst_poruke);
		moja_poruka.tip_poruke = moja_poruka.redni_broj;
		moja_poruka.pid_poruke = moja_poruka.redni_broj; //skini
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),(moja_poruka.redni_broj+1),0);
		printf("Primio sam poruku %s\n", moja_poruka.tekst_poruke);
	}
	else{
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),(moja_poruka.redni_broj-1),0);
		printf("Primio sam poruku %s\n", moja_poruka.tekst_poruke);
		moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke)-1] = '\0';
		fgets(moja_poruka.tekst_poruke,100,stdin);
		moja_poruka.tip_poruke = moja_poruka.redni_broj+1;
		moja_poruka.pid_poruke = moja_poruka.redni_broj; //skini
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		printf("Poslao sam %s\n", moja_poruka.tekst_poruke);
	}


	return 0;

}
