#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

// Deklarisati potrebne globalne promenljive
int id_reda;

// Definisati potrebne strukture za razmenu poruka (može i drugačije)

typedef struct poruka_prijava
{
	long id;
	char broj[100];
}poruka_prijava;

typedef struct poruka_potez
{
	long id;
	char *tekst;
}poruka_potez;


int main() {
	key_t kljuc_reda_kom;
	poruka_prijava prijava,info_partije;
	poruka_potez potez;
	int rbr, duzina;
	char rec[100];
	
	// Povezi se na odgovarajuci red
	kljuc_reda_kom = ftok("./kostur-server.c", 11);
	id_reda = msgget(kljuc_reda_kom, IPC_CREAT|0666);
	//  Prijavi se serveru, i omogući igranje partije
	prijava.broj[0] = getpid();
	prijava.id = 50;
	msgsnd(id_reda, &prijava, sizeof(prijava), 0);
	msgrcv(id_reda, &info_partije, sizeof(info_partije), prijava.broj[0], 0);
	rbr = info_partije.broj[0];
	printf("%d\n", rbr);
	
	if (rbr%2 == 1) {
		printf("Unesi rec:\n");
		fgets(potez.tekst,sizeof(potez.tekst),stdin);
		printf("%c %c\n", potez.tekst[strlen(potez.tekst) - 3], potez.tekst[strlen(potez.tekst) - 2]);
		// Posalji poruku
		potez.id = 50 + rbr;
		msgsnd(id_reda, &potez, sizeof(potez), 0);
	}
	
	while (1) {
		// Primi poruku
		msgrcv(id_reda, &potez, sizeof(potez), rbr, 0);
		strcpy(rec, potez.tekst);
		duzina = strlen(rec);
		
		if (strcmp(rec, "pobeda")==0) {
			printf("Pobeda\n");
			exit(0);
		}
		
		if (strcmp(rec, "poraz")==0) {
			printf("Poraz\n");
			exit(0);
		}
		
		printf("Primljena rec %s\n", rec);
		
		do {
			printf("Unesi rec:\n");
			fgets(potez.tekst,sizeof(potez.tekst),stdin);
		}while(rec[duzina-3]!=potez.tekst[0] || rec[duzina-2]!=potez.tekst[1]);
		
		// Posalji poruku
		potez.id = 50 + rbr;
		msgsnd(id_reda, &potez, sizeof(potez), 0);
	}
}
	
	
