#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

typedef struct por{

		long mtype;
		char text[30];
		pid_t pid;
		int redni;
}Tporuka;
int serverID, klijentID;

int main(){
	
	Tporuka poruka;
	serverID=msgget(ftok("server.c",'S'), IPC_CREAT |0666);
	
	srand(time(NULL));
	int r = rand()%255;
	klijentID = msgget(ftok("klijent.c",r), IPC_CREAT | 0666);
	poruka.redni = klijentID;
	poruka.mtype = 1;
	
	if(msgsnd(serverID,&poruka, sizeof(Tporuka),0)==-1){
		printf("Geska u konekciji na server\n");
		exit(1);
		}
	printf("unesi poruku:\n");
	fgets(poruka.text,30,stdin);

	poruka.mtype = 2;
	if(msgsnd(klijentID,&poruka,sizeof(Tporuka),0)==-1){
		printf("Geska u konekciji na server\n");
		exit(1);
		}
		
	msgrcv(klijentID,&poruka,sizeof(Tporuka),2,0);
	printf("Primljena poruka: %s",poruka.text);	
	msgctl(klijentID,IPC_RMID,NULL);

}
