#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

pid_t pidDete;
pid_t pidRoditelj;


void myHendler1(int sig)
{
	printf("DETE: Prekid nije moguc\n");
}

void myHendler2(int sig)
{
	printf("Roditelj ubija dete\n");
	kill(pidDete, SIGKILL);
	kill(pidRoditelj, SIGKILL);
}




int main()
{
	pid_t pid;
	int n, i, r;
	
	printf("Unesi broj N: ");
	scanf("%d", &n);
	
	
	pid=fork();
	
	if(pid==-1)
	{
		printf("Greska fork!");
		exit(1);
	}
	if(pid==0)
	{
		//DETE
		
		signal(SIGINT, myHendler1);
		for(i=1;i<n;i+=2)
		{		
			printf("DETE: %d\n", i);
			r=rand() % 10;
			sleep(r);
		}
		printf("Dete zavrsilo!\n");
		exit(1);
	}
	else
	{
		//RODITELJ
		pidDete=pid;
		pidRoditelj=getpid();
		signal(SIGINT, myHendler2);
		for(i=0;i<n;i+=2)
		{
			printf("RODITELJ: %d\n", i);
			r=rand() % 10;
			sleep(1);
		}
		signal(SIGINT, SIG_IGN);
		printf("Roditelj zavrsio!\n");
		wait(0);
		
	}
	
	
	
	return 0;
}
