#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define N 6

typedef struct porukaP
{
	long tip;
	int id;
	pid_t pidP;
	int flg;
}PorukaP;


typedef struct poruka
{
	long tip;
	int id;
	char rec[100];
}Poruka;

int main()
{
	pid_t pid;
	key_t kljuc1,kljuc;
	int idReda,idReda1;
	Poruka novaP;
	PorukaP prijava;
	int i ;
	
	//red za prijavu
	kljuc1=ftok("./server.c",1);
	idReda1=msgget(kljuc,IPC_CREAT|0666);
	
	// red za poruke
	kljuc=ftok("./klijent.c",1);
	idReda=msgget(kljuc,IPC_CREAT|0666);
	
	prijava.tip=1;
	prijava.flg=0;
	while(prijava.flg==0)
	{
		pid=fork();
		switch(pid)
		{
			case -1:
			{
				printf("GRESKA\n");
				exit(0);
			}
			case 0:
				prijava.tip=1;
				prijava.pidP=getpid();
				msgsnd(idReda1,&prijava,sizeof(prijava),0);
				msgrcv(idReda1,&prijava,sizeof(prijava),getpid(),0);
			default:
				prijava.tip=1;
				prijava.pidP=getpid();
				msgsnd(idReda1,&prijava,sizeof(prijava),0);
				msgrcv(idReda1,&prijava,sizeof(prijava),getpit(),0);		
		}
	}
	
	for(i=1;i<N;i++)
	{
		if(prijava.id==i)
		{
			novaP.tip=i+1;
			fgets(novaP.rec,sizeof(novaP.rec),stdin);
			msgsnd(idReda,&novaP,sizeof(novaP.text),0);
			msgrcv(idReda,&novaP,sizeof(novaP.text),i,0);
			printf("%s\n",novaP.text);
		}
		i++;
		if(prijava.id==i)
		{
			msgrcv(idReda,&novaP,sizeof(novaP.text),i,0);
			printf("%s\n",novaP.text);
			fgets(novaP.rec,sizeof(novaP.rec),stdin);
			novaP.tip=i-1;
			msgsnd(idReda,&novaP,sizeof(novaP.text),0);
		}
	}
		
	return 0;
}
