#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

pid_t pid;
pid_t pidRoditelja;

void handler(int sig)
{
	kill(pid,SIGKILL);
	printf("DETE UBIJENO!\n");
	kill(pidRoditelja,SIGINT); //Jelica
	printf("Roditelj interupted");
}


int main()
{
	
	int n,i;
	printf("Unesi N : ");
	scanf("%d",&n);
	
	pid=fork();
	
	switch(pid)
	{
		case -1:
			{
			printf("GRESKA\n");
			exit(0);
		}
		case 0:
				signal(SIGINT,SIG_IGN);
				for(i=0;i<n;i=i+2)
					{
						printf("\nDETE %d\n",i);
						sleep(2);
					}
		default:
			pidRoditelja=getpid();
			signal(SIGINT,handler);
			for(i=1;i<n;i=i+2)
				{
					printf("\nROD: %d\n",i);
					sleep(3);
				}
	}
	return 0;
}
