#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

void sig_handler_dete(){
    printf("Prekid nije moguc");
    kill(getpid(), SIG_IGN);
}

void sig_handler_roditelj(pid_t pid){
    kill(pid, SIGKILL);
    kill(getpid(), SIGINT);
}

int main(){

    pid_t pid;

    int n,i;
    scanf("%d", &n);

    pid = fork();

    switch (pid){
        case -1:
            perror("Greska pri forkovanju");
            exit(1);
        case 0:
            signal(SIGINT, sig_handler_dete());
            for (i=1; i<n; i++){
                if (i % 2){
                    printf("%d\n", i);
                    sleep(rand() % 10);
                }
            }
        break;
        default:
            signal(SIGINT, sig_handler_roditelj(pid));
            for (i=0; i<n; i++){
                if (!(i % 2)){
                    printf("%d\n", i);
                    sleep(rand() % 10);
                }
            }
    }

    return 0;

}
