#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

pid_t pid;

void handler(int sig){
	if(pid==0){
		printf("\nPrekid nije moguc\n");
	}
	else{
		kill(pid,SIGKILL);
		exit(0);
	}
}

int main(){
	
	int n;
//jelica
	int i;
	
	scanf("%d",&n);
	
	pid=fork();
	
	if(pid == -1){
		printf("Fork greska\n");
		exit(1);
	}
	else if(pid == 0){
		signal(SIGINT,handler);
		for(i=1;i<=n;i+=2){
			printf("DETE %d: %d\n",getpid(),i);
			sleep(rand()%5);
		}
	}
	else{
		signal(SIGINT,handler);
		for(i=2;i<=n;i+=2){
			printf("RODITELJ %d: %d\n",getpid(),i);
			sleep(rand()%5);
		}
	}

	return 0;
}
