#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive

int red, red1;
int deca = 0;

//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
typedef struct poruka_prijava
{
	long type;
	char text[100];
}poruka_prijava;

typedef struct poruka_potez
{
	long type;
	char text[100];
}poruka_potez;

typedef struct poruka_partija
{
	long type;
	char text[100];
}poruka_partija;
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2) {
	poruka_potez pot;
	char rec[100];
	int duzina;
	
	pot.type = 100;
	msgrcv(red1, &pot, sizeof(pot.text), 100, 0);
	strcpy(rec, pot.text);
	duzina = strlen(pot.text);
	
	printf("%s %c%c\n", rec, rec[duzina-2], rec[duzina-1]);
	
	//TODO :  primi poruku od klijenta 
	if (rec[duzina-2]=='n' && rec[duzina-1]=='t')
	{
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
		pot.type = rbr1;
		strcpy(pot.text, "pobeda");
		msgsnd(red1, &pot, sizeof(pot.text), 0);
		pot.type = rbr2;
		strcpy(pot.text, "poraz");
		msgsnd(red1, &pot, sizeof(pot.text), 0);
		
		poruka_partija pobednik;
		
		pobednik.type = getpid();
		sprintf(pobednik.text, "%d", rbr1);
		msgsnd(red1, &pobednik, sizeof(pobednik.text), 0);
		//TODO: Upisati u red partija redni broj pobednika
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		pot.type = rbr2;
		msgsnd(red1, &pot, sizeof(pot.text), 0);
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	int parni = 0;
	int neparni = 0;
	int i;
	pid_t dete;
	poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	while(wait(&dete) && deca != 0)
	{
		pobednik.type = getpid();
		msgrcv(red1, &pobednik, sizeof(pobednik), getpid(), 0);
		deca--;
		i = atoi(pobednik.text);
		if(i % 2 == 0)
			parni++;
		else
			neparni++;
	}
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red, IPC_RMID, NULL);
	msgctl(red1, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	signal(SIGINT, sighandler);
	key_t kljuc, kljuc1;
	poruka_prijava prijava1, prijava2;
	int rbr=0;
	//int stat;
	//int rbr1, rbr2, pid_partija;
	pid_t partija;
	int flg;
	
	kljuc = ftok("./server.c", 70);
	kljuc1 = ftok("./server.c", 71);
	red = msgget(kljuc, IPC_CREAT | 0666);
	red1 = msgget(kljuc1, IPC_CREAT | 0666);
	
	printf("Begin\n");
	
	while(1) 
	{
		// TODO : Prijava klijenta, fork, igra
		msgrcv(red, &prijava1, sizeof(prijava1.text), 70, 0);
		prijava1.type = atoi(prijava1.text);
		sprintf(prijava1.text, "%d", ++rbr);
		msgrcv(red, &prijava2, sizeof(prijava2.text), 70, 0);
		prijava2.type = atoi(prijava2.text);
		sprintf(prijava2.text, "%d", ++rbr);
		msgsnd(red, &prijava1, sizeof(prijava1.text), 0);
		msgsnd(red, &prijava2, sizeof(prijava2.text), 0);
		deca += 2;
		
		partija = fork();
		switch(partija)
		{
			case 0:
				
				do
				{
					flg = proveri_rec(rbr-1, rbr);
					if(!flg)
						proveri_rec(rbr, rbr-1);
				}while(!flg);
				break;
		}
		
		
	}
	
	
	
	return 0;
}
// Ne zaboravite signale :) 
