#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

pid_t pid;


void signal_handler(int sig) {
    if(pid == 0) {
        printf("Child: Cant be interupted!\n");
    }
    else if(pid > 0) {
        printf("Parent: Sending SIGKILL to child and executing default SIGINT action!\n");
        kill(pid, SIGKILL);
        exit(0);
    }
}

int main() {
    int n; 

    scanf("%d", &n);
    
    printf("Parent: N = %d\n", n);
    printf("Parent: Creating child!\n");

    signal(SIGINT, signal_handler);
    
    pid = fork();
    
    


    if(pid == 0) {
        for(int i = 1; i < n; i = i+2) {
            printf("Child: Writing number: %d\n", i);
            sleep(rand() % 10);
        }
         printf("Child: Finishing!");

    }
    else if(pid > 0) {
        for(int i = 0; i < n; i = i + 2) {
            printf("Parent: Writing number: %d\n", i);
            sleep(rand() % 10);
        }
        printf("Parent: Finishing!");
    }
    else if(pid == -1) {
        printf("Parent: Failed to create child!\n");
        return(0);
    }

    return(1);
}