#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>



struct msg
{
	long type;
    pid_t pid;
    int id;
    char* poruka;
};

struct msg msg;


int main() {
    int n = 5;
    key_t key = ftok("./zadatak2-server-laksi.c", 56);
    
    int msgqid = msgget(key, IPC_CREAT|0666);
    msg.type = 123456;
    msg.pid = getpid();

    if(msgqid != -1) {
        msgsnd(msgqid, &msg, sizeof(msg), 0);
        printf("Poslao poruku server-u!\n");
        msgrcv(msgqid, &msg, sizeof(msg), getpid(), 0);
        printf("Primio redni broj od servera: %d\n", msg.id);

        while(1) {
            if(msg.id % 2 == 0) {
                // ne znam da ucitam string sa stdin-a :)
                msg.type = msg.id + 1;
                msg.pid = getpid();
                msg.poruka = "Cao parni\n";
                msgsnd(msgqid, &msg, sizeof(msg), 0);
                msgrcv(msgqid, &msg, sizeof(msg), msg.id, 0);
                printf("Poruka od neparnog: %s", msg.poruka);
                exit(0);
            }
            else {
                msgrcv(msgqid, &msg, sizeof(msg), msg.id, 0);
                printf("POruka od parnog: %s", msg.poruka);
                msg.poruka = "Odgovor neparni!\n";
                msg.type = msg.id - 1;
                msgsnd(msgqid, &msg, sizeof(msg), 0);
                exit(0);
            }
        }
    }

    return(1);
}