#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>
#include <time.h>

void ignore_signal(int sig) {
    printf("Prekid nije moguc\n");
}

pid_t pid = -1;

void signal_handler(int sig) {
	// Jelica
	printf("Test test test \n");
    if (pid != -1) {
        kill(pid, SIGKILL);
    }

    exit(0);
}

int main() {
    
    int n,i;
    printf("Enter number N:\n");
    scanf("%d", &n);


    pid = fork();
    srand(getpid());

    if (pid == -1) {
        perror("Unable to fork process");
        exit(1);
    } else if (pid == 0) {
        // child
        signal(SIGINT, ignore_signal);

        for (i = 0; i < n; i++) {
            if (i % 2 == 1) {
                printf("[CHILD PROCES %d] %d\n", getpid(), i);
                sleep(rand() % 10 + 1);
            }
        }
    } else {
        // father
        signal(SIGINT, signal_handler);

        for (i = 0; i < n; i++) {
            if (i % 2 == 0) {
                printf("[PROCES %d] %d\n", getpid(), i);
                sleep(rand() % 10 + 1);
            }
        }
    }

    return 0;
}
