#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive
int partija = 1;
int neparni = 0, parni = 0;

//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long tip;
	int rb; 
};

struct poruka_potez
{
	long tip;
	char rec[50];
};

struct poruka_partija
{
	long tip;
	int pidPartije;
	int pobednikPartije; // 1 neparni 2 parni
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2, int red_info_id, int red_kom_id) {
	struct poruka_potez pot;
	char rec[100];
	int duzina;
	//TODO :  primi poruku od klijenta 
	int pom, indikator = 0;
	int m; //ciji je potez- 1 za neparan, 2 za paran
	m = rbr1%2; // 1 
	pom = msgrcv(red_kom_id, &pot, sizeof(pot), 1, 0);//ako je prazan rbr2
	//if(pom == -1)
	//{	indikator = 1; //ovo znaci da je uzeo poruku rbr2
//		pom = msgrcv(red_kom_id, &pot, sizeof(pot), 2 , IPC_NOWAIT);
	//}
	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
	

		if(indikator == 0)
		{
			pot.tip = 1;
			strcpy(pot.rec, "pobeda");
			msgsnd(red_kom_id, &pot, sizeof(pot), 0);
			pot.tip = 2;
			strcpy(pot.rec, "poraz");
			msgsnd(red_kom_id, &pot, sizeof(pot), 0);
		}
		else
		{
			pot.tip = 2;
			strcpy(pot.rec, "pobeda");
			msgsnd(red_kom_id, &pot, sizeof(pot), 0);
			pot.tip = 1;
			strcpy(pot.rec, "poraz");
			msgsnd(red_kom_id, &pot, sizeof(pot), 0);
		}
			
		struct poruka_partija pobednik;
		//TODO: Upisati u red partija redni broj pobednika
		pobednik.tip = 1;
		if(pot.tip == 1)
			pobednik.pobednikPartije = rbr2;
		else
			pobednik.pobednikPartije = rbr1;
		msgsnd(red_info_id, &pobednik, sizeof(pobednik), 0);
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		pot.tip = rbr1%2 + 1;
		msgsnd(red_kom_id, &pot, sizeof(pot),0);
		return 0; // partija još uvek traje
	}
}

/*
void sighandler(int sig) {
	int parni = 0;
	int neparni = 0;
	int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red_kom_id, IPC_RMID, NULL);
	msgctl(red_info_id, IPC_RMID, NULL);
	exit(0);
}
*/
int main() {
	key_t kljuc_reda_kom, kljuc_reda_info;
	struct poruka_prijava prijava1, prijava2;
	struct poruka_potez potez;
	struct poruka_partija porPartija;
	int rbr=0; //redni broj runde?
	int stat;
	int rbr1 = 1, rbr2 = 2, pid_partija;
	int red_kom_id, red_info_id;
	porPartija.tip = 1;
	// TODO : Kreiraj redove
	kljuc_reda_kom = ftok("./kostur-server.c", 32);
	kljuc_reda_info = ftok("./kostur-server.c", 23);
	red_kom_id = msgget(kljuc_reda_kom, IPC_CREAT|0666); // red za komunikaciju
	red_info_id = msgget(kljuc_reda_info, IPC_CREAT|0666);// red za cuvanje informacija o odigranim partijama
	
	printf("kreirani redovi\n");
	while(1) {
		// TODO : Prijava klijenta, fork, igra
		msgrcv(red_kom_id, &prijava1, sizeof(prijava1), 1, 0);
		msgrcv(red_kom_id, &prijava2, sizeof(prijava2), 1, 0);
		
		prijava1.rb = rbr1;
		prijava2.rb = rbr2;
		prijava1.tip = prijava2.tip = 2;
		msgsnd(red_kom_id, &prijava1, sizeof(prijava1), 0);
		msgsnd(red_kom_id, &prijava2, sizeof(prijava2), 0);

		porPartija.pidPartije = fork();
		int ind;
		if(porPartija.pidPartije == 0)
		{
			printf("registrujem reci\n");
			do
			{
				ind = proveri_rec(rbr1, rbr2, red_info_id, red_kom_id);
			}while(!ind);
				
		}
		
		
		
	}
	return 0;
}
// Ne zaboravite signale :) 
