#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct Poruka_s{
	long tip;
	char tekst[30];
	pid_t pid;
	int redni_broj;
}Poruka;

//Prvo se pokrene broj(paran) klijenata, pa se server pokrene.

void main()
{
	int br, n, red1, red2, pv;
	key_t kljuc1, kljuc2;
	Poruka salji, primi;

//	printf("Uneti N: ");
//	scanf("%d", &n);

	kljuc1 = ftok("./klijent.c", 60);
	red1 = msgget(kljuc1, IPC_CREAT|0666);
	kljuc2 = ftok("./server.c", 70);
	red2 = msgget(kljuc2, IPC_CREAT|0666);
	
	br = 1;
	pv = msgrcv(red1, &primi, sizeof(primi), 1, IPC_NOWAIT);
	while(pv != -1)
	{
		salji.tip = primi.pid;
		salji.redni_broj = br;
		++br;

		pv = msgsnd(red2, &salji, sizeof(salji), 0);
		if(pv == -1)
		{
			printf("Greska pri slanju poruke!\n");
			exit(0);
		}

		sleep(2);
		pv = msgrcv(red1, &primi, sizeof(primi), 1, IPC_NOWAIT);
	}
	printf("Proces server je zavrsio!\n");
}
