#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>


typedef struct _msgbuf{
	long tip;
	int redniBroj;
	pid_t pid;
	char tekst[30];
} msgbuf;

int main(){
	key_t key = ftok("./klijent.c", 69);
	int idReda = msgget(key, IPC_CREAT|0666);
	msgbuf poruka;
	poruka.tip = 1;
	poruka.pid = getpid();
	
	msgsnd(idReda, &poruka, sizeof(poruka), 0);
	
	poruka.tip = poruka.pid;// printf("moj tip %d\n", poruka.tip);
	msgrcv(idReda, &poruka, sizeof(poruka), poruka.tip, 0);
	printf("Redni broj: %d\n", poruka.redniBroj);

	if(poruka.redniBroj % 2 != 0){
		printf("Unesi poruku: "); fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
		poruka.tip = poruka.redniBroj +1;
		//printf("saljem tipu: %d\n", poruka.tip);
		msgsnd(idReda, &poruka, sizeof(poruka), 0); 
		
		poruka.tip = poruka.redniBroj; 
		//printf("primam sa tipom: %d\n", poruka.tip);
		msgrcv(idReda, &poruka, sizeof(poruka), poruka.tip, 0);
		printf("Primljena poruka: %s\n", poruka.tekst);
	} else if(poruka.redniBroj % 2 == 0){
		poruka.tip = poruka.redniBroj;
		//printf("primam sa tipom: %d\n", poruka.tip);
		msgrcv(idReda, &poruka, sizeof(poruka), poruka.tip, 0);
		printf("Primljena poruka: %s\n", poruka.tekst);
		
		poruka.tip = poruka.redniBroj;
		//printf("saljem tipu: %d\n", poruka.tip);
		printf("Unesi poruku: "); fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
		msgsnd(idReda, &poruka, sizeof(poruka), 0);
	}
	
	return 0;
}
