#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

void izbrisiSemafor(int sig)
{
	printf("Primio sam CTRL+C, prekidam program\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
	
	printf("Zavrsavam\n");
	exit(0);
}

int main()
{

	
	

	
	
	srand(time(NULL));
	
	key_t key;
	union semun operacija;
	struct sembuf P,V;
	int karta;
	
	key=ftok("prvi.c",'P');
	int shmid1,shmid2,shmid3;
	shmid1=shmget(key,sizeof(int),0644|IPC_CREAT);
	key=ftok("prvi.c",'T');
	shmid2=shmget(key,sizeof(int),0644|IPC_CREAT);
	int *znak,*broj;
	znak=(int*)shmat(shmid1,NULL,0);
	broj=(int*)shmat(shmid2,NULL,0);

	//	
	int *ind;
	key=ftok("prvi.c",'D');
	shmid3=shmget(key,sizeof(int),0644|IPC_CREAT);
	ind=(int*)shmat(shmid3,NULL,0);
	*ind=0;
//	
	
	
	key=ftok("prvi.c",'A');
	semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	
	signal(SIGINT,izbrisiSemafor);
	if(semid!=-1)
	{
		operacija.val=1;
		semctl(semid,0,SETVAL,operacija);
		
		operacija.val=0;
		semctl(semid,1,SETVAL,operacija);
		
		operacija.val=0;
		semctl(semid,2,SETVAL,operacija);
		
		operacija.val=0;
		semctl(semid,3,SETVAL,operacija);
		
	}
	else if (errno==EEXIST)
	{
		printf("Neko drugi je kreirao i inicijalizovao semafor, ja se samo povezujem\n");
		semid=semget(key,4,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(0);
	}
	
	P.sem_num=3;
	P.sem_op=-1;
	P.sem_flg=0;
	
	V.sem_num=0;
	V.sem_op=1;
	V.sem_flg=0;
	
	
	int i,br,zn;
	while(1)
	{
		semop(semid,&P,1);
		br=rand()%14;
		zn=rand()%4;
		printf("Izvucena karta: br:%d zn:%d\n",br,zn);
		printf("Deljena memorija: broj: %d, znak: %d\n",*broj,*znak);
		if(br==*broj || zn==*znak)
		{
			*broj=br;
			*znak=zn;
			
			//			
			if(*broj==8)
				if(*ind==0)
						*ind=1;
				else
					*ind=0;
				
			if(*ind==0)
			{
				P.sem_num=0;
				P.sem_op=-1;
				P.sem_flg=0;
	
				V.sem_num=1;
				V.sem_op=1;
				V.sem_flg=0;
			}
			else
			{
				P.sem_num=1;
				P.sem_op=-1;
				P.sem_flg=0;
	
				V.sem_num=0;
				V.sem_op=1;
				V.sem_flg=0;
}
//				
		}
		else 
			printf("Nemam adekvatnu kartu\n");
		
		sleep(2);
		printf("\n");
		semop(semid,&V,1);
	}
	
	shmdt(znak);
	shmdt(broj);
	return 0;
}

