#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{

	key_t key;
	int ind;
	int semid;
	int br = 0,n;
	
	struct sembuf opr_V, opr_P;
	union semun op_nad_sem;
	
	key = ("igrac1.c", 'A');
	semid = semget(key,4,0666|IPC_CREAT|IPC_EXCL);

	if(semid != -1)
	{
		op_nad_sem.val = 1;
		semctl(semid,0,SETVAL,op_nad_sem);
		op_nad_sem.val = 0;
		semctl(semid,1,SETVAL,op_nad_sem);
		op_nad_sem.val = 0;
		semctl(semid,2,SETVAL,op_nad_sem);
		op_nad_sem.val = 0;
		semctl(semid,3,SETVAL,op_nad_sem);
	}

	else if(errno == EEXIST)
	{
		semid = semget(key,4,0);
	}

	else
	{
		printf("Greska!\n");
		exit(0);
	}

	opr_P.sem_num = 3;
	opr_P.sem_op = -1;
	opr_P.sem_flg = 0;

	opr_V.sem_num = 0;
	opr_V.sem_op = 1;
	opr_V.sem_flg = 0;

	srand(time(NULL));

	while(br<6)
	{
		ind = semop(semid,&opr_P,1);
			if(ind == -1) break;
		br++;
		n = rand() % 15;
		if(n == 0)
		   n = 1;
		printf("%d\n",n);
		ind = semop(semid,&opr_V,1);
			if(ind == -1) break;
		sleep(2);
		
	}

} 

