#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


int main()
{
	key_t key;
	int semid;
	struct sembuf P;
	struct sembuf V;
	
	key = ftok("igrac1.c", 'R');
	
	semid = semget(key, 4, 0644 | IPC_CREAT);
	
	if(semid == -1)
	{
		printf("NIJE MOGUCE KREIRATI SEMAFORE\n");
		exit(1);
	}
	
	V.sem_num = 2;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	P.sem_num = 2;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	srand(time(NULL));
	
	for(int i = 0; i < 6; i++)
	{
		semop(semid, &V, 2);
		
		printf("IGRAC 3: %d\n", rand() % 15);
		
		semop(semid, &P, 1);
	}
	
	semctl(semid, 2, IPC_RMID);
	
	return 0;
}
