#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid,shmid;

union semun
{
	int val;				//SETVAL
	struct semid_ds *buf;	//IPC_STAT and IPC_SET
	ushort *array;			//GETALL and SETALL
};

int main()
{
	
	
	key_t k2=ftok("./treci.c",'r');
	int izbrojao=shmget(k2,sizeof(int),0666|IPC_CREAT);
	int *red=shmat(izbrojao,NULL,0);
	srand(time(NULL));
	int *talonBroj,*talonZnak;
	int igracBroj,igracZnak;
	union semun arg;
	struct sembuf p,s,s1;
	key_t kljuc=ftok("./prvi.c",'r');
	key_t kljuc1=ftok("./drugi.c",'r');
	int sh=shmget(kljuc1,sizeof(int),0666|IPC_CREAT);
	shmid=shmget(kljuc,sizeof(int),0666|IPC_CREAT);
	talonBroj=shmat(shmid,NULL,0);
	talonZnak=shmat(sh,NULL,0);
	semid=semget(kljuc,4,0666|IPC_CREAT|IPC_EXCL);
	if(semid==-1)
	{
		semid=semget(kljuc,4,0);
	}
	else
	{
		arg.val=1;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);
		semctl(semid,2,SETVAL,arg);
		semctl(semid,3,SETVAL,arg);
	}
	
	*talonBroj=rand()%14;
	*talonZnak=rand()%4;
	
	p.sem_num=0;
	p.sem_op=-1;
	p.sem_flg=0;
	
	s.sem_num=1;
	s.sem_op=1;
	s.sem_flg=0;
	
	s1.sem_num=3;
	s1.sem_op=1;
	s1.sem_flg=0;
	
	int i=0;
	
	while(1)
	{
		printf("%d krug\n",i);
		i++;
		igracBroj=rand()%14;
		igracZnak=rand()%4;
		if(igracBroj == *talonBroj || igracZnak == *talonZnak)
		{
			printf("%d %d %d %d pogodak\n",igracBroj,igracZnak,*talonBroj,*talonZnak);
			*talonBroj=igracBroj;
			*talonZnak=igracZnak;
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
			printf("%d %d %d %d\n",igracBroj,igracZnak,*talonBroj,*talonZnak);
		}
		semop(semid,&p,1);
		sleep(1);
		if(*talonBroj==7)
		{
			*red+=1;
		}
		if(*red%2)
		{
			semop(semid,&s1,1);
		}
		else semop(semid,&s,1);
	}
	shmdt(talonZnak);
	shmdt(talonBroj);
}
