#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef union unija{
	int val;
	struct semid_ds *buf;
	ushort *array;
}semun;

int main(){
	
	srand(time(NULL));
	
	key_t kljuc;
	int semid, shmid, k, z;
	int *karta, *znak, *indikator;
	semun arg;
	struct sembuf smanji, povecaj1, povecaj2;
	
	kljuc = ftok("./igrac1.c", 'R');
	shmid = shmget(kljuc, 3*sizeof(int), 0644 | IPC_CREAT);
	
	kljuc = ftok("./igrac1.c", 'A');
	semid = semget(kljuc, 4, 0666 | IPC_CREAT | IPC_EXCL);
	
	karta = (int*)shmat(shmid,NULL,0);
	znak = ((int*)shmat(shmid,NULL,0)) + 1;
	indikator = ((int*)shmat(shmid,NULL,0)) + 2;
	
	*indikator = 0; //nula je za redosled 1 2 3 4 a jedinica za obrnuti redosled
	
	if(semid != -1){
		arg.val = 0;
		semctl(semid, 0, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 1, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 2, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 3, SETVAL, arg);
	}
	else if(errno == EEXIST){
		semid = semget(kljuc,4,0);
	}
	else{
		printf("Greska!\n");
		exit(0);
	}
	
	smanji.sem_num = 0;
	smanji.sem_op = -1;
	smanji.sem_flg = 0;
	
	povecaj1.sem_num = 1;
	povecaj1.sem_op = 1;
	povecaj1.sem_flg = 0;
	
	povecaj2.sem_num = 3;
	povecaj2.sem_op = 1;
	povecaj2.sem_flg = 0;
	
	int prazan = 0;
	
	for( ; ; ){		
		k = rand()%14;
		z = rand()%4;
		//*karta = k;
		//*znak = z;
		
		//ako je ovo prvo izvlacenje
		if(prazan==0){
			printf("Prvi put sam izvukao kartu broj %d\n", k+1);
			if(z == 0){
				printf("Prvi put sam izvukao kartu znaka karo\n");
			}
			else if(z == 1){
				printf("Prvi put sam izvukao kartu znaka pik\n");
			}
			else if(z == 2){
				printf("Prvi put sam izvukao kartu znaka tref\n");
			}
			else{
				printf("Prvi put sam izvukao kartu znaka herc\n");
			}
			*karta = k;
			*znak = z;
			prazan  = 1;
			
			if(k == 8){
				semop(semid,&povecaj2,1);
				*indikator = 1;
			}
			else{
				semop(semid,&povecaj1,1);
				*indikator = 0;
			}
			sleep(3);
		}
		else{
				printf("Izvukao sam kartu broj %d\n", k+1);
				if(z == 0){
				printf("Izvukao sam kartu znaka karo\n");
				}
				else if(z == 1){
					printf("Izvukao sam kartu znaka pik\n");
				}
				else if(z == 2){
					printf("Izvukao sam kartu znaka tref\n");
				}
				else{
					printf("Izvukao sam kartu znaka herc\n");
				}
				
				if(*indikator == 0)
				{
				if(k==*karta || z==*znak){
					*karta = k;
					*znak = z;
					printf("Poklopio sam\n");
					if(k==8){
						semop(semid,&povecaj2,1);
						*indikator = 1;
						sleep(3);
					}
					else{
						semop(semid,&povecaj1,1);
						//*indikator = 0;
						sleep(3);
					}
				}
				else{
					printf("Nisam poklopio\n");
					semop(semid,&povecaj1,1);
					//*indikator = 0;
					sleep(3);
				}
				}
				else{
					if(k==*karta || z==*znak){
					*karta = k;
					*znak = z;
					printf("Poklopio sam\n");
					if(k==8){
						semop(semid,&povecaj1,1);
						*indikator = 0;
						sleep(3);
					}
					else{
						semop(semid,&povecaj2,1);
						//*indikator = 0;
						sleep(3);
					}
				}
				else{
					printf("Nisam poklopio\n");
					semop(semid,&povecaj2,1);
					//*indikator = 0;
					sleep(3);
				}
				}			
			
			
		}
		/*
		//pocetak ifa
		if(*karta == 8){ //da li je karta 8
			*indikator  = 1; 

			if(prazan==0){ // ako je ovo prvo izvlacenje
				printf("Prvi put sam izvukao kartu broj 8\n");
				prazan = 1;
			}
			else{
				printf("Izvukao sam kartu broj 8\n");
			}
			
			if()
			
			semop(semid,&povecaj2,1);
		
		} //kraj ifa
		else{ //ako karta nije 8
			*indikator = 0;
			
			if(prazan==0){ //ako je ovo prvo izvlacenje
				if(*karta==10){
					printf("Prvi put sam izvukao kartu broj 11, a to je 1\n");
				}
				else{
					printf("Prvi put sam izvukao kartu broj %d\n", *karta + 1);
				}
				prazan = 1;
			}
			
			
			if(*karta==10){
				printf("Izvukao sam kartu broj 11, a to je 1\n");
			}
			else{
				printf("Izvukao sam kartu broj %d\n", *karta + 1);
			}
			
			semop(semid,&povecaj1,1);
			
		}
		//kraj elsa
		*/
		sleep(3);
		semop(semid,&smanji,1);
	}
	
	shmdt(karta);
	shmdt(znak);
	shmdt(indikator);
	
	return 0;

}
