#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

struct karta {
	int br; // 1-14
	int znak;
	int smer;
};

int main() {
	srand(time(NULL));
	
	key_t key;
	//union semun arg;
	int shmid, semid;
	struct sembuf T, C, talon;
	struct karta *pocetna, moja;
	
	key = ftok("./Zadatak2_init.c", 'A');
	printf("Kljuc je %d\n", key);
	
	shmid = shmget(key, SHM_SIZE * sizeof(int), 0644 | IPC_CREAT);
	printf("ID segmenta je %d\n", shmid);
	
	pocetna = shmat(shmid, NULL, 0);
	
	key = ftok("./Zadatak2_init.c", 'B');
	printf("Kljuc semafora je %d\n", key);
	
	semid = semget(key, 5, 0644 | IPC_CREAT);
	printf("ID semafora je %d\n", semid);
	
	T.sem_num = 2;
	T.sem_op = 1;
	T.sem_flg = 0;
	
	C.sem_num = 3;
	C.sem_op = -1;
	C.sem_flg = 0;
	
	talon.sem_num = 4;
	talon.sem_op = 1;
	talon.sem_flg = 0;
	
	while(1) {
		semop(semid, &C, 1);
		
		moja.br = (rand() % 14) + 1;
		
		moja.znak = rand() % 4;
		
		printf("Igrac 4, moja karta %d %d\n", moja.br, moja.znak);
		printf("Pocetna %d %d\n", pocetna->br, pocetna->znak);
				  
		if(moja.znak == pocetna->znak || (moja.br == pocetna->br && moja.br != 8)) {
			pocetna->br = moja.br;
			pocetna->znak = moja.znak;
			printf("Pocetna je sada %d %d\n", pocetna->br, pocetna->znak);
		}
		else
			printf("Nemam adekvatnu kartu\n");
		
		if(pocetna->br == 8 && moja.br == 8) {
			printf("Okrenut smer\n");
			pocetna->smer = 1;
			sleep(2);
			semop(semid, &T, 1);
		}
		else if(pocetna->br == 8 && pocetna->znak == moja.znak) {
				pocetna->smer = 0;
				sleep(2);
				semop(semid, &T, 1);
		}
			else {
				sleep(2);
				semop(semid, &talon, 1);
			}
	}
}
