//ZADATAK 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;

union semun {

int val;
struct semid_ds *buf;
ushort *array;

};

void izbrisiSemafor()
{
	printf("\nIgraci su se posvadjali i igra je prekinuta\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
}

int main()
{
	key_t key;
	int ind;
	int karta;
	int br = 6,brr = 0;
	
	key = ftok("Ivan_Ljubisavljevic",'A');
	
	semid = semget(key, 4, 0644 | IPC_CREAT | IPC_EXCL);
	
	struct sembuf opr_p, opr_v;
	union semun arg;
	
	signal(SIGINT, izbrisiSemafor);
	
	
	if(semid != -1)
	{
		arg.val = 0;
		semctl(semid, 0, SETVAL, arg);
		arg.val = 1;
		semctl(semid, 1, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 2, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 3, SETVAL, arg);
	}
	else if(errno == EEXIST)
		semid = semget(key, 4, 0);
	else
	{	
		printf("Neka druga greska!\n");
		exit(0);
	}
	
	opr_p.sem_num = 1;
	opr_p.sem_op = -1;
	opr_p.sem_flg = 0;
	
	opr_v.sem_num = 2;
	opr_v.sem_op = 1;
	opr_v.sem_flg = 0;
	
	
	while(br)
	{
		ind = semop(semid, &opr_p, 1);
		--br;
		
		if(ind == -1)
		{
		
			
			break;
		}

		srand(time(NULL));
		karta = (rand() % 14)+1;
		
		printf("Igrac2 izvukao kartu: %d\n", karta);
		brr++;
		sleep(1);
		
		ind = semop(semid, &opr_v, 1);
		
		if(ind == -1)
		{
		
			if(brr!=6)
			{
				srand(time(NULL));
				karta = (rand() % 14)+1;
				
				printf("Igrac2 izvukao kartu: %d\n", karta);
			}
			break;
		}
		
	}
	if(!br)
	{
		sleep(1);
		printf("Zavrsio sam igru i izvukao sam 6 karata\n");
		semctl(semid,1,IPC_RMID);
		sleep(1);
	}
}
