#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int *k;
int *z;

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid,shmid1,shmid2;


void izbrisiSemafor(int sig)
{
	printf("Uhvacen SIGINT\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);

	shmdt(k);
	shmdt(z);
	shmctl(shmid1,IPC_RMID,NULL);
	shmctl(shmid2,IPC_RMID,NULL);
	
}

int main()
{
	srand(time(NULL));
	key_t kljuc;
	union semun operacija_nad_sem;
	struct sembuf i1,i2,i3,i4;
	signal(SIGINT,izbrisiSemafor);
	
	kljuc=ftok("zad1.c",2);
	shmid1=shmget(kljuc,sizeof(int),0644|IPC_CREAT);
	k=shmat(shmid1,NULL,0);
	
	kljuc=ftok("zad1.c",3);
	shmid2=shmget(kljuc,sizeof(int),0644|IPC_CREAT);
	z=shmat(shmid2,NULL,0);
	
	kljuc=ftok("zad.c",10);
	semid=semget(kljuc,4,0644|IPC_CREAT|IPC_EXCL);
	


	
	if(semid!=-1)
	{
		printf("Ja kreiram semafor\n");
		operacija_nad_sem.val=1;
		semctl(semid,0,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,1,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,2,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,3,SETVAL,operacija_nad_sem);
	}
	else if(errno==EEXIST)
	{
		printf("Semafor vec postoji\n");
		semid=semget(kljuc,4,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(0);
	}
	
	

	i1.sem_num=0;
	i1.sem_op=-1;
	i1.sem_flg=0;
	
	i2.sem_num=1;
	i2.sem_op=1;
	i2.sem_flg=0;
	
	i3.sem_num=2;
	i3.sem_op=-1;
	i3.sem_flg=0;
	
	i4.sem_num=3;
	i4.sem_op=1;
	i4.sem_flg=0;


	
	int ind,karta,znak,pom;
	while(1)
	{
		pom=0;
		ind=semop(semid,&i3,1);
		if(ind!=-1) break;
		
		karta=rand()%14;
		if(karta==0) karta=14;
		
		znak=rand()%4;

		sleep(1);
		
		if((*k)==karta || (*z)==znak )
		{
			printf("Igrac 3: kartu %d %d poklapam kartom %d %d\n", *k,*z,karta,znak);
			(*k)=karta;
			(*z)=znak;
			pom=karta;
		}
		else
		{
			printf("Nemam kartu\n");
			
			
		}
				if(pom==8)
			{
				ind=semop(semid,&i2,1);
			}
			else
			{
				ind=semop(semid,&i4,1);
				
			}
		
	
		
	    if(ind!=-1) break;
		
		return 0;
		
		
		
		
		
	}
	
	
}
