#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun 
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid, shmid;
int* data;

void handler( int sig )
{
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	shmdt(data);
	shmctl(shmid, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	key_t kljuc;
	int karta, znak, ind;
	union semun op;
	struct sembuf p, v;
	
	signal( SIGINT, handler );
	kljuc = ftok("./igrac1.c",'B');
	shmid = shmget( kljuc, 3*sizeof(int), 0666 | IPC_CREAT );
	data = shmat( shmid, NULL, 0 );
	
	kljuc = ftok("./igrac1.c",'A');
	semid = semget(kljuc, 4, 0666 | IPC_CREAT | IPC_EXCL );
	
	if( semid != -1 )
	{
		data[0] = random() % 13 + 1;
		data[1] = random() % 4;
		if( data[0] != 8 )
			data[2] = 1;
		else
			data[2] = 0;
		printf("Talon: broj %d, znak %d\n",data[0], data[1]);
		op.val = 1;
		semctl( semid, 0, SETVAL, op );
		op.val = 0;
		semctl( semid, 1, SETVAL, op );
		op.val = 0;
		semctl( semid, 2, SETVAL, op );
		op.val = 0;
		semctl( semid, 3, SETVAL, op );
	}
	else if( errno == EEXIST )
		semid = semget( kljuc, 4, 0 );
	
	p.sem_num = 0;
	p.sem_op = -1;
	p.sem_flg = 0;
	
	v.sem_num = 1;
	v.sem_op = 1;
	v.sem_flg = 0;
	
	srand(time(NULL));
	
	while( 1 )
	{
		ind = semop( semid, &p, 1 );
		if( ind == -1 )
		{
			shmdt(data);
			exit(0);
		}
		karta =  random()%13 + 1;
		znak = random()%4;
		printf("Moja karta %d, znak %d\n",karta,znak);
		if( data[0] == karta || data[1] == znak )
		{
			printf("Poklapam kartu\n");
			data[0] = karta;
			data[1] = znak;
			if( data[0] == 8 )
			{
				if( data[2] == 0 )
					data[2] = 1;
				else
					data[2] = 0;
			}
		}
		else
			printf("Nemam adekvatnu kartu\n");
		if( data[2] == 0 )
		{
			v.sem_num = 3;
			v.sem_op = 1;
			v.sem_flg = 0;
		}
		else
		{
			v.sem_num = 1;
			v.sem_op = 1;
			v.sem_flg = 0;
		}
		sleep(2);
		ind = semop( semid, &v, 1 );
		if( ind == -1 )
		{
			shmdt(data);
			exit(0);
		}
		sleep(1);
	}
	
}






















