#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define N 2


int shmid1, shmid2, shmid3, semid;
int *smer, *karta, *znak;
struct sembuf P_spil, V_igrac1, V_igrac4;

#define P semop(semid, &P_spil, 1)
#define V1 semop(semid, &V_igrac1, 1)
#define V4 semop(semid, &V_igrac4, 1)


union semun {
	int val;
	struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */
	ushort *array;
};


void kraj(int sig)
{
	printf("KRAJ\n");
	for(int i=0; i<5; i++)
		semctl(semid, i, IPC_RMID);
	shmctl(shmid1, IPC_RMID, NULL);
	shmctl(shmid2, IPC_RMID, NULL);
	shmctl(shmid3, IPC_RMID, NULL);
	
	exit(1);
}


int main()
{
	key_t kljuc;
	time_t t1, t2;
	union semun poc;
	srand(time(NULL));
	
	signal(SIGINT, kraj);
	
	kljuc = ftok("./spil.c", 'A');
	printf("kljuc %d\n", kljuc);
	shmid1 = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
	printf("shmid1 %d\n", shmid1);
	
	kljuc = ftok("./spil.c", 'B');
	shmid2 = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
	printf("shmid2 %d\n", shmid2);
	
	kljuc = ftok("./spil.c", 'V');
	shmid3 = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
	printf("shmid3 %d\n", shmid3);
	
	kljuc = ftok("./spil.c", 'C');
	semid = semget(kljuc, 5, 0666 | IPC_CREAT | IPC_EXCL);
	printf("semid %d\n", semid);
	
	if(semid != -1)
	{
		printf("kreiran semafor %d\n", semid);
		poc.val = 1;
		semctl(semid, 0, SETVAL, poc);
		poc.val = 0;
		for(int i=1; i<5; i++)
			semctl(semid, i, SETVAL, poc);
	}
	else if(errno == EEXIST)
	{
		semid = semget(kljuc, 5, 0);
		printf("prikacio se na semafor %d\n", semid);
	}
	else
	{
		printf("GRESKA\n");
		exit(1);
	}
	
	smer = shmat(shmid1, (int *)NULL, 0);
	karta = shmat(shmid2, (int *)NULL, 0);
	znak = shmat(shmid3, (int *)NULL, 0);
	

	*smer = 1;
	
	*karta = rand() % 14 + 1;
	sleep(1);
	*znak = rand() % 4 + 1;
	
	printf("karta: %d, ", *karta);
	printf("znak: ");
	
	switch(*znak)
	{
		case 1:
			printf("karo\n");
			break;
		case 2:
			printf("pik\n");
			break;
		case 3:
			printf("tref\n");
			break;
		case 4:
			printf("herc\n");
		}
	
	
	if(*karta == 8)
		*smer = -1;
		
	
	
	P_spil.sem_num = 0;
	P_spil.sem_op = -1;
	P_spil.sem_flg = 0;
	
	V_igrac1.sem_num = 1;
	V_igrac1.sem_op = 1;
	V_igrac1.sem_flg = 0;
	
	V_igrac4.sem_num = 4;
	V_igrac4.sem_op = 1;
	V_igrac4.sem_flg = 0;
	
	P;
	V1;
	
	int ind;
	while(1)
	{
		ind = P;
		if(ind == -1)  break;
		
		sleep(2);
		
		printf("karta: %d\n", *karta);
		printf("znak: %d\n", *znak);
		
		if(*karta == 8)
			*smer *= -1;
		
		if(*smer == -1)
		{
			printf("smer: levo\n");
			ind = V4;
			if(ind == -1)  break;
		}
		else
		{
			printf("smer: desno\n");
			ind = V1;
			if(ind == -1)  break;
		}

	}	
	
}









