#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semnum
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

void izbrisiSemafore()
{
	printf("Brisem semafore!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	printf("Semafori su izbrisani!\n");
	exit(0);
}

struct karta
{
	int broj;
	char znak[10];
};

void nadjiZnak(int br, struct karta *k)
{
	if(br == 1)
		strcpy(k->znak, "karo");
	if(br == 2)
		strcpy(k->znak, "pik");
	if(br == 3)
		strcpy(k->znak, "tref");
	if(br == 4)
		strcpy(k->znak, "herc");
}

int main()
{
	signal(SIGINT, izbrisiSemafore);
	
	srand(time(NULL));
	/*int x = (rand()%15);
		printf("%d\n", x);*/
		
	
	key_t kljuc;
	union semnum arg;
	struct sembuf P, V, L;
	int ind;
	struct karta *karta;
	
	kljuc = ftok("igrac1.c", 'A');
		printf("Kljuc je: %d\n", kljuc);
		
	int shmid;
	    shmid = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
		printf("Memorija je: %d\n", shmid);
	
	semid = semget(kljuc, 4, 0666 | IPC_CREAT | IPC_EXCL);
		printf("Sem id je: %d\n", semid);
		
	if(semid != -1)
	{
		printf("Semafori nisu postojali ja ih pravim.\n");
		
		arg.val = 1;
		semctl(semid, 0, SETVAL, arg);
		
		arg.val = 0;
		semctl(semid, 1, SETVAL, arg);
		
		arg.val = 0;
		semctl(semid, 2, SETVAL, arg);
		
		arg.val = 0;
		semctl(semid, 3, SETVAL, arg);
	}
	else if(errno == EEXIST)
	{
		printf("Samo se kacim na postojeci skup semafora\n");
		semid = semget(kljuc, 4, 0);
	}
	else
	{
		printf("Neka druga greska. Izlazim.\n");
		exit(0);
	}
	
	P.sem_num = 1;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 2;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	L.sem_num = 0;
	L.sem_op = 1;
	L.sem_flg = 0;
	
	karta = (struct karta *)shmat(shmid, NULL, 0);
	//*karta = (rand()%14) + 1;
	
	
	while(1)
	{
		ind = semop(semid, &P, 1);
			if(ind == -1) break;
		
		struct karta *mojaKarta;
		mojaKarta = (struct karta *)malloc(sizeof(struct karta));
		mojaKarta->broj = (rand()%14) + 1;
		int znak;
		znak = (rand()%4) + 1;
		nadjiZnak(znak, mojaKarta);
		printf("\nKarta na talonu je: %d - %s\n", karta->broj, karta->znak);
		printf("Moja karta je: %d - %s\n", mojaKarta->broj, mojaKarta->znak);
		if(karta->broj == 8)
		{
			karta->broj = mojaKarta->broj;
			strcpy(karta->znak, mojaKarta->znak);
			ind = semop(semid, &L, 1);
				if(ind == -1) break;
		}
		if(karta->broj != 8)
		{
			ind = semop(semid, &V, 1);
				if(ind == -1) break;
		}
		if(mojaKarta->broj == karta->broj || ((strcmp(mojaKarta->znak, karta->znak)) == 0))
		{
			printf("Imam adekvatnu kartu!!!\n");
			karta->broj = mojaKarta->broj;
			strcpy(karta->znak, mojaKarta->znak);
		}
		else
		{
			printf("Nemam adekvatnu kartu!!!\n");
		}
		
		sleep(5);
	}
	
}

