#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct karta {
    int broj;
    int znak;
    int smer;

};
struct karta *data;
int semid,shmid,broj,nov_znak;
struct sembuf mutexP1,mutexV1,mutexP2,mutexV2,mutexP3,mutexV3,mutexP4,mutexV4;
#define P1 semop(semid,&mutexP1,1);
#define V1 semop(semid,&mutexV1,1);
#define P2 semop(semid,&mutexP2,1);
#define V2 semop(semid,&mutexV2,1);
#define P3 semop(semid,&mutexP3,1);
#define V3 semop(semid,&mutexV3,1);
#define P4 semop(semid,&mutexP4,1);
#define V4 semop(semid,&mutexV4,1);

int main() {
    srand(time(NULL));
    key_t key;
    //rand()%14;

    mutexP1.sem_flg = SEM_UNDO;
    mutexP1.sem_op = -1;
    mutexP1.sem_num = 0;
    mutexV1.sem_flg = SEM_UNDO;
    mutexV1.sem_op = 1;
    mutexV1.sem_num = 0;

    mutexP2.sem_flg = SEM_UNDO;
    mutexP2.sem_op = -1;
    mutexP2.sem_num = 1;
    mutexV2.sem_flg = SEM_UNDO;
    mutexV2.sem_op = 1;
    mutexV2.sem_num = 1;

    mutexP3.sem_flg = SEM_UNDO;
    mutexP3.sem_op = -1;
    mutexP3.sem_num = 2;
    mutexV3.sem_flg = SEM_UNDO;
    mutexV3.sem_op = 1;
    mutexV3.sem_num = 2;

    mutexP4.sem_flg = SEM_UNDO;
    mutexP4.sem_op = -1;
    mutexP4.sem_num = 3;
    mutexV4.sem_flg = SEM_UNDO;
    mutexV4.sem_op = 1;
    mutexV4.sem_num = 3;

    if ((key = ftok("./igrac1.c",'S'))==-1) {
        perror("Igrac11");
        exit(1);
    }

    if((semid = semget(key,4,IPC_EXCL|0666))==-1) {
        perror("Igrac12");
        exit(1);
    }

    if((shmid = shmget(key,sizeof(int),IPC_CREAT|0666))==-1) {
        perror("Igrac13");
        exit(1);
    }

    data = shmat(shmid,NULL,0);

    while(1) {

        P3;
        printf("Na talonu: %d",(*data).broj);
        if ((*data).znak == 1) {
            printf(",  karo\n");
        }
        if ((*data).znak == 2) {
            printf(",  pik\n");
        }
        if ((*data).znak == 3) {
            printf(",  tref\n");
        }
        if ((*data).znak == 4) {
            printf(",  srce\n");
        }
        broj = (rand()%14)+1;
        nov_znak = (rand()%4)+1;

        printf("Izvukao kartu %d",broj);
        if (nov_znak == 1) {
            printf(",  karo\n");
        }
        if (nov_znak == 2) {
            printf(",  pik\n");
        }
        if (nov_znak == 3) {
            printf(",  tref\n");
        }
        if (nov_znak == 4) {
            printf(",  srce\n");
        }

        if((*data).broj == broj || (*data).znak == nov_znak) {
            printf("Stavio kartu\n\n");
            (*data).broj = broj;
            (*data).znak = nov_znak;
            if((*data).broj == 8) {
                if((*data).smer == 1) {
                    (*data).smer = 0;
                }
                else {
                    (*data).smer = 1;
                }
            }
        }
        else {
            printf("Nemam advekatnu kartu\n\n");
        }
        sleep(2);
        if((*data).smer == 1) {
            V4;
        }
        else {
            V2;
        }
        
    }

}