#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf; 
	ushort *array;
};

int main(int args, char* argv[])
{
	int semid;
	int ind;
	key_t key;
	int i, karta;
	
	union semun semafor;
	struct sembuf P,V;

	key = ftok("igrac.c",'A');
	printf("Kljuc je: %d\n", key);
	
	semid = semget(key, 4, 0666|IPC_CREAT|IPC_EXCL);
	if(semid != -1)
	{
		printf("Ja sam kreirao semafor. SEMID = %d\n", semid);
		semafor.val = 1;
		semctl(semid, 0, SETVAL, semafor);
		semafor.val = 0;
		semctl(semid, 1, SETVAL, semafor);
		semctl(semid, 2, SETVAL, semafor);
		semctl(semid, 3, SETVAL, semafor);
	}
	else if(errno == EEXIST)
	{
		semid = semget(key , 4, 0);
		printf("Semafor je vec postojao. SEMID = %d\n", semid);
	}
	
	
	if(!strcmp(argv[1],"1"))
	{
		P.sem_num = 0;
		P.sem_op = -1;
		P.sem_flg = 0;
		
		V.sem_num = 1;
		V.sem_op = 1;
		V.sem_flg = 0;
	}
	else if(!strcmp(argv[1],"2"))
	{
		P.sem_num = 1;
		P.sem_op = -1;
		P.sem_flg = 0;
		
		V.sem_num = 2;
		V.sem_op = 1;
		V.sem_flg = 0;
	}
	else if(!strcmp(argv[1],"3"))
	{
		P.sem_num = 2;
		P.sem_op = -1;
		P.sem_flg = 0;
		
		V.sem_num = 3;
		V.sem_op = 1;
		V.sem_flg = 0;
		
	}
	else if(!strcmp(argv[1],"4"))
	{
		P.sem_num = 3;
		P.sem_op = -1;
		P.sem_flg = 0;
		
		V.sem_num = 0;
		V.sem_op = 1;
		V.sem_flg = 0;
	}
	else
	{
		printf("*****GRESKA!!!*****\nKao argument posaljite redni broj igraca (1-4)\n");
	}
	
	
	srand(time(NULL));
	
	for(i = 0; i < 6; i++)
	{
		semop(semid, &P, 1);
		karta = rand() % 14 + 1;
		printf("IGRAC %s, KARTA %d:  %d\n", argv[1], i+1, karta);
		sleep(1);
		semop(semid, &V, 1);
	}
		
	semop(semid, &P, 1);
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	semop(semid, &V, 1);
	
}
