#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define NORMALAN 1
#define OKRENUT -1

typedef struct karta{
	int broj;
	int znak;
	int smer;
}Karta;

union semun {
	int val;
	struct semid_ds *buf; 
	ushort *array;
};



int main(){
	srand(time(NULL));
	key_t key;
	int semid,shmid,ind,vrednost,znak;
	struct sembuf PT,VC,VD;
	Karta *talon;
	union semun arg;
	key = ftok("./prvi.c",'A');
	printf("kljuc je %d\n",key);
	shmid = shmget(key,sizeof(Karta),0666|IPC_CREAT);
	printf("Id memorije je %d\n",shmid);
	semid = semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	printf("ID semafora j %d\n",semid);
	if(semid != -1){
		printf("Ja sam kreirao semafor sad ga inicijalizujem\n");
		arg.val = 1;
		semctl(semid,0,SETVAL,arg);
		arg.val = 0;
		semctl(semid,1,SETVAL,arg);
		arg.val = 0;
		semctl(semid,2,SETVAL,arg);
		arg.val = 0;
		semctl(semid,3,SETVAL,arg);
	}
	else if(errno == EEXIST){
		printf("Neko drugiu je vec kreirao semafor ja se samo povezujem\n");
		semid = semget(key,4,0);
	}
	else{
		printf("Neka greskaaa\n");
		exit(0);
	}
	
	talon = (Karta *)shmat(shmid,(void *)0,0);
	
	PT.sem_num = 2;
	PT.sem_op = -1;
	PT.sem_flg = 0;
	
	VC.sem_num = 3;
	VC.sem_op = 1;
	VC.sem_flg = 0;
	
	VD.sem_num = 1;
	VD.sem_op = 1;
	VD.sem_flg = 0;
	
	while(1){
		ind = semop(semid,&PT,1);
		if(ind == -1) break;
		sleep(3);
		printf("Talon je %d %d %d\n",talon->broj,talon->znak,talon->smer);
		vrednost = rand()%14+1;
		znak = rand()%4+1;
		printf("Dobio sam %d %d\n",vrednost,znak);
		if(talon->broj == 0 || talon->broj==vrednost || talon->znak == znak){
			talon->broj = vrednost;
			talon->znak = znak;
			if(vrednost == 8){
				talon->smer = (talon->smer)*(-1);
			}
			printf("Talon je %d %d %d\n\n",talon->broj,talon->znak,talon->smer);
		}
		else{
			printf("Nemam adekvatnu kartu\n\n");
		}
		if(talon->smer == NORMALAN){
			ind = semop(semid,&VC,1);
			if(ind == -1) break;
		}
		else{
			ind = semop(semid,&VD,1);
			if(ind == -1) break;
		}
	}
	
	return 0;
}
