#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

typedef struct delmem_s {
	int broj;
	int znak;
} delmem;

#define SHMSIZE sizeof(delmem)

int main(void) {
	
	srand(time(NULL));
	
	key_t key = ftok("init.c", 'S');
	int sid = semget(key, 4, IPC_CREAT | 0666);
	union semun arg;
	//S1 
	arg.val = 0;
	semctl(sid, 0, SETVAL, arg);
	arg.val = 0;
	//S2 
	semctl(sid, 1, SETVAL, arg);
	arg.val = 0;
	//S3 
	semctl(sid, 2, SETVAL, arg);
	arg.val = 0;
	//S4 
	semctl(sid, 3, SETVAL, arg);
	
	
	
	
	printf("Kreirao sam i setovao semafore.\n");
	
	key = ftok("init.c", 'M');
	int mid = shmget(key, SHMSIZE, 0666 | IPC_CREAT);
	
	delmem *talon = (delmem*)shmat(mid, NULL, 0);
	
	int broj = (rand() % 14) + 1;
	int znak = (rand() % 4);
	//0 - karo
	//1 - pik
	//2 - tref
	//3 -  herc
	

	struct sembuf VS1 = {0, +1, 1};
	
	printf("Na talonu je postavljena prva karta:");
	printf("%d", broj);
	if (znak == 0) printf(" - karo\n");
	if (znak == 1) printf(" - pik\n");
	if (znak == 2) printf(" - tref\n");
	if (znak == 3) printf(" - herc\n");
	talon->broj = broj;
	talon->znak = znak;
	
	
	
	semop(sid, &VS1, 1);
	shmdt(talon);
	
	printf("Zavrsavam sa radom.\n");
	
	
	
	
	return 0;
}
