#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

typedef struct karta{
	int broj;
	int znak;
}karta;

int main(){
	
	srand(time(NULL));
	int partija = 0;
	key_t key;
	int shmid, semid;
	karta *talon;
	karta randomKarta;
	int *redosled;
	struct sembuf p, v, l, d;
	
	key = ftok("./init.c", 'A');
	shmid = shmget(key, SHM_SIZE*sizeof(karta), 0666|IPC_CREAT);
	printf("Id segmenta talona je %d\n", shmid);
	
	talon = shmat(shmid, NULL, 0);
	
	key = ftok("./init.c", 'C');
	shmid = shmget(key, SHM_SIZE*sizeof(int), 0666|IPC_CREAT);
	printf("Id segmenta redosleda je %d\n", shmid);
	
	redosled = shmat(shmid, NULL, 0);
	
	
	key = ftok("./init.c", 'B');
	semid = semget(key, 4,0);
	printf("Id semafora je %d\n", semid);
	
	//ja sam 0
	
	p.sem_num = 0;
	p.sem_op = 1;
	p.sem_flg = 0;
	
	v.sem_num = 0;
	v.sem_op = -1;
	v.sem_flg = 0;
	
	//drugi
	d.sem_num = 1;
	d.sem_op = 1;
	d.sem_flg = 0;
	
	//cetvrti
	l.sem_num = 3;
	l.sem_op = 1;
	l.sem_flg = 0;
	
	semop(semid, &p, 1);
	while(1){
		printf("%d.IGRAC 1\n", partija);
		partija++;
		//smanji semafor
		semop(semid, &v, 1);
		
		randomKarta.broj = rand()%14;
		randomKarta.znak = rand()%4;
		//printf("Talon: broj %d znak %d\n", talon->broj, talon->znak);
		//printf("Izvuko sam kartu: broj %d znak %d \n", randomKarta.broj, randomKarta.znak);
		
		
		if(talon->znak == randomKarta.znak || talon->broj == randomKarta.broj){
			printf("IGRAC 1: Bacio sam kartu!\n");
			if(talon->broj == 8){
				if(*redosled == 1)
					*redosled = 2;
				else
					*redosled = 1;
			}
			talon->znak = randomKarta.znak;
			talon->broj = randomKarta.broj;
			printf("Talon posle bacanja je : broj %d znak %d\n", talon->broj, talon->znak);	
		}
		else
			printf("Ne mogu da bacim kartu!\n");
		
		if(*redosled == 1){
			printf("Igra igrac broj 2\n");
			sleep(5);
			semop(semid, &d, 1);
		}
		else if(*redosled == 2){
			printf("Igra igrac broj 4\n");
			sleep(5);
			semop(semid, &l, 1);
		}
		printf("Redosled je %d\n", *redosled);
		//povecaj semafor
		//semop(semid, &v, 1);
		
		printf("---------------------------------\n");
	}
	
	
	
	

}

