#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

//bitno da zna redni broj
//ako 8 prva odmah se menja smer

//1 je karo
//2 pik
//3 tref
//4 herc

//1 desno
//2 levo

typedef struct karta{
	int broj;
	int znak;
}karta;

struct semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main(){
	
	srand(time(NULL));
	
	key_t key;
	int shmid, semid, shmid2;
	karta *talon;
	karta randomKarta;
	int *redosled;
	struct semun arg;
	
	
	//TALON
	key = ftok("./init.c", 'A');
	shmid = shmget(key, SHM_SIZE*sizeof(karta), 0666|IPC_CREAT);
	printf("Id segmenta talona je %d\n", shmid);
	
	talon = shmat(shmid, NULL, 0);
	
	//REDOSLED
	
	key = ftok("./init.c", 'C');
	shmid2 = shmget(key, SHM_SIZE*sizeof(int), 0666|IPC_CREAT);
	printf("Id segmenta redosleda je %d\n", shmid2);
	
	redosled = shmat(shmid2, NULL, 0);
	
	//SEMAFORI
	key = ftok("./init.c", 'B');
	semid = semget(key, 4, 0666|IPC_CREAT);
	printf("Id semafora je %d\n", semid);
	
	//inicijalizacija
	arg.val = 0;
	semctl(semid, 0, SETVAL, arg);
	arg.val = 0;
	semctl(semid, 1, SETVAL, arg);
	semctl(semid, 2, SETVAL, arg);
	semctl(semid, 3, SETVAL, arg);
	
	
	/*p.sem_num = 0;
	p.sem_op = 1;
	p.sem_flg = 0;
	
	semop(semid, &p, 1);*/
	
	*redosled = 1;
	printf("Redosled je %d\n", *redosled);
	//talon
	randomKarta.broj = rand()%14;
	randomKarta.znak = rand()%4;
	
	*talon = randomKarta;
	
	printf("Prva karta je: broj %d znak %d\n", talon->broj, talon->znak);
	//randomKarta.broj = 8;
	//menja redosled
	if(randomKarta.broj == 8)
		*redosled = 2;
	printf("Redosled je %d\n", *redosled);
	
	sleep(150);

}
