#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define KARO 0
#define PIK 1
#define TREF 2
#define HERC 3

#define NORMALANSMER 0
#define OBRNUTISMER 1

union semun
{
	int val;
	ushort *array;
	struct semid_ds *buf;
};

struct Karta
{
	int broj;
	int znak;
	int smer;
};

int main()
{
	srand(time(NULL));
	
	union semun arg;
	struct sembuf PrviV;
	
	struct Karta *karta;
	
	key_t key=ftok("./treci.c",'A');
	int shmid=shmget(key,1024,0666|IPC_CREAT);
	
	key=ftok("./treci.c",'B');
	int semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{
		arg.val=0;
		semctl(semid,0,SETVAL,arg);
		semctl(semid,1,SETVAL,arg);
		semctl(semid,2,SETVAL,arg);
		semctl(semid,3,SETVAL,arg);
	}
	else if(errno==EEXIST)
	{
		semid=semget(key,4,0);
	}
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	////////semafori
	
	PrviV.sem_num=0;
	PrviV.sem_op=+1;
	PrviV.sem_flg=0;
	
	////////memorija
	karta=shmat(shmid,NULL,0);
	
	karta->broj=rand()%14;
	karta->znak=rand()%4;
	if(karta->broj==8)
		karta->smer=OBRNUTISMER;
	else
		karta->smer=NORMALANSMER;
	
	semop(semid,&PrviV,1); //odblokiraj 1
	
	//inicijalizuje memoriju, prvu kartu na talonu i pokrece prvog igraca
	
	sleep(5000);
	
	shmdt(karta);
}
