#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef union senum
{
	int val;
	struct semid_ds *buf;
	ushort *array;
}senum;

typedef struct Message
{
	long type;
	char text[100];
	int broj;
}Message;

int semid;

void handler(int sig)
{
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	exit(0);
}

void Izvuci(char *karta)
{
	char *k, *k1, *k2;
	int i,j;
	char temp, temp1 = '\0';
	
	
	k = (char*)malloc(2*sizeof(char));
	k1 =(char*)malloc(2*sizeof(char));
	k2 = (char*)malloc(2*sizeof(char));
	
	i = rand() % 14;
	j = rand() % 4;
	
	switch(i)
	{
		case 0:
			temp = '1';
			break;
		case 1:
			temp = '2';
			break;
		case 2:
			temp = '3';
			break;
		case 3:
			temp = '4';
			break;
		case 4:
			temp = '5';
			break;
		case 5:
			temp = '6';
			break;
		case 6:
			temp = '7';
			break;
		case 7:
			temp = '8';
			break;
		case 8:
			temp = '9';
			break;
		case 9:
			temp = '1';
			temp1 = '0';
			break;
		case 10:
			temp = '1';
			temp1 = '1';
			break;
		case 11:
			temp = '1';
			temp1 = '2';
			break;
		case 12:
			temp = '1';
			temp1 = '3';
			break;
		case 13:
			temp = '1';
			temp1 = '4';
			break;
	}
	
	*k = temp;
	*k2 = temp1;
	
	switch(j)
	{
		case 0:
			temp = 'K';
			break;
		case 1:
			temp = 'P';
			break;
		case 2:
			temp = 'T';
			break;
		case 3:
			temp = 'H';
			break;
	}
	
	*k1 = temp;
	
	strcat(strcpy(karta, k1), strcat(k, k2));
}

int main()
{
	signal(SIGINT, handler);
	srand(time(NULL));
	key_t key = ftok("./igrac.c", 70);		// sem
	semid = semget(key, 4, IPC_CREAT | 0644 | IPC_EXCL);
	key_t key1 = ftok("./igrac.c", 71);		// poruka
	int row = msgget(key1, IPC_CREAT | 0666);
	key_t key2 = ftok("./igrac.c", 72);		// memory
	int shmid = shmget(key2, 1024, IPC_CREAT | 0644);
	char *data;	
	senum sem;
	char *karta;
	
	karta = (char*)malloc(5*sizeof(char));
	
	if(semid != -1)
	{
		//sem.val = 1;
		sem.val = 0;
		semctl(semid, 0, SETVAL, sem);
		sem.val = 0;
		semctl(semid, 1, SETVAL, sem);
		sem.val = 0;
		semctl(semid, 2, SETVAL, sem);
		sem.val = 0;
		semctl(semid, 3, SETVAL, sem);
	}
	else if(errno == EEXIST)
	{
		semget(semid, 4, 0);
	}
	else
		exit(0);
	
	Message msg;
	
	msg.broj = -1;
	msg.type = getpid();
	strcpy(msg.text, "prijava");
	msgsnd(row, &msg, sizeof(msg.text), 0);
	
	/*
	Izvuci(karta);
	printf("prva karta na talonu: %s\n", karta);
	data = shmat(shmid, NULL, 0);
	
	strcpy(data, karta);
	
	shmdt(data);
	*/
	
	int flg = 1;
	int flg1;
	char t[10], *t1,*t2;
	
	t1 = (char*)malloc(2*sizeof(char));
	t2 = (char*)malloc(2*sizeof(char));
	
	while(msg.broj < 0)
	{
		msgrcv(row, &msg, sizeof(msg.broj), getpid(), 0);
	}
	
	int tren = msg.broj - 1;
	int pret, sled;
	printf("Ja sam igrac br: %d\n", tren);
	if(tren == 1)
		pret = 3;
	else
		pret = tren -1;
	if(tren == 3)
		sled = 1;
	else
		sled = tren +1;
	
	char *osam = (char*)malloc(2*sizeof(char));
	*osam = '8';
	
	struct sembuf T = {tren,-1,0}, P = {pret,1,0}, S = {sled,1,0};
	
	//struct sembuf T = {0,-1,0},P = {3,1,0},S = {1,1,0};
	while(1)
	{
		semop(semid, &T, 1);
		Izvuci(karta);
		printf("Izvucena karta: %s\n", karta);
		data = shmat(shmid, NULL, 0);
		strcpy(t, data);
		printf("karta na talonu: %s\n", t);
		*t1 = karta[1];
		*t2 = t[1];
		flg1 = 0;
		
		if(!strcmp(t1, t2))
		{
			if((karta[2] >= '0' && karta[2] <= '9') && (t[2] >= '0' && t[2] <= '9'))
			{
				*t1 = karta[2];
				*t2 = t[2];
				
				if(!strcmp(t1,t2))
					flg1 = 1;
			}
		}
		
		if(flg1)
		{
			strcpy(data, karta);
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
		}
		*t1 = karta[1];
		if(!strcmp(t1, osam))
		//if(karta[1] == '8');
			flg = -flg;

		if(flg == 1)
			semop(semid, &S, 1);
		else
			semop(semid, &P, 1);
		
		shmdt(data);
		
		break;
	}

	
	
	
	
	
	
	

	
	
	
}
