#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef union senum
{
	int val;
	struct semid_ds *buf;
	ushort *array;
}senum;

typedef struct Message
{
	long type;
	char text[100];
	int broj;
}Message;

int semid;

void handler(int sig)
{
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	exit(0);
}

void Izvuci(char *karta)
{
	char *k, *k1, *k2;
	int i,j;
	char temp, temp1 = '\0';
	
	
	k = (char*)malloc(2*sizeof(char));
	k1 =(char*)malloc(2*sizeof(char));
	k2 = (char*)malloc(2*sizeof(char));
	
	i = rand() % 14;
	j = rand() % 4;
	
	switch(i)
	{
		case 0:
			temp = '1';
			break;
		case 1:
			temp = '2';
			break;
		case 2:
			temp = '3';
			break;
		case 3:
			temp = '4';
			break;
		case 4:
			temp = '5';
			break;
		case 5:
			temp = '6';
			break;
		case 6:
			temp = '7';
			break;
		case 7:
			temp = '8';
			break;
		case 8:
			temp = '9';
			break;
		case 9:
			temp = '1';
			temp1 = '0';
			break;
		case 10:
			temp = '1';
			temp1 = '1';
			break;
		case 11:
			temp = '1';
			temp1 = '2';
			break;
		case 12:
			temp = '1';
			temp1 = '3';
			break;
		case 13:
			temp = '1';
			temp1 = '4';
			break;
	}
	
	*k = temp;
	*k2 = temp1;
	
	switch(j)
	{
		case 0:
			temp = 'K';
			break;
		case 1:
			temp = 'P';
			break;
		case 2:
			temp = 'T';
			break;
		case 3:
			temp = 'H';
			break;
	}
	
	*k1 = temp;
	
	strcat(strcpy(karta, k1), strcat(k, k2));
}

int main()
{
	signal(SIGINT, handler);
	srand(time(NULL));
	key_t key = ftok("./igrac.c", 70);		// sem
	semid = semget(key, 4, IPC_CREAT | 0644 | IPC_EXCL);
	key_t key1 = ftok("./igrac.c", 71);		// poruka
	int row = msgget(key1, IPC_CREAT | 0666);
	key_t key2 = ftok("./igrac.c", 72);		// memory
	int shmid = shmget(key2, 1024, IPC_CREAT | 0644);
	char *data;	
	senum sem;
	char *karta;
	
	karta = (char*)malloc(5*sizeof(char));
	
	if(semid != -1)
	{
		sem.val = 0;
		semctl(semid, 0, SETVAL, sem);
		sem.val = 0;
		semctl(semid, 1, SETVAL, sem);
		sem.val = 0;
		semctl(semid, 2, SETVAL, sem);
		sem.val = 0;
		semctl(semid, 3, SETVAL, sem);
	}
	else if(errno == EEXIST)
	{
		semget(semid, 4, 0);
	}
	else
		exit(0);
	
	Izvuci(karta);
	printf("prva karta na talonu: %s\n", karta);
	data = shmat(shmid, NULL, 0);
	
	strcpy(data, karta);
	
	shmdt(data);
	
	struct sembuf I = {0,1,0};
	
	Message msg;
	long igraci[4];
	int n = 0, i;
	
	while(1)
	{
		for(i = 0;i<4;i++)
		{
			igraci[i] = 0;
		}
		msgrcv(row, &msg, sizeof(msg.broj), 0, 0);
		igraci[n++] = msg.type;
		printf("Igrac prijavljen, ukupan broj igraca: %d\n", n);
		sleep(2);
		msgrcv(row, &msg, sizeof(msg.broj), 0, 0);
		igraci[n++] = msg.type;
		printf("Igrac prijavljen, ukupan broj igraca: %d\n", n);
		sleep(2);
		msgrcv(row, &msg, sizeof(msg.broj), 0, 0);
		igraci[n++] = msg.type;
		printf("Igrac prijavljen, ukupan broj igraca: %d\n", n);
		sleep(2);
		msgrcv(row, &msg, sizeof(msg.broj), 0, 0);
		igraci[n++] = msg.type;
		printf("Igrac prijavljen, ukupan broj igraca: %d\n", n);
		sleep(2);
		
		if(!fork())
		{
			msg.type = n--;
			msgsnd(row, &msg, sizeof(msg.broj), 0);
			msg.type = n--;
			msgsnd(row, &msg, sizeof(msg.broj), 0);
			msg.type = n--;
			msgsnd(row, &msg, sizeof(msg.broj), 0);
			msg.type = n--;
			msgsnd(row, &msg, sizeof(msg.broj), 0);
			
			semop(semid, &I, 1);
			break;
		}
		else
			n = 0;
		
	}
	
	
	
	
	
	
	

	
	
	
}
