#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};
int main()
{
	key_t key;
	int semid,br=0;
	struct sembuf p,v;
	union semun arg;
	srand(time(NULL));
	
	key=ftok("prvi.c",'a');

	
	semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	
	
	
	if(semid==-1)
	{
		if(errno==EEXIST) semid=semget(key,4,0);
		else exit(0);
	}
	else
	{
		arg.array=(unsigned short*)malloc(sizeof(unsigned short));
		arg.array[0]=1;
		arg.array[1]=0;
		arg.array[2]=0;
		arg.array[3]=0;
		
		semctl(semid,0,SETALL,arg);
	}
	
	p.sem_num=1;
	p.sem_op=-1;
	p.sem_flg=0;
	
	v.sem_num=2;
	v.sem_op=1;
	v.sem_flg=0;
	
	while(br<6)
	{
		if(semop(semid,&p,1)==-1) exit(0);
		printf("%d\n",rand()%14);
		if(semop(semid,&v,1)==-1) exit(0);
		sleep(3);
		br++;
	}
	
	return 0;
}
