#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

typedef struct card{
	int znak; // 1 - 4
	int broj; // 1 - 14
	int prethodna;
	int br;
	int obrnut;
}card;

int main()
{
	key_t kljuc;
	int shmid;
	int semid;
	card *karta;
	struct sembuf p,v;
	
	srand(time(NULL));
	
	kljuc=ftok("./init.c",'A');
	//printf("Kljuc %d\n",kljuc);
	shmid = shmget(kljuc, sizeof(karta), 0666|IPC_CREAT);
	//printf("Shmid %d\n",shmid);
	semid = semget(kljuc, 4, 0666|IPC_CREAT);
	//printf("semid %d\n",semid);
	
	p.sem_num = 2;
	p.sem_op = -1;
	p.sem_flg = 0;
	
	v.sem_num = 3;
	v.sem_op = 1;
	v.sem_flg = 0;
	
	int ind;
	card trenutna;
	int postavljena;
	
	karta = shmat(shmid,NULL,0);
	
	while(1389)
	{
		ind = semop(semid,&p,1);
		if(ind == -1) break;
		
		postavljena = 0;
		trenutna.znak=rand()%4 +1;
		trenutna.broj=rand()%14 +1;
		
		
		printf("Talon %d %d\n",karta->znak, karta->broj);
		printf("Ja %d %d\n",trenutna.znak, trenutna.broj);
		
		if(karta->znak == trenutna.znak || karta->broj == trenutna.broj)
		{
			karta->znak = trenutna.znak;
			karta->broj = trenutna.broj;
			printf("Stavio sam kartu\n");
			postavljena = 1;
		}
		else
			printf("Nemam adekvatnu kartu\n");
			
		
			
		if(postavljena==1 && trenutna.broj==8)
		{
			printf("Obrcem redosled\n");
			
			if(karta->obrnut ==0)
				karta->obrnut = 1;
			else
				karta->obrnut = 0;
			
			if(karta->prethodna == 2)
			{
				v.sem_num = 1;
				v.sem_op = 1;
				v.sem_flg = 0;
			}
			else if(karta->prethodna ==4)
			{
				v.sem_num = 3;
				v.sem_op = 1;
				v.sem_flg = 0;
			}
		}
		
		karta->prethodna=3;
		sleep(2);
		ind = semop(semid,&v,1);
		if(ind == -1) break;
		
	}
}
