#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

typedef struct card{
	int znak; // 1 - 4
	int broj; // 1 - 14
	int predhodna;
	int obrnut;
	int br;
}card;

int main()
{
	key_t kljuc;
	int shmid;
	int semid;
	card *karta;
	union semun arg;
	struct sembuf v;
	
	srand(time(NULL));
	
	kljuc=ftok("./init.c",'A');
	//printf("Kljuc %d\n",kljuc);
	shmid = shmget(kljuc, sizeof(karta), 0666|IPC_CREAT);
	//printf("Shmid %d\n",shmid);
	semid = semget(kljuc, 4, 0666|IPC_CREAT);
	//printf("semid %d\n",semid);
	
	arg.val = 0;
	semctl(semid,0,SETVAL,arg);
	semctl(semid,1,SETVAL,arg);
	semctl(semid,2,SETVAL,arg);
	semctl(semid,3,SETVAL,arg);
	
	karta = shmat(shmid,NULL,0);
	
	karta->znak=rand()%4 +1;
	karta->broj=rand()%14 +1;
	karta->predhodna = 0;
	karta->br = 0;
	karta->obrnut = 0;
	
	printf("Znak %d broj %d\n",karta->znak, karta->broj);
	
	if(karta->broj != 8)
		v.sem_num = 0;
	else
		v.sem_num = 3;
		
	v.sem_op = 1;
	v.sem_flg = 0;
	semop(semid,&v,1);
}
