#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024
#define SEM_LEN 8

union semun {
	int val;
	struct semid_ds *buf; 
	ushort *array;
};

int semid;

void signalHandler(int sig)
{
	printf("\nIgra je prekuta,zavrsavamo igru za par sekundi\n");
	sleep(2);
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
	semctl(semid,4,IPC_RMID);
	semctl(semid,5,IPC_RMID);
	semctl(semid,6,IPC_RMID);
	semctl(semid,7,IPC_RMID);
	exit(0);
}

int main()
{
	signal(SIGINT,signalHandler);
	printf("IGRAC 2\n");
	printf("--------------------------------\n");
	srand(time(NULL));
	key_t key,key1,key2;
	union semun operacija;
	struct sembuf oduzimanje,sabiranje,sabiranje1,oduzimanje1;
	int shmid,*data,*data1,shmid1,okreni,*data2,shmid2;
	
	key = ftok("igrac1.c",'A');
	key1 = ftok("igrac1.c",'B');
	key2 = ftok("igrac1.c",'C');
	
	shmid = shmget(key,SHM_SIZE,0666|IPC_CREAT);
	shmid1 = shmget(key1,SHM_SIZE,0666|IPC_CREAT);
	shmid2 = shmget(key2,SHM_SIZE,0666|IPC_CREAT);
	
	semid = semget(key,SEM_LEN,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid != -1)
	{
		//printf("Ja kreiram semafor,nije bio kreiran\n");
		operacija.val = 0;
		semctl(semid,0,SETVAL,operacija);
		
		operacija.val = 0;
		semctl(semid,1,SETVAL,operacija);
		
		operacija.val = 0;
		semctl(semid,2,SETVAL,operacija);
		
		operacija.val = 0;
		semctl(semid,3,SETVAL,operacija);
		
		operacija.val = 1;
		semctl(semid,4,SETVAL,operacija);
		
		operacija.val = 0;
		semctl(semid,5,SETVAL,operacija);
		
		operacija.val = 0;
		semctl(semid,6,SETVAL,operacija);
		
		operacija.val = 0;
		semctl(semid,7,SETVAL,operacija);
	}
	else if(errno == EEXIST)
	{
	//	printf("Semafor je bio kreiran,samo se kacim na njega\n");
		semid = semget(key,SEM_LEN,0);
	}
	else 
	{
		printf("Neka druga greska je u pitanju\n");
		printf("Izlazim...\n");
		sleep(2);
		exit(0);
	}
	data = (int*)shmat(shmid,(void*)0,0);
	data1 = (int*)shmat(shmid1,(void*)0,0);
	data2 = (int*)shmat(shmid2,(void*)0,0);
	
	
	oduzimanje.sem_num = 5;
	oduzimanje.sem_op = -1;
	oduzimanje.sem_flg = 0;

	oduzimanje1.sem_num = 1;
	oduzimanje1.sem_op = -1;
	oduzimanje1.sem_flg = 0;
	
	sabiranje.sem_num = 6;
	sabiranje.sem_op  = 1;
	sabiranje.sem_flg = 0;	

	sabiranje1.sem_num = 0;
	sabiranje1.sem_op  = 1;
	sabiranje1.sem_flg = 0;	
	
	int i,ind,karta,znak;
	char poruka[100];
	i=0;
	while(1)
	{
		if(*data2 == 11)
			semop(semid,&oduzimanje1,1); //to znaci da moze da igra
		else
		{
			ind = semop(semid,&oduzimanje,1); //pusti ga da radi
			if(ind == -1) break;
		}
		sleep(2);
		karta = rand() % 15;
		znak = rand() % 4;
		
		if(karta == 0) karta = 5;
		if(znak == 0) strcpy(poruka,"karo");
		else if(znak == 1) strcpy(poruka,"pik");
		else if(znak == 2) strcpy(poruka,"herc");
		else strcpy(poruka,"tref");
		
		printf("Moja karta je %d - znaka %s\n",karta,poruka);

		if(karta == *data || znak == *data1)
		{
			*data = karta;
			*data1 = znak;
			printf("Stavio sam je na talon\n");
			
			if(karta == 8) okreni = 1;
			else okreni = 0;
		}
		else printf("Ne mogu da igram\n");
	
		if(okreni != 1)
		{
			ind = semop(semid,&sabiranje,1); //pusti ga da radi
			if(ind == -1) break;
			sleep(3);
		}
		else
		{
			semop(semid,&sabiranje1,1);
			*data2 = 11;
		
			sleep(3);
		}
		i++;
	}
}
