#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int main(){
	// rng
	srand(time(0));
	
	// povezivanja
	key_t key = ftok("server.c", 1);
	int shm_id = shmget(key, 1024, 0644 | IPC_CREAT);
	int *niz = shmat(shm_id, NULL, 0);
	key = ftok("server.c", 2);
	int sem_id_ctl = semget(key, 3, 0644 | IPC_CREAT);
	struct sembuf sem;
	
	// registracija
	sem.sem_num = 0;
	sem.sem_op = 1;
	sem.sem_flg = 0;
	semop(sem_id_ctl, &sem, 1);
	
	// povratna inf
	sem.sem_num = 1;
	sem.sem_op = -1;
	semop(sem_id_ctl, &sem, 1);
	
	// inicijalizacija u igri
	
	// ulazi u kriticni region
	sem.sem_num = 3;
	sem.sem_op = -1;
	semop(sem_id_ctl, &sem, 1);
	
	int ksem = niz[0];
	int kshm = niz[1];
	int red = (niz[2]) % 4 + 1;
	(niz[2])++;
	
	sem.sem_num = 3;
	sem.sem_op = 1;
	semop(sem_id_ctl, &sem, 1);
	// izlazi iz kr
	
	// prijavljivanje
	key = ftok("server.c", ksem);
	int sem_id_game = semget(key, 5, 0);
	
	key = ftok("igrac.c", kshm);
	int shm_id_game = shmget(key, 1024, 0644 | IPC_CREAT);
	int *top = shmat(shm_id_game, NULL, 0);
	
	// inicijalizovao
	sem.sem_num = 2;
	sem.sem_op = 1;
	semop(sem_id_ctl, &sem, 1);
	
	// igra
	int i;
	int karta[2];
	for(i = 0 ; i < 6 ; i++){
		// ceka potez
		sem.sem_num = red;
		sem.sem_op = -1;
		semop(sem_id_game, &sem, 1);
		
		// potez
		karta[0] = rand() % 13 + 1;
		karta[1] = rand() % 4;
		if(karta[0] == top[0] || karta[1] == top[1]){
			printf("izbacio %d ", karta[0]);
			switch(karta[1]){
				case 0: printf("herts"); break;
				case 1: printf("pik"); break;
				case 2: printf("karo"); break;
				case 3: printf("tref"); break;
			}
			printf("\n");
			
			top[0] = karta[0];
			top[1] = karta[1];
			if(top[0] == 8)
				top[2] *= -1;
		}
		else
			printf("nemam adekvatnu kartu\n");
		
		sleep(1);
		// daje sledecem
		if(top[2] == 1)
			sem.sem_num = (red + 1) % 5;
		else
			sem.sem_num = red - 1;
		sem.sem_op = 1;
		semop(sem_id_game, &sem, 1);
	}
	shmdt(niz);
	shmdt(top);
}
