#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
//id semafora 0,1,2,3 su za igrace redom (1,2,3,4)
//4,5,6,7


int brojpoteza=1;
int randomkarta;
int randomznak;
int kartanavrhu;
int znaknavrhu;

union semnu {
	int val;
	struct semid_ds *buf;
	ushort *array;
};
typedef struct pomocni{
	int znak;
	int karta;
	char moja_poruka[100];
}pomocni;
struct poruka{
	long tip;
	pomocni pom[1];
};
int main()
{
	int ind,semid,id_reda;
	int karta,znak;
	key_t kljuc;
	srand(time(NULL));
	struct sembuf KrajCetvrtog,Prvi,PocetakDrugog;
	union semnu operacija_nad_semaforom;
	struct poruka moja_poruka;
	
	randomkarta=rand()%14+1;
	randomznak=rand()%4+1;
	
	kljuc=ftok("./drugiigrac.c",65);
	id_reda=msgget(kljuc,0666|IPC_CREAT);
	printf("id reda je : %d\n",id_reda);
	kljuc = ftok("./cetvrtiigrac.c",'T');
	semid = semget(kljuc,10,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid != -1)
	{
		operacija_nad_semaforom.val=0;
		semctl(semid,4,SETVAL,operacija_nad_semaforom);
		semctl(semid,1,SETVAL,operacija_nad_semaforom);
		semctl(semid,2,SETVAL,operacija_nad_semaforom);
		semctl(semid,3,SETVAL,operacija_nad_semaforom);
		semctl(semid,5,SETVAL,operacija_nad_semaforom);
		semctl(semid,6,SETVAL,operacija_nad_semaforom);
		semctl(semid,7,SETVAL,operacija_nad_semaforom);
		operacija_nad_semaforom.val=1;
		semctl(semid,4,SETVAL,operacija_nad_semaforom);
	}
	else if( errno == EEXIST)
	{
		semid=semget(kljuc,10,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(0);
	}
	printf("Karte je %d %d\n",randomkarta,randomznak); 
	KrajCetvrtog.sem_num=4;
	KrajCetvrtog.sem_op=-1;
	KrajCetvrtog.sem_flg=0;
	
	Prvi.sem_num=0;
	Prvi.sem_op=1;
	Prvi.sem_flg=0;
	
	PocetakDrugog.sem_num=5;
	PocetakDrugog.sem_op=1;
	PocetakDrugog.sem_flg=0;
	
	while(1)
	{
		if(brojpoteza > 6)
		{
			exit(0);
		}
		semop(semid,&KrajCetvrtog,1);
		semop(semid,&Prvi,1);
		karta=rand()%14+1;
		znak=rand()%4+1;
		printf("Moja karta je %d %d\n",karta,znak);
		/*if(brojpoteza == 1)
		{
			if(randomkarta == karta || randomznak == znak)
			{
				printf("Izbacujem Kartu %d Znak %d",karta,znak);
				kartanavrhu=karta;
				znaknavrhu=znak;
				moja_poruka.tip=1;
				kartanavrhu=moja_poruka.pom[0].karta = kartanavrhu;
				znaknavrhu=moja_poruka.pom[0].znak = kartanavrhu;
				moja_poruka.tip=1;
				msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
			}
			else
			{
				printf("Nemam adekvatnu kartu\n");
				kartanavrhu=moja_poruka.pom[0].karta = randomkarta;
				znaknavrhu=moja_poruka.pom[0].znak = randomznak;
				moja_poruka.tip=1;
				msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
			}
		}
		else
		{
			msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),4,1);
			kartanavrhu=moja_poruka.pom[0].karta;
			znaknavrhu=moja_poruka.pom[0].znak;
			if(kartanavrhu == karta || znaknavrhu == znak)
			{
				printf("Izbacujem Kartu %d Znak %d",karta,znak);
				kartanavrhu=karta;
				znaknavrhu=znak;
				kartanavrhu=moja_poruka.pom[0].karta = kartanavrhu;
				znaknavrhu=moja_poruka.pom[0].znak = kartanavrhu;
				moja_poruka.tip=1;
				msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
			}
			else
			{
				printf("Nemam adekvatnu kartu\n");
				moja_poruka.tip=1;
				msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.pom),0);
			}
		}*/
		brojpoteza++;
		ind=semop(semid,&PocetakDrugog,1);
		sleep(5);
		if(ind == -1)
			break;
	}
	return 0;
}
