#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;
int shmid1;
int shmid2;
int shmid3;

int main(){
int broj=66;
	srand(time(NULL));
	key_t key1,key;
	union semun a;
	int i=1,ind,brojKarte,znakKarte;
	int *talonKarta,*talonZnak,*smer;
	char imeZnaka[10];
	struct sembuf p,v1,v2;
	key1=ftok("./igrac1.c",broj);
	
	semid=semget(key1,4,0666|IPC_CREAT|IPC_EXCL);
		
	key=ftok("./igrac2.c",broj);
	shmid1=shmget(key,sizeof(int),0666|IPC_CREAT);
	key=ftok("./igrac3.c",broj);
	shmid2=shmget(key,sizeof(int),0666|IPC_CREAT);
	key=ftok("./igrac4.c",broj);
	shmid3=shmget(key,sizeof(int),0666|IPC_CREAT);
	
	if(semid!=-1){
		a.val=1;
		semctl(semid,0,SETVAL,a);
		a.val=0;
		semctl(semid,1,SETVAL,a);
		a.val=0;
		semctl(semid,2,SETVAL,a);
		a.val=0;
		semctl(semid,3,SETVAL,a);
		
	}
	else if(errno==EEXIST){
		semid=semget(key1,4,0);
	}
	else{
		printf("Greska!\n");
		exit(0);
	}
	
	talonKarta=(int *)shmat(shmid1,NULL,0);
	talonZnak=(int *)shmat(shmid2,NULL,0);
	smer=(int *)shmat(shmid3,NULL,0);
		
	p.sem_num=1;
	p.sem_op=-1;
	p.sem_flg=0;
	
	v1.sem_num=2;
	v1.sem_op=1;
	v1.sem_flg=0;
	
	v2.sem_num=0;
	v2.sem_op=1;
	v2.sem_flg=0;
	
	while(1){
		
	
		ind=semop(semid,&p,1);
		if(ind==-1) break;
	
		sleep(6);
		brojKarte=rand()%14+1;
		znakKarte=rand()%4; //0-herc 1-pik 2-karo 3-tref
		
		if(znakKarte==0)
			strcpy(imeZnaka,"herc");
		else if(znakKarte==1)
			strcpy(imeZnaka,"pik");
		else if(znakKarte==2)
			strcpy(imeZnaka,"karo");
		else if(znakKarte==3)
			strcpy(imeZnaka,"tref");
			
			
		printf("%d:   Igrac2: %d %s\n",i++,brojKarte,imeZnaka);
		if((*talonKarta)==brojKarte){
			(*talonZnak)=znakKarte;
			if(brojKarte==8) (*smer)*=-1;
		}
		else if((*talonZnak)==znakKarte){
			(*talonKarta)=brojKarte;
			if(brojKarte==8) (*smer)*=-1;
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
		}
		
		if((*talonZnak)==0)
			strcpy(imeZnaka,"herc");
		else if((*talonZnak)==1)
			strcpy(imeZnaka,"pik");
		else if((*talonZnak)==2)
			strcpy(imeZnaka,"karo");
		else if((*talonZnak)==3)
			strcpy(imeZnaka,"tref");
			
			
		
		printf("Trenutno na talonu %d %s\n___________________________\n",(*talonKarta),imeZnaka);
		
		if((*smer)==1){
			ind=semop(semid,&v1,1);
		}
		else if((*smer)==-1){
			ind=semop(semid,&v2,1);
		}
		if(ind==-1) break;
		
	}


}
