#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semnum{
	int val;
	struct semid_ds *buf;
	ushort *array;
};



int main(){
	key_t kljuc;
	union semnum operacija;
	struct sembuf povecaj,smanji,povecajsup;
	int semid,shmid,*vrednost;
	int karta,znak,pomznak,pomkarta,smer;
	
	kljuc=ftok("./igrac1.c",65);
	semid=semget(kljuc,4,0666 |IPC_CREAT | IPC_EXCL);
	
	if(semid != -1){
		printf("Semofor nije bio napravljen, ja sam ga napravio\n");
		operacija.val = 1;
		semctl(semid,0,SETVAL,operacija);
		operacija.val = 0;
		semctl(semid,1,SETVAL,operacija);
		semctl(semid,2,SETVAL,operacija);
		semctl(semid,3,SETVAL,operacija);
	}
	else{
		printf("Semofor je bio napravljen, ja sam se samo povezao\n");
		semid=semget(kljuc,4,0);	
	}
	
	kljuc=ftok("./igrac1.c",65);
	shmid = shmget(kljuc, 1024, 0644 | IPC_CREAT);
	
	vrednost= shmat(shmid, NULL, 0);
	
	povecaj.sem_num = 2;
	povecaj.sem_op = 1;
	povecaj.sem_flg = 0;
	
	povecajsup.sem_num = 0;
	povecajsup.sem_op = 1;
	povecajsup.sem_flg = 0;
	
	smanji.sem_num = 1;
	smanji.sem_op = -1;
	smanji.sem_flg = 0;
	
	srand(time(NULL));
	
	while(1){
		semop(semid,&smanji,1);
		
		karta=rand() %14;
		
		znak= rand() % 4;
		
		karta++;
		
		znak++;
		
		printf("Izvukao sam %d znaka %d\n",karta,znak);
		pomkarta = *vrednost;
		smer=pomkarta%10;
		pomkarta/=10;
		pomznak=pomkarta%10;
		pomkarta=pomkarta/10;
		if(pomznak== znak || pomkarta == karta){
			printf("Stavio sam kartu na talon \n");
			if(karta == 8){
				printf("I promenio sam smer \n");
				if(smer==1)
					smer--;
				else
					smer++;
			}
			karta=(karta*10+znak)*10+smer;
			*vrednost=karta;
		}
		
		sleep(4);
		
		if(smer==0)
			semop(semid,&povecaj,1);
		else
			semop(semid,&povecajsup,1);
	}
	
	
	
	
}
