#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;
void izbrisi_semafor(int sig)
{
	printf("Prekinut sam sa CTRL+C, brisem semafor!");

	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);

	printf("Zavrsavam!\n");
	exit(0);

}

struct imi_poruka
{
	long tip_poruke;
	char tekst_poruke[100];
	int broj;
};



int main()
{
	srand(time(NULL));

	key_t key;
	int shmid;
	int ind;

	int id_reda;
	key_t kljuc;

	kljuc = ftok("proba.txt",65);
	id_reda = msgget(kljuc,IPC_CREAT);
	struct imi_poruka moja_poruka;

	char niz[100][100];
	strcpy(niz[0],"karo");
	strcpy(niz[1],"pik");
	strcpy(niz[2],"tref");
	strcpy(niz[3],"herc");

	union semun operacije_nad_sem;
	struct sembuf opr_p, opr_v;

	key = ftok("text.txt",'A');
	shmid = shmget(key,sizeof(int),0666|IPC_CREAT);
	semid = semget(key,2,0666|IPC_CREAT|IPC_EXCL);
	moja_poruka.tip_poruke = 1;

	signal(SIGINT,izbrisi_semafor);

	int n = 6;
	int broj;
	int znak;

	if(semid != -1)
	{
		printf("Semafor nije bio kreiran, ja sam ga kreirao!\n");

		operacije_nad_sem.val = 0;
		semctl(semid,0,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,1,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,2,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,3,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,4,SETVAL,operacije_nad_sem);


	}
	else if(errno == EEXIST)
	{
		printf("Semafor je vec kreiran i inizicalizovan, ja se samo kacim\n");
		semid = semget(key,2,0);
	}
	else
	{
		printf("Neka druga greska!\n");
		exit(0);
	}

	opr_p.sem_num = 0;
	opr_p.sem_op = -1;
	opr_p.sem_flg = 0;				


	opr_v.sem_num = 4;
	opr_v.sem_op = 1;
	opr_v.sem_flg = 0;				


	while(n > 0)
	{
		ind = semop(semid,&opr_p,1);
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);

		if(ind == -1) break;
		broj = rand() % 14 + 1;
		znak = rand() % 4;
		printf("%d\n",broj );
		printf("%s\n",niz[znak] );
		ind = semop(semid,&opr_v,1);
		if(ind == -1) break;
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),5,0);
		if(strcmp(moja_poruka.tekst_poruke,"izbaci") != 0)
		{
			printf("%s\n",moja_poruka.tekst_poruke );			// ako je poslao izbaci (talon) ne stampaj nista,
																// inace stampaj "Nemam adekvatnu kartu!"
		}
		sleep(3);

		n--;
	}
}