#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

struct imi_poruka
{
	long tip_poruke;
	char tekst_poruke[100];
	int broj;
};


void izbrisi_semafor(int sig)
{
	printf("Prekinut sam sa CTRL+C, brisem semafor!");

	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);

	printf("Zavrsavam!\n");
	exit(0);

}



int main()
{
	srand(time(NULL));
	 key_t key;
	int shmid;
	int ind;
	int broj;
	int znak;
	int n = 6;
	key_t kljuc;
	int id_reda;
	char niz[100][100];
	strcpy(niz[0],"karo");
	strcpy(niz[1],"pik");
	strcpy(niz[2],"tref");
	strcpy(niz[3],"herc");

	kljuc = ftok("proba.txt",65);
	id_reda = msgget(kljuc,IPC_CREAT);
	struct imi_poruka moja_poruka;

	union semun operacije_nad_sem;
	struct sembuf opr_p, opr_v,opr_v1,opr_v2,opr_v3,opr_v4;

	key = ftok("text.txt",'A');
	shmid = shmget(key,sizeof(int),0666|IPC_CREAT);
	semid = semget(key,2,0666|IPC_CREAT|IPC_EXCL);

	signal(SIGINT,izbrisi_semafor);

	if(semid != -1)
	{
		printf("Semafor nije bio kreiran, ja sam ga kreirao!\n");

		operacije_nad_sem.val = 0;
		semctl(semid,0,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,1,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,2,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,3,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,4,SETVAL,operacije_nad_sem);
	}
	else if(errno == EEXIST)
	{
		printf("Semafor je vec kreiran i inizicalizovan, ja se samo kacim\n");
		semid = semget(key,2,0);
	}
	else
	{
		printf("Neka druga greska!\n");
		exit(0);
	}

	
	opr_p.sem_num = 4;
	opr_p.sem_op = -4;
	opr_p.sem_flg = 0;				// smanji CETVRTI za 1


	opr_v.sem_num = 0;
	opr_v.sem_op = 1;
	opr_v.sem_flg = 0;				// povecaj prvi za 1, da se napravi ponovni ciklus


	opr_v1.sem_num = 0;
	opr_v1.sem_op = 1;
	opr_v1.sem_flg = 0;


	opr_v2.sem_num = 1;
	opr_v2.sem_op = 1;
	opr_v2.sem_flg = 0;


	opr_v3.sem_num = 2;
	opr_v3.sem_op = 1;
	opr_v3.sem_flg = 0;

	opr_v4.sem_num = 3;
	opr_v4.sem_op = 1;
	opr_v4.sem_flg = 0;

	

	while( n > 0)
	{
		broj = rand() % 14 + 1;
		znak = rand() % 4;

		
		ind = semop(semid,&opr_p,1);
		if(ind == -1) break;

		ind = semop(semid,&opr_v1,1);
		ind = semop(semid,&opr_v2,1);
		ind = semop(semid,&opr_v3,1);
		ind = semop(semid,&opr_v4,1);

		

		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),1,0);



		if(broj == moja_poruka.broj || strcmp(moja_poruka.tekst_poruke,niz[znak]) == 0)
		{
			strcpy(moja_poruka.tekst_poruke,"izbaci");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}
		else
		{
			strcpy(moja_poruka.tekst_poruke,"Nemam adekvatnu kartu!");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}

		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),2,0);

		if(broj == moja_poruka.broj || strcmp(moja_poruka.tekst_poruke,niz[znak]) == 0)
		{
			strcpy(moja_poruka.tekst_poruke,"izbaci");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}
		else
		{
			strcpy(moja_poruka.tekst_poruke,"Nemam adekvatnu kartu!");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}


		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),3,0);

		if(broj == moja_poruka.broj || strcmp(moja_poruka.tekst_poruke,niz[znak]) == 0)
		{
			strcpy(moja_poruka.tekst_poruke,"izbaci");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}
		else
		{
			strcpy(moja_poruka.tekst_poruke,"Nemam adekvatnu kartu!");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),4,0);

		if(broj == moja_poruka.broj || strcmp(moja_poruka.tekst_poruke,niz[znak]) == 0)
		{
			strcpy(moja_poruka.tekst_poruke,"izbaci");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}
		else
		{
			strcpy(moja_poruka.tekst_poruke,"Nemam adekvatnu kartu!");
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		}

		n--;

	}

}