#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *arr;
};

typedef struct karta
{
	int br;
	int z;
	int osam;
}karta;

int main()
{
	key_t key;
	union semun arg;
	int semid;
	int shmid;
	time_t t;
	karta *pom;
	srand((unsigned)time(&t));
	
	/* pravljenje kljuca za dm */
	key = ftok("igrac.c", 'V');
	
	/* kacenje na dm */
	shmid = shmget(key, sizeof(int) * 3, 0644 | IPC_CREAT);
	
	/* pravljenje kljuca za semafore */
	key = ftok("igrac.c", 'B');
	
	/* pravljenje ili kacenje na semafore */
	semid = semget(key, 5, 0666 | IPC_CREAT);
	
	/* inicijalizacija semafora */
	arg.val = 1;
	semctl(semid, 0, SETVAL, arg); // na pocetku prvi semafor je otvoren
	arg.val = 0;
	semctl(semid, 1, SETVAL, arg); // svi ostali su zatvoreni
	semctl(semid, 2, SETVAL, arg);
	semctl(semid, 3, SETVAL, arg);
	semctl(semid, 4, SETVAL, arg);
	
	pom = shmat(shmid, NULL, 0);
	
	pom->br = rand()%15;
	if(pom->br == 0 || pom->br == 8) pom->br++;
	
	
	for(;;)
	{
		sleep(1);
		if(pom->z == 0) printf("pik ");
		if(pom->z == 1) printf("herc ");
		if(pom->z == 2) printf("karo ");
		if(pom->z == 3) printf("tref ");
		printf("%d\n",pom->br);
		
	}
}
