#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
union semun{
	int val;
	ushort *array;
	struct semid_ds *buf;
};
int main(){
	
	srand(time(NULL));
	
	struct sembuf P, V;
	union semun arg;
	key_t key;
	int semid;
	
	key=ftok("./igrac1.c",'A');
	semid=semget(key,2,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1){
		//inicijalizacija 
		arg.val=1;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);
	}
	else if(errno==EEXIST){
		semget(key,2,0);
	}
	else{
		printf("Greska\n");
		exit(0);
	}
	
	P.sem_num=0;
	P.sem_flg=0;
	P.sem_op=-3;
	
	V.sem_num=0;
	V.sem_flg=0;
	V.sem_op=+1;
	
	for(int i=0;i<6;i++){
		int karta=rand()%14;
		
		semop(semid,&P,1);
		printf("Karta broj %d: %d\n",i+1,karta);
		sleep(1);
		semop(semid,&V,1);
	}
	
	printf("IGRAC 3: Zavrsavam igru!\n");
	
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	
	return 0;
}
