#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

void prekidDete()
{
	printf("Dete nije moguce prekinuti!\n");
}

void signalHandler(int pid)
{
	printf("Proces roditelj se zavrsava\n");
	kill(pid,SIGKILL);
}

int main()
{
	int pid;
	int n;
	printf("Uneti N:");
	scanf("%d",&n);
	
	pid = fork();
	
	if(pid == -1)
	{
		printf("Greska!\n");
		exit(1);
	}
	else if(pid == 0) //dete
	{
		int i;
		int broj = rand()%5;
		for(i=1;i<n;i++)
		{
			if(i%2==1)
			{
				printf("D:%d\n",i);
				sleep(broj);
				signal(SIGINT,prekidDete);
			}
			
		}
	}
	else //roditelj
	{
		int i;
		int broj = rand()%5;
		for(i=1;i<n;i++)
			if(i%2==0)
			{ 
				printf("R:%d\n",i);
				sleep(broj);
			}
		signal(SIGINT,signalHandler);
	}
}
