#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct 
{
    long type;
    char data[100];
    int rbr;
}message;

int main() {
	key_t key;
	message my_msg;
    int qid, pom, N, count = 1;

    key = ftok("./server.c", 65);
    qid = msgget(key, IPC_CREAT|0666);

    printf("Ucitati broj N.\n");
    scanf("%d", &N);

    while(N % 2 != 0 && N <= 21){
        printf("Ucitati paran broj manji od 22.\n");
        scanf("%d\n", &N);
    }

    
    my_msg.type = 0;
    my_msg.rbr = 1;
    printf("%10ld\n", msgrcv(qid, &my_msg, sizeof(my_msg), 1, 0));
    //strcpy(my_msg.data, "\n"); 
    //msgsnd(qid, &my_msg, sizeof(my_msg), 1);
    printf("Poslata je poruka.\n");

    while(count <= N){

        my_msg.type = 0;
        my_msg.rbr = 0;

        // ID svakog klijenta je prvobitno 1
        pom = msgrcv(qid, &my_msg, sizeof(my_msg), 1, 0);
        
        printf("%d\n", pom);

        if(my_msg.rbr == -1){
            printf("Prijava klijenta je prepoznata.\n");
        }

        printf("Klijent je registrovan.\n");

        // Postavljamo na novi ID klijenta
        my_msg.type = count;
        msgsnd(qid, &my_msg, sizeof(my_msg), 1);
        printf("Klijentu je prosledjen id sa brojem %d.\n", count);
        count += 1;

    }

    return 0;
}
	
	
