#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive
int nizpidova[2];
int a;
int id_reda_kom,id_reda_info;
//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long tip;
	int rednibroj;
	int pid;
};

struct poruka_potez
{
	long tip;
	char tekst_poruke[20];
	int rednibroj;
	int pid;
};

struct poruka_partija
{
	long tip;
	int pid;
	int rednibroj;
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2) {
	struct poruka_potez pot;
	char rec[100];
	int duzina;
	//TODO :  primi poruku od klijenta 
	
	msgrcv(id_reda_kom,&pot,sizeof(pot),rbr1,0);
	
	strcpy(rec,pot.tekst_poruke);
	duzina=strlen(rec);
	
	sleep(1);
	
	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
		
		strcpy(pot.tekst_poruke,"pobeda");//ako ne ond \0
		
		msgsnd(id_reda_kom,&pot,sizeof(pot),0); //salje pobeda
		
		sleep(1);
		
		pot.tip=rbr2; //salje drugom izgubio
		strcpy(pot.tekst_poruke,"poraz");
		
		msgsnd(id_reda_info,&pot,sizeof(pot),0);
		
		struct poruka_partija pobednik;
		//TODO: Upisati u red partija redni broj pobednika
		
		pobednik.tip=pobednik.rednibroj=rbr1;
		
		//pobednik.pid=pot.pid;
		sleep(1);
		
		msgsnd(id_reda_info,&pobednik,sizeof(pobednik),0);
		
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		
		pot.tip=pot.rednibroj=rbr2;
		
		msgsnd(id_reda_kom,&pot,sizeof(pot),0);
		
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	int parni = 0;
	int neparni = 0;
	//int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	
	waitpid(nizpidova[0],&a,0);
	
	waitpid(nizpidova[1],&a,0);
	
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	
	while((msgrcv(id_reda_info,&pobednik,sizeof(pobednik),0,0)!=-1))
	{
		if(pobednik.rednibroj%2==1) //neparni
			neparni++;
		else
			parni++;	
	}
	
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(id_reda_kom, IPC_RMID, NULL);
	msgctl(id_reda_info, IPC_RMID, NULL);
	exit(0);
}

int main() {
	
	//key_t kljuc_reda_kom, kljuc_reda_info;
	struct poruka_prijava prijava1, prijava2;
	
	//struct poruka_potez poruka1,poruka2;
	
	//int rbr=0;
	//int stat;
	int rbr1=1, rbr2=2;
	
	//int nizpartija[20];
	
	/*kljuc_reda_kom=ftok("./klijent.c",1);
	

	
	if((id_reda_kom=msgget(kljuc_reda_kom,IPC_CREAT|0660)==-1))
	{
		printf("Greska prilikom kreiranja reda za kom\n");
		exit(1);
	}
	
	printf("Id reda kom: %d\n",id_reda_kom);
	
	sleep(1);
	
	kljuc_reda_info=ftok("./server.c",2);
	
	if((id_reda_info=msgget(kljuc_reda_info,IPC_CREAT|0660)==-1))
	{
		printf("Greska prilikom kreiranja reda za info\n");
		exit(1);
	}
	
	
	
	printf("Id reda info: %d\n",id_reda_info);*/
	
	key_t kljuc=ftok("./server.c",1);
	id_reda_kom=msgget(kljuc,IPC_CREAT|0660);
	
	printf("Id reda kom: %d\n",id_reda_kom);
	
	key_t kljuc_info=getpid();
	id_reda_info=msgget(kljuc_info,IPC_CREAT|0660);
	
	printf("Id reda kom: %d\n",id_reda_info);
	
	
	sleep(1);
	
	int pid,pid2;
	//int i=0;//brojac pidova
	
	sleep(5);
	
	while(1) {
		
		//prijava
		msgrcv(id_reda_kom,&prijava1,sizeof(prijava1),0,0); //cekam jednog
		
		prijava1.rednibroj=rbr1;
		
		msgsnd(id_reda_kom,&prijava1,sizeof(prijava1),0); //prosledjujem
		
		sleep(2);
		msgrcv(id_reda_kom,&prijava2,sizeof(prijava2),0,0); //cekam drugog
		
		prijava2.rednibroj=rbr2;
		
		msgsnd(id_reda_kom,&prijava2,sizeof(prijava2),0); //prosledjujem
		//zavrsena prijava
		
		pid=fork();
		
		if(pid==0) //dete(igrac)
		{
			signal(SIGINT,SIG_IGN);
			
			//msgrcv(id_reda_kom,&poruka1,sizeof(poruka1),rbr1,0);
			
			int x=proveri_rec(rbr1,rbr2);
			
			
			if(x==1)
				exit(0);
				
		}
		else if(pid==-1) //greska
		{
			printf("Greska dete\n");
			exit(1);
		}
		else //roditelj
		{
			nizpidova[0]=pid;
			
			pid2=fork();//drugo dete
			
			if(pid2==0) //dete
			{
				signal(SIGINT,SIG_IGN);
				
				//msgrcv(id_reda_kom,&poruka2,sizeof(poruka2),rbr2,0);
			
				int x=proveri_rec(rbr1,rbr2);
				
			if(x==1)
				exit(0);
			}
			else if(pid2==-1)
			{
				printf("Greska\n");
				exit(1);
			}
			nizpidova[1]=pid2;
			
			signal(SIGINT,sighandler);
			
		}
		
		//kraj prve runde
		rbr1+=2;
		rbr2+=2;
	}
	return 0;
}
// Ne zaboravite signale :) 
