#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct{
	long tip_poruke;
	int redni_broj;
	int pid;
	char tekst_poruke[100];
} PORUKE;

int main(){
	key_t kljuc;
	int id_reda;
	PORUKE poruka;
	
	kljuc = ftok("./server.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	poruka.tip_poruke = 1;
	poruka.pid = getpid();
	strcpy(poruka.tekst_poruke, "prijavljujem se\n");
	msgsnd(id_reda, &poruka, sizeof(poruka),0);
	
	msgrcv(id_reda, &poruka, sizeof(poruka), poruka.pid, 0);
	poruka.tip_poruke = poruka.redni_broj;
	
	kljuc = ftok("./klijent.c", 68);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	if (poruka.redni_broj % 2 == 1){
			printf("Unesite poruku:\n");
			fgets(poruka.tekst_poruke, sizeof(poruka.tekst_poruke), stdin);
			poruka.tip_poruke = poruka.redni_broj;
			msgsnd(id_reda, &poruka, sizeof(poruka), 0);
			poruka.redni_broj++;
			msgrcv(id_reda, &poruka, sizeof(poruka), poruka.redni_broj, 0);
			printf("Primljena poruka: %s\n", poruka.tekst_poruke);
	}
	else{
			poruka.redni_broj--;
			poruka.tip_poruke = poruka.redni_broj;
			msgrcv(id_reda, &poruka, sizeof(poruka), poruka.redni_broj, 0);
			printf("Primljena poruka: %s\n", poruka.tekst_poruke);
			printf("Unesite poruku:\n");
			fgets(poruka.tekst_poruke, sizeof(poruka.tekst_poruke), stdin);
			poruka.tip_poruke = poruka.redni_broj;
			msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	}
	return 0;
}
