#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

struct poruka {
	long tip_poruke;
	char tekst_poruke[100];
	int id;
};

struct prijava {
	long tip_poruke; // 3
	char tekst_poruke[100];
	int broj_prijava;
};

struct kraj {
	long tip_poruke; // 4
	char tekst_poruke[100];
};


int main() {
	key_t kljuc;
	struct poruka moja_poruka, poruka_klijenta, odgovor_klijenta;
	struct prijava moja_prijava;
	struct kraj kraj_prijave;
	int id_reda, n, i, rbr;
	char *c;
	
	kljuc = ftok("./klijent.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	moja_poruka.tip_poruke=2;
	
	msgrcv(id_reda, &moja_prijava, sizeof(moja_prijava), 3, 0);		
	n=moja_prijava.broj_prijava;
		
	for(i=1; i<=n; i++) {
		msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 1, 0);		
		printf("Klijent dobio ID: %d\n", i);
		
		msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
		sleep(4);		
	}
	
	kraj_prijave.tip_poruke = 4;
	strcpy(kraj_prijave.tekst_poruke, "\nSvi klijenti su dobili svoj ID\n");
	msgsnd(id_reda, &kraj_prijave, sizeof(kraj_prijave), 0);
	sleep(3);
	printf("\nPrijave su zavrsene i klijenti ce poceti sa razmenom poruka.\n");
	
	
	for(i=1; i<=n; i++) {
		printf("Poruka neparnog klijenta %d: ", i);
		fgets(poruka_klijenta.tekst_poruke,sizeof(poruka_klijenta.tekst_poruke),stdin);
		poruka_klijenta.tip_poruke=5;

		msgsnd(id_reda, &poruka_klijenta, sizeof(poruka_klijenta), 0);
		//-----
		msgrcv(id_reda, &poruka_klijenta, sizeof(poruka_klijenta), 5, 0);
		printf("Odgovor parnog klijenta %d na poruku neparnog %d: ", i*2, i);
		fgets(odgovor_klijenta.tekst_poruke,sizeof(odgovor_klijenta.tekst_poruke),stdin);
		odgovor_klijenta.tip_poruke=6;		
		sleep(2);
		i++;		
	}	
	
	
	
	return 0;
}
