#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

int x;

void signal_handler_dete (int sig)
{
	printf("Nije moguce prekinuti ovaj proces\n");
}

void signal_handler_roditelj (int sig)
{
	kill(x,SIGKILL);
	exit(0);
}

int main(void)
{
	int N,pom,i,rv;
	printf("Uneti broj N: ");
	scanf("%d",&N);
	pom = fork();
	if (pom == -1)
	{
		printf("Fork greska!\n");
		exit(0);
	}
	else if (pom == 0)  // Dete;
	{
		for (i = 1;i < N;i++)
		{
			signal(SIGINT,signal_handler_dete);
			printf("DETE:\n");
			if (i % 2 != 0)          
			{
				printf("%d\n",i);
				sleep(5);
			}
		}
		
	}
	else                // Roditelj;
	{
		x = pom;
		for (i = 1;i < N;i++)
		{
			signal(SIGINT,signal_handler_roditelj);
			printf("RODITELJ:\n");
			if (i % 2 == 0)
			{
				printf("%d\n",i);
				sleep(5);
			}
		}
		wait(&rv);
	}
}
