#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <wait.h>

void handler1(int n){
	printf("Nije moguce prekinuti samo proces dete!\n");
}

void handler2(int n){
	kill(getpid()+1, SIGKILL);
	kill(getpid()+2, SIGKILL);
	printf("Procesi roditelj i dete prekinuti.\n");
	exit(0);
}

int main(){
	pid_t pid;
	int i,n,rv;

	scanf("%d", &n);
	pid= fork();
	
	switch(pid){
		case -1:
			exit(0);
		case 0:
			signal(SIGINT, handler1);
			for(i=1;i<n;){
				printf("DETE: %d\n", i);
				sleep(rand()%3);
				i+=2;
			}
			return 0;

		default:
			signal(SIGINT, handler2);
			for(i=2;i<n;){
				printf("RODITELJ: %d\n", i);
				sleep(rand()%3);
				i+=2;
			}
	}
	return 0;
}
