#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

int brPartije = 1;
//TODO : Deklarisati potrebne globalne promenljive


//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long int tip;
	int pid;
	int broj;
	char tekst[30];
};

struct poruka_potez
{
	
};

struct poruka_partija
{
	long int tip;
	int broj;
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2,char *rec) {
//	struct poruka_potez pot;
	int duzina  =strlen(rec);
	//TODO :  primi poruku od klijenta 
	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		
		return 0; // partija još uvek traje
	}
}

void rhandler(int sig) {
	int parni = 0;
	int neparni = 0;
	int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	wait(NULL);
	key_t kljucInfo = ftok("./server.c",75);
	int idReda2 = msgget(kljucInfo,IPC_CREAT|0666);
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	i = msgrcv(idReda2,&pobednik,sizeof(pobednik),20,IPC_NOWAIT);
	while(i != -1){
		if(pobednik.broj %2 == 0)
			parni++;
		else 
			neparni++;
		i = msgrcv(idReda2,&pobednik,sizeof(pobednik),20,IPC_NOWAIT);
	}
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(idReda2, IPC_RMID, NULL);
//	msgctl(red_info_id, IPC_RMID, NULL);
	exit(0);
}

int main() {
	key_t kljucKom;//kljucInfo;
	kljucKom = ftok("./klijent.c",65);
	key_t kljucInfo = ftok("./server.c",75);
	int ind;
	int idReda1 = msgget(kljucKom,IPC_CREAT|0666);
	int idReda2 = msgget(kljucInfo,IPC_CREAT|0666);
	struct poruka_prijava prijava1,prijava2;
	pid_t pid;
	
	
	while(1){
		msgrcv(idReda1,&prijava1,sizeof(prijava1),1,0);
		ind  = proveri_rec(prijava1.broj,prijava2.broj,prijava1.tekst);
		printf("Prvi je %d\n",prijava1.pid);
		prijava1.tip = prijava1.pid;
		prijava1.broj = brPartije;
		msgsnd(idReda1,&prijava1,sizeof(prijava1),0);
		
		msgrcv(idReda1,&prijava2,sizeof(prijava2),1,0);
		printf("Drugi je %d\n",prijava2.pid);
		prijava2.tip = prijava2.pid;
		prijava2.broj = brPartije+1;
		msgsnd(idReda1,&prijava2,sizeof(prijava2),0);
		
		brPartije+=2;
		
		printf("Prvi je %d\n",prijava1.pid);
		
		if((pid = fork())==0){
			signal(SIGINT,SIG_IGN);
			printf("Dte\n");
			while(1){
				msgrcv(idReda1,&prijava1,sizeof(prijava1),2,0);
				ind = proveri_rec(prijava1.broj, prijava2.broj,prijava1.tekst);
				if(ind){
					struct poruka_partija pobednik;
					pobednik.tip = 20;
					pobednik.broj = prijava1.broj;
					msgsnd(idReda2,&pobednik,sizeof(pobednik),0);
					
					prijava2.tip = prijava2.pid;
					prijava2.broj = 200;
					msgsnd(idReda1,&prijava2,sizeof(prijava2),0);
					
					prijava1.tip = prijava1.pid;
					prijava1.broj = 300;
					msgsnd(idReda1,&prijava1,sizeof(prijava1),0);
					break;
				}
				
				printf("Prvi je poslao poruku %s\n",prijava1.tekst);
				strcpy(prijava2.tekst,prijava1.tekst);
				prijava2.tip = prijava2.pid;
				msgsnd(idReda1,&prijava2,sizeof(prijava2),0);
				msgrcv(idReda1,&prijava2,sizeof(prijava2),2,0);
				
				ind = proveri_rec(prijava2.broj, prijava1.broj,prijava2.tekst);
				if(ind){
					struct poruka_partija pobednik;
					pobednik.tip = 20;
					pobednik.broj = prijava2.broj;
					msgsnd(idReda2,&pobednik,sizeof(pobednik),0);
					
					prijava1.tip = prijava1.pid;
					prijava1.broj = 200;
					msgsnd(idReda1,&prijava1,sizeof(prijava1),0);
					
					prijava2.tip = prijava2.pid;
					prijava2.broj = 300;
					msgsnd(idReda1,&prijava2,sizeof(prijava2),0);
					break;
				}
				
				
				strcpy(prijava1.tekst,prijava2.tekst);
				prijava1.tip = prijava1.pid;
				printf("Drugi je poslao poruku %s\n",prijava2.tekst);
				msgsnd(idReda1,&prijava1,sizeof(prijava1),0);
				
			}
			exit(0);
		}
		else{
			printf("Roditelj\n");
			signal(SIGINT,rhandler);
			wait(NULL);
		}
	}
	return 0;
}
