#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>

pid_t pid;

void signal_handler1()
{
		kill(pid, SIGKILL);
		kill(getpid(), SIGKILL);
}

void signal_handler2()
{
		printf("Prekid nije moguc.\n");
		kill(getpid(), SIGCHLD);
}

int main()
{
	int n;
	int i;
	
	signal(SIGCHLD, SIG_IGN);
	
	scanf("%d", &n); //unosimo n
	
	pid = fork(); //kreiramo proces dete
	
	printf("PID: %d\n", pid);
	
	switch(pid)
	{
		case -1:
		{
				perror("Greska pri kreiranju novog procesa.\n");
				exit(1);
		}
		case 0:
		{
			signal(SIGINT, signal_handler2);
			printf("DETE: %d\n", getpid());
			i = 0;
			while(i < n)
			{
				printf("%d\n", i);
				i+= 2;
				sleep(rand() % 10);
			}
			break;
		}
			
		default:
		{
			signal(SIGINT, signal_handler1);
			printf("RODITELJ: %d\n", getpid());
			i = 1;
			while(i < n)
			{
				printf("%d\n", i);
				i+= 2;
				sleep(rand() % 10);
			}
			break;
		}
	}

	return 0;
}
