#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define tipPrijava 1
#define tipRazmenaPoruka 2

struct poruka_prijava
{
	long tip;
	char poruka[100];
	int brKlijenta;
	pid_t pidKlijenta;
};

int main(){	
	key_t kljuc;
	int idReda;
	int brojPrijavljenih = 0;
	int n = 1;
	
	kljuc = ftok("./server.c", 50);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	printf("pid klijent: %d\n", getpid());
	
	struct poruka_prijava prijava;
	prijava.tip = tipPrijava; 
	prijava.pidKlijenta = getpid();
	msgsnd(idReda, &prijava, sizeof(prijava), tipPrijava); 
	printf("Poslato!\n");
	struct poruka_prijava prihvacenaPrijava;
	msgrcv(idReda, &prihvacenaPrijava, sizeof(prihvacenaPrijava), getpid(), 0); 
	printf("Prihvacena prijava!\n");
}
