#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_KLIJENATA 21
#define tipPrijava 1
#define tipRazmenaPoruka 2

struct poruka_prijava
{
	long tip;
	char poruka[100];
	int brKlijenta;
	pid_t pidKlijenta;
};

int main(){	
	key_t kljuc;
	int idReda;
	int brojPrijavljenih = 0;
	int n = 1;
	
	kljuc = ftok("./server.c", 50);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	while(n%2!=0){
		printf("Unesi paran broj klijenata:");
		scanf("%d",&n);
	}
	

	
	while(brojPrijavljenih < n){
		struct poruka_prijava prijava;
		msgrcv(idReda, &prijava, sizeof(prijava), tipPrijava, 0); 
		brojPrijavljenih++;
		printf("Prijavljeno: %d\nPoslednji prijavljen pid: %d\n", brojPrijavljenih, prijava.pidKlijenta);
		struct poruka_prijava nazadKlijentu;
		nazadKlijentu.tip = tipPrijava;
		nazadKlijentu.brKlijenta = brojPrijavljenih;
		nazadKlijentu.pidKlijenta = prijava.pidKlijenta;
		
		msgsnd(idReda, &nazadKlijentu, sizeof(nazadKlijentu), prijava.pidKlijenta);
	}
	
	return 0;
}
