#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

struct poruka
{
	long tip; //jelica
	int pidd;
};

int rod_primljen_SIGINT=0;
void roditelj_signal_handler(int sig)
{
	rod_primljen_SIGINT=1;
}


void dete_signal_handler(int sig)
{
	printf("Prekid nije moguc.\n");
}


int main()
{
	key_t kljuc;
	int id_reda;
	
	struct poruka p;
	
	kljuc=ftok("./milicavucic52_2018.c",65);
	id_reda=msgget(kljuc,IPC_CREAT|0666);
	
	p.tip=1;
	srand(time(0));
	pid_t pid;
	int n,i;
	
	printf("Unesi n:\n");
	scanf("%d",&n);
	
	pid=fork();
	switch(pid)
	{
		case -1:
			perror("Greska\n");
			exit(-1);
		case 0:
			p.pidd=getpid();
			msgsnd(id_reda,&p,sizeof(p),0);
//			printf("Dete: moj pid je %d\n",getpid());
			signal(SIGINT,dete_signal_handler);
			for(i=0;i<n;i++)
				if(i%2==1)
					{
						printf("DETE %d\n",i);
						sleep(rand());
					}
			exit(0);
			
		default:
			msgrcv(id_reda,&p,sizeof(p),1,0);
			//Jelica
			printf("Ovde sam \n");
			pid_t piddd=p.pidd;
			signal(SIGINT,roditelj_signal_handler);
			if(rod_primljen_SIGINT==1)
			{
				kill(piddd,SIGKILL);
				return(0);
				
			}
			for(i=0;i<n;i++)
				if(i%2==0)
				{
					printf("RODITELJ: %d\n",i);
					sleep(rand());
				}
				
			
			
	}
	return 0;
}
