#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/wait.h>

#define MAX_PARTIJA 20
#define PUTANJA "./kostur-server.c"
#define PROJEKAT 10
#define MAX_IGRACA 10
#define MAX_TEKST 50
#define TACNO 1
#define NETACNO 0

int nk, nd;
long klijenti[MAX_IGRACA];
pid_t djeca[MAX_IGRACA];

typedef struct {
	long pid;
	char tekst[MAX_TEKST];
	int redniBroj, status;
} poruka;


int main(void) {
	poruka p, p0, p1;
	int red, i;
	pid_t pid;
	/* Broj klijenata, broj djece. */
	nk=nd=0;
	key_t kljuc=ftok(PUTANJA, PROJEKAT);
	red=msgget(kljuc, IPC_CREAT|0666);
	for(;;) {
		s: for(i=0; i<2; i++) {
			printf("Cekam prijavu br: %d\n", i);
			msgrcv(red, &p, sizeof(p), 0, 0);
			p.redniBroj=i;
			klijenti[nk]=p.pid;
			nk++;
			msgsnd(red, &p, sizeof(p), p.pid);
			printf("Prijava primljena.\n");
		}
		nd++;
		djeca[nd-1]=pid=fork();
		if(pid<0) {
			printf("Fork greska.\n");
			exit(1);
		}
		/* Dijete: */
		if(pid==0) {
			s1: signal(SIGINT, SIG_IGN);
			poruka p0;
			msgrcv(red, &p0, sizeof(p0), djeca[nd-1], 0);
			if(p0.status==NETACNO)
				goto s;
			else goto s1;
		} else {
			/* Roditelj: */
			s2: signal(SIGINT, SIG_IGN);
			poruka p1;
			msgrcv(red, &p1, sizeof(p1), getpid(), 0);
			if(p1.status==NETACNO)
				goto s;
			else goto s2;
		}
	}
	return 0;
}
