#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>


struct poruka{
    long tip;
    int id;
    pid_t pid;
    char text[50];
};


int main(){

    key_t kljuc;
    int id_reda;

    kljuc = ftok("./klijent.c", 1);

    id_reda = msgget(kljuc, IPC_CREAT|0666);

    struct poruka moja_poruka;
    moja_poruka.pid = getpid();
    moja_poruka.tip = 1;

    msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);

    moja_poruka.tip = moja_poruka.id;

    char s[50];

    if (moja_poruka.id % 2){
        fgets(s, sizeof(s), stdin);
        s[strlen(s)-1] = '\0';
        strcpy(moja_poruka.text, s);
        moja_poruka.tip = moja_poruka.id + 1;
        msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
        printf("Poslata poruka %s", s);


        msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.id, 0);
        printf("Primljena poruka %s", moja_poruka.text);
    }
    else{
        msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.id, 0);
        moja_poruka.id--;
        printf("Primljena poruka %s", moja_poruka.text);

        fgets(s, sizeof(s), stdin);
        s[strlen(s)-1] = '\0';
        strcpy(moja_poruka.text, s);
        moja_poruka.tip = moja_poruka.id - 1;
        msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
        printf("Poslata poruka %s", s);

    }

    return 0;
}
