#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct porukica{
	long tip;
	int redni_broj;
	char poruka[100];
}porukica;

int main(){
	
	key_t kljuc;
	int id_reda;
	porukica p;
	
	kljuc = ftok("./server.c",16);
	id_reda = msgget(kljuc,IPC_CREAT|0666);
	
	p.tip = 1;
	p.redni_broj = 0;
	
	msgsnd(id_reda,&p,sizeof(p),0);
	msgrcv(id_reda,&p,sizeof(p),1,0);
	
	printf("Redni broj: %d\n",p.redni_broj);
	
	if(p.redni_broj % 2 == 1){
		p.tip = (p.redni_broj)+1;
		scanf("%s",p.poruka);
		msgsnd(id_reda,&p,sizeof(p),0);
		msgrcv(id_reda,&p,sizeof(p),p.tip,0);
		printf("%s\n",p.poruka);
	}
	else{
		p.tip = p.redni_broj;
		msgrcv(id_reda,&p,sizeof(p),p.tip,0);
		printf("%s\n",p.poruka);
		scanf("%s",p.poruka);
		msgsnd(id_reda,&p,sizeof(p),0);
	}

	return 0;
}
