#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<sys/types.h>
#include<sys/msg.h>
#include<sys/ipc.h>
#include<signal.h>
#include<sys/wait.h>
#include<string.h>

typedef struct poruka
{
    long tip;
    int broj;
    char tekst[100];
}poruka;

int main()
{
    key_t kljuc;
    int id_reda;
    poruka mojaPoruka;
    int brPrijavljenih = 0;
    int n;

    kljuc = ftok("./server.c", 17);
    id_reda = msgget(kljuc, IPC_CREAT | 0666);
    printf("%d\n", id_reda);

    printf("Unesite N(paran broj, manji od 21):\n");
    scanf("%d", &n);

    while(brPrijavljenih < n)
    {
        brPrijavljenih++;
        printf("%d\n", brPrijavljenih);
        strcpy(mojaPoruka.tekst, "Prijava");
        mojaPoruka.tip = brPrijavljenih;
        msgsnd(id_reda, &mojaPoruka, sizeof(mojaPoruka), 0);
        sleep(2);
        msgrcv(id_reda, &mojaPoruka, sizeof(mojaPoruka), brPrijavljenih, 0);
        printf("Dobio sam broj: %d\n", mojaPoruka.broj);
    }


    printf("Prijava zavrsena\n");

    int i;
    getchar(); //zbog prethodnog unosa
    for(i=1; i<=n; i+=2)
    {
        printf("KLIJENT %d\n", i);
        printf("Unesi poruku:\n");
     
        fgets(mojaPoruka.tekst, sizeof(mojaPoruka.tekst), stdin);
        mojaPoruka.tip = i;
        mojaPoruka.tekst[strlen(mojaPoruka.tekst)-1] = '\0';
        
        msgsnd(id_reda, &mojaPoruka, sizeof(mojaPoruka), 0);
        printf("Klijent %d je poslao poruku: %s\n",i, mojaPoruka.tekst);

        printf("KLIJENT %d\n", i+1);
        msgrcv(id_reda, &mojaPoruka,sizeof(mojaPoruka), i, 0);
        printf("Klijent %d je primio poruku: %s\n", i+1, mojaPoruka.tekst);
        mojaPoruka.tip = i+1;
        printf("Unesi poruku:\n");
        fgets(mojaPoruka.tekst, sizeof(mojaPoruka.tekst), stdin);
        mojaPoruka.tekst[strlen(mojaPoruka.tekst)-1] = '\0';

        msgsnd(id_reda,&mojaPoruka, sizeof(mojaPoruka), 0);
         printf("Klijent %d je poslao poruku: %s\n", i+1, mojaPoruka.tekst);

        msgrcv(id_reda, &mojaPoruka,sizeof(mojaPoruka), i+1, 0);
        printf("Klijent %d je primio poruku: %s\n", i, mojaPoruka.tekst);

    }

    return 0;
}