#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

void signal_handler(int sig)
{
	printf("Prekid nije moguc!\n");
}

int main()
{
	int n,i;
	pid_t pid;
	
	scanf("%d",&n);
	
	pid = fork();
	signal(SIGINT,signal_handler);	
	switch(pid)
	{
		case -1:
			printf("Greska!");
			exit(1);	
		case 0:
			signal(SIGINT,signal_handler);	
			for(i=1;i<n;i++)
			{
				if(i%2==1)
				{
					printf("Dete ispisuje sve neparne brojeve, a to su: %d\n",i);
					sleep(rand()%10);
				}
			}
		case 1:
			for(i=1;i<n;i++)
			{
				if(i%2==0)
				{
					printf("Roditelj ispisuje sve parne brojeve, a to su: %d\n",i);
					sleep(rand()%10);
				}
			}
			exit(1);
	}
	
	
	return 0;
}
