
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

struct mojaPoruka
{
	long tip;
	char tekst[10];
	int podatak;
	int pid;
};

int main()
{
	int redniBroj;
	
	struct mojaPoruka poruka;
	poruka.tip = 1;
	poruka.pid = getpid();
	
	int idReda =  msgget( ftok("./server.c", 14), 0  );
	printf("POVEZUJEM SE NA RED SA ID: %d\n",idReda);
	// SALJEM PRIJAVU SERVERU
	msgsnd(idReda, &poruka, sizeof(poruka), 0);
	
	printf("POSLAO SAM PORUKU \n");
	int pidProcesa  = getpid();
	msgrcv(idReda, &poruka, sizeof(poruka),pidProcesa , 0);
	redniBroj = poruka.podatak;
	
	printf("REDNI BROJ KLIJENTA JE : %d\n", redniBroj);
	if( redniBroj %2 == 1 )
	{
		poruka.tip = redniBroj;
		printf("UNESI PORUKU\n");
		fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
		msgsnd(idReda, &poruka, sizeof(poruka), 0);
		
		msgrcv(idReda, &poruka, sizeof(poruka),redniBroj+1 , 0);
		
		printf("PRIMLJENA PORUKA : %s\n", poruka.tekst);
		
	}
	
	else 
	{
		msgrcv(idReda, &poruka, sizeof(poruka),redniBroj-1, 0);
		printf("PRIMLJENA PORUKA : %s\n", poruka.tekst);
		printf("UNESI PORUKU\n");
		fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
		poruka.tip = redniBroj;
		msgsnd(idReda, &poruka, sizeof(poruka), 0);
		
		
		
		
	}
	
	
	
}
