#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <errno.h>
#include <string.h>
#include <signal.h>

typedef struct _data1
{
    int pid;
    int id;
} Data1;

typedef struct _data2
{
    char word[20];
    int myPid;
    int id;
} Data2;

typedef struct _data_win 
{
    long tip;
    struct _data1 data;
} DataWin;

typedef struct _data_word
{
    long tip;
    Data2 data;
} DataWord;

int main()
{
    //signal(SIGINT, sigint_handler);
    key_t key = ftok("./win-data", 1);
    key_t key2 = ftok("./data-comm", 1);
    int id_queue = msgget(key, IPC_CREAT|0666);
    int id_queue2 = msgget(key, IPC_CREAT|0666);
    DataWin player;
    DataWord word;
    player.tip = 2;
    player.data.pid = getpid();
    player.data.id = 0;

    printf("Requestion to join\n");
    msgsnd(id_queue, &player, sizeof(player), 0);

    msgrcv(id_queue2, &word, sizeof(word), getpid(), 0);
    printf("My id %d\n", word.data.id);
    if(word.data.id%2 == 1)
    {
        printf("Enter starting word : ");
        fgets(word.data.word, sizeof(word.data.word), stdin);
        word.tip = word.data.myPid;
        printf("Sending word %s to %ld\n", word.data.word, word.tip);
        msgsnd(id_queue2, &word, sizeof(word), 0);
    }

    while(1)
    {
        if(word.data.id%2 == 1)
            msgrcv(id_queue2, &word, sizeof(word), getpid(), 0);
        printf("Enter next word : ");
        fgets(word.data.word, sizeof(word.data.word), stdin);
        printf("Sending word %s\n to %ld", word.data.word, word.tip);
        word.tip = word.data.myPid;
        msgsnd(id_queue2, &word, sizeof(word), 0);
        if(word.data.id%2 != 1)
            msgrcv(id_queue2, &word, sizeof(word), getpid(), 0);
    }
}