#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

pid_t pid;

void ispis_parnih(int n)
{
	int i;
	for(i=0;i<=n;i+=2)
	{
			printf("%d\t",i);
			sleep(rand()%4+1);
	}
	printf("\n");
}
void ispis_neparnih(int n)
{
	int i;
	for(i=1;i<=n;i+=2)
	{
			printf("%d\t",i);
			sleep(rand()%4+1);
	}
	printf("\n");
}

void signal_handle(int sig)
{
	if(pid==0)
	{
			printf("Prekid nije moguc!\n");
	}else
	{
			kill(pid,SIGKILL);
	}
	
}


int main(void)
{
	int n;
	scanf("%d",&n);
	signal(SIGINT,signal_handle);
	pid=fork();
		switch(pid)
		{
				case -1:
					printf("Greska pri forkovanju\n");
					exit(0);
				case 0:
					ispis_neparnih(n);
					break;
				default:
					ispis_parnih(n);
					break;
		}
	return 0;
}
