#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

//DETE stampa sa DESNE strane, RODITELJ sa LEVE;

void SignalHandler(int signal)
{
	printf("\nUhvacen signal SIGINT(D).\n");
	printf("Prekid nije moguc.\n");
}

void SignalHandler2(int signal)
{
	printf("\nUhvacen signal SIGINT(R).\n");

	pid_t pid;

	pid = getpid();
	pid += 1;

	printf("Ubijam dete!\n");
	kill(pid, SIGKILL);
	exit(0);
}

void main()
{
	pid_t pid;
	int n, pom1, pom2;

	printf("Uneti broj N: ");
	scanf("%d", &n);

	pid = fork();	

	if(pid == 0)
	{
		//printf(" Proces DETE.\n");		//Neparne brojeve;
		pom2 = n-1;

		while(pom2 > 0)
		{
			if(pom2 % 2 == 1)
				printf("D:	%d\n", pom2);
			--pom2;

			signal(SIGINT, SignalHandler);
			sleep(4);
		}

	}
	else if(pid == -1)
	{
		printf("Greska!\n");
		exit(0);
	}
	else
	{
		//printf("Proces RODITELJ.\n");		//Parne brojeve;
		pom1 = n-1;

		while(pom1 >= 0)
		{
			if(pom1 % 2 == 0)
				printf("R: %d\n", pom1);
			--pom1;

			signal(SIGINT, SignalHandler2);
			sleep(4);
		}

	}
}
