#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>


int pid;

void roditeljHandler(int sig)
{
    printf("RODITELJ:Prekidam\n");
    kill(pid, SIGKILL);
    exit(1);
}

void deteHandler(int sig)
{
    printf("DETE:Prekid nije moguc\n");
}

int main()
{
    int n;
    scanf("%d", &n);

    pid = fork();

    srand(time(0));

    switch(pid)
    {
        case 0:
            signal(SIGINT, deteHandler);
            for(int i=1; i<n; i+=2)
            {
                printf("DETE:%d\n", i);
                sleep(rand() % 5 + 1);
            }
        case -1:
            printf("greska\n");
        default:
            signal(SIGINT, roditeljHandler);
            for(int i=2; i<n; i+=2)
            {
                printf("RODITELJ:%d\n", i);
                sleep(rand() % 5 + 1);
            }
    }

}




